/*
*  AddrEditDlgs.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "AddrEditDlgs.h"
#include "AddressDlgs.h"
#include "fileman.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TAddrEditDlg *AddrEditDlg;
//---------------------------------------------------------------------------
bool __fastcall EditAddressesEtc(TStrings *Addresses, TStrings *Newsgroups, TForm *Owner)
{
   AnsiString cap;
   if (Newsgroups)cap = "Newsgroup Editor"; else
   if (Addresses) cap = "Address Editor";

   TAddrEditDlg *AEDlg = new TAddrEditDlg(Owner);
   AEDlg->ActiveControl = AEDlg->AddrMemo;
   if (!Addresses && Newsgroups)
   {
      AEDlg->NewsMemo->Lines->Text = Newsgroups->Text;
      AEDlg->PageControl1->ActivePage = AEDlg->NewsgroupTab;
      AEDlg->ActiveControl = AEDlg->NewsMemo;
      AEDlg->AddressTab->TabVisible = false;
   }
   if (!Newsgroups && Addresses)
   {
      AEDlg->AddrMemo->Lines->Text = Addresses->Text;
      AEDlg->PageControl1->ActivePage = AEDlg->AddressTab;
      AEDlg->NewsgroupTab->TabVisible = false;
   }
   AEDlg->AddrMemo->Modified = false;
   AEDlg->NewsMemo->Modified = false;
   AEDlg->Caption = cap;

   bool save=false;
   if (AEDlg->Execute())
   {
      if (Addresses && AEDlg->AddrMemo->Lines->Text!=Addresses->Text)
      {
         Addresses->Text = AEDlg->AddrMemo->Lines->Text;
         save = true;
      }
      if (Newsgroups && AEDlg->NewsMemo->Lines->Text!=Newsgroups->Text)
      {
         Newsgroups->Text = AEDlg->NewsMemo->Lines->Text;
         save = true;
      }
   }
   return save;
}
//---------------------------------------------------------------------------
bool __fastcall EditAddressesEtcOnly(TForm *Owner)
{
   bool edit=false;
   TAddrEditDlg *AEDlg = new TAddrEditDlg(Owner);
   AEDlg->Caption = "Address/Newsgroup Editor";
   AEDlg->ActiveControl = AEDlg->AddrMemo;
   GetAppData(AEDlg->AddrMemo->Lines,UserAddresses+PS+General);
   GetAppData(AEDlg->NewsMemo->Lines,UserAddresses+PS+Newsgroups);
   if (AEDlg->Execute() && AEDlg->SaveLists()) edit = true;
   delete AEDlg;
   return edit;
}
//---------------------------------------------------------------------------
__fastcall TAddrEditDlg::TAddrEditDlg(TComponent* Owner)
  : TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner);
   AddrMemo->Clear(); AddrMemo->Modified = false;
   NewsMemo->Clear(); NewsMemo->Modified = false;
}
//---------------------------------------------------------------------------
bool __fastcall TAddrEditDlg::Execute()
{
   ShowModal();
   return ModalResult==mrOk;
}
//---------------------------------------------------------------------------
bool __fastcall TAddrEditDlg::SaveLists()
{
   TStringList *lines = new TStringList(); lines->Sorted = true;
   if (AddrMemo->Modified)
   {
      lines->Clear(); lines->AddStrings(AddrMemo->Lines);
      PutAppData(UserAddresses+PS+General,lines);
      AddrMemo->Modified = false;
   }
   if (NewsMemo->Modified)
   {
      lines->Clear(); lines->AddStrings(NewsMemo->Lines);
      PutAppData(UserAddresses+PS+Newsgroups,lines);
      NewsMemo->Modified = false;
   }
   delete lines;
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TAddrEditDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel && (AddrMemo->Modified || NewsMemo->Modified))
   {
      switch (MsgBoxHwnd(Handle,
         "Your list has been modified.\n\nSave your changes?",
         "Confirm",MB_YESNOCANCEL))
      {
         case IDCANCEL: CanClose = false; break;
         case IDYES: SaveLists();
      }
   }
}
//---------------------------------------------------------------------------
