/*
*  AddressDlgs.h
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#ifndef AddressDlgsH
#define AddressDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ComCtrls.hpp>
#include "headman.h"
#include "MsgWins.h"
//---------------------------------------------------------------------------
bool __fastcall GetMailRecipients(TMessageWin *Msgwin);

class TAddressMan
{
public:
   int hdr;
   TForm *owner;
   TStrings *msg;
   TStringList *lines;
   THeaderManager *headers;
   __fastcall TAddressMan(TForm *Owner, TStrings *Msg);
   __fastcall~TAddressMan();
   void __fastcall Delete(AnsiString header, AnsiString line);
   void __fastcall Add(AnsiString header, AnsiString line);
   void __fastcall ReplaceHeader(AnsiString header, TStrings *lines);
   void __fastcall ClearHeader(AnsiString header);
   void __fastcall Header2ListBox(AnsiString header, TListBox *list);
   AnsiString __fastcall HeaderCommaText(AnsiString msgheader);
};

class TAddressDlg : public TForm
{
__published:	// IDE-managed Components
  TButton *OkBtn;
  TButton *CancelBtn;
  TPageControl *PageControl1;
  TTabSheet *TabSheet1;
  TPanel *Panel3;
  TListBox *AddrsList;
  TGroupBox *GroupBox1;
  TRadioButton *ToBtn;
  TRadioButton *CcBtn;
  TRadioButton *BcBtn;
  TTabSheet *TabSheet2;
  TPanel *Panel1;
  TListBox *GrpsList;
  TGroupBox *GroupBox2;
  TRadioButton *GroupsBtn;
  TButton *HelpBtn;
  TSpeedButton *EditAddrBtn;
  TSpeedButton *EditGrpsBtn;
	TLabel *Label1;
  void __fastcall ListBoxDblClick(TObject *Sender);
  void __fastcall EditAddrBtnClick(TObject *Sender);
  void __fastcall EditGrpsBtnClick(TObject *Sender);
  void __fastcall HelpBtnClick(TObject *Sender);
  void __fastcall ListBoxClick(TObject *Sender);
  void __fastcall HdrBtnClick(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
private:	// User declarations
public:		// User declarations
  TRichEdit *Ed;
  bool Modified;
  AnsiString Hdrname;
  TMessageWin *Msgwin;
  TStringList *Items;
  THeaderManager *Headman;
  TStringList *OrgHeaders;
  __fastcall TAddressDlg(TComponent* Owner);
  __fastcall virtual ~TAddressDlg();
  AnsiString __fastcall GetHeaderCommaText(AnsiString header);
  void __fastcall Header2ListBox(AnsiString header, TListBox *list);
  void __fastcall GetHeaderItems(AnsiString header, TStrings *items);
  void __fastcall ReplaceHeader(AnsiString header, TStrings *items);
  void __fastcall ClearSelected(TListBox *list);
  AnsiString __fastcall ChkdHeader();
  bool __fastcall DoingNewsgroups();
  bool __fastcall Execute();
};

const AnsiString Newsgroups = "Newsgroups";
const AnsiString General = "General";
//---------------------------------------------------------------------------
extern TAddressDlg *AddressDlg;
//---------------------------------------------------------------------------
#endif
