/*
*  BarredRemsDlgs.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "BarredRemsDlgs.h"
#include "CpkKeyWins2.h"
#include "mixmaster.h"
#include "HelpDlgs.h"
//#include "MsgBoxDlgs.h"
#include "FileMan.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TBarredRemsDlg *BarredRemsDlg;
//---------------------------------------------------------------------------
bool __fastcall CheckDeleteBarredMixmasterKeys()
{
   bool bar=false;
   TStringList *mixkeys = new TStringList();
   if (FileExists(mringtxt)) mixkeys->LoadFromFile(mringtxt);
   if (CheckDeleteBarredMixmasterKeys(mixkeys))
   {
      mixkeys->SaveToFile(mringtxt);
      bar = true;
   }
   delete mixkeys;
   return bar;
}
//---------------------------------------------------------------------------
bool __fastcall CheckDeleteBarredMixmasterKeys(TStrings *Keys)
{
   AnsiString line;
   bool modified=false;
   TStringList *bars = new TStringList();
   GetAppData(bars,"BarredMixmaster");
   for (int b=0; b<bars->Count; b++)
   {
      int k=0; while (k<Keys->Count)
      {
         if (Keys->Strings[k].LowerCase().Pos(bars->Strings[b].LowerCase())==1)
         {
            bool gotkey = false;
            while (k<Keys->Count)
            {
               line = Keys->Strings[k]; Keys->Delete(k);
               if (line=="-----End Mix Key-----")
                  gotkey = true;
               if (line.IsEmpty() && gotkey)
                  break;
               modified = true;
            }
         }
         k++;
      }
   }
   CheckDeleteBarredMixmasterType2(bars);

   delete bars;
   return modified;
}
//---------------------------------------------------------------------------
bool __fastcall CheckDeleteBarredMixmasterType2(TStrings *bars)
{
   AnsiString line;
   bool modified=false;
   TStringList *Type2 = new TStringList();
   if (FileExists(mtyp2txt)) Type2->LoadFromFile(mtyp2txt);
   for (int b=0; b<bars->Count; b++)
   {
      int t=0; while (t<Type2->Count)
      {
         if (Type2->Strings[t].LowerCase().Pos(bars->Strings[b].LowerCase())>0)
         {
            Type2->Delete(t);
            modified = true;
            break;
         }
         t++;
      }
   }
   if (modified) Type2->SaveToFile(mtyp2txt);
   delete Type2;
   return modified;
}
//---------------------------------------------------------------------------
bool __fastcall CheckDeleteBarredCypherpunkKeys()
{
   bool ok=false;
   TStringList *keys = new TStringList();
   if (FileExists(cringtxt)) keys->LoadFromFile(cringtxt);
   if (CheckDeleteBarredCypherpunkKeys(keys))
   {
     keys->SaveToFile(cringtxt);
     ok = true;
   }
   delete keys;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall CheckDeleteBarredCypherpunkKeys(TStrings *Keys)
{
   AnsiString bar;
   bool modified=false; int p;
   TStringList *bars = new TStringList();
   TCpkKeyList2 *keys = new TCpkKeyList2(Keys);
   GetAppData(bars,"BarredCypherpunk");
   int b=-1; while (++b<bars->Count)
   {
      bar = bars->Strings[b]; if ((p=bar.Pos(" "))>0) bar[p] = ',';
      int k=0; while(k<keys->Count)
      {
         if (keys->Strings[k].LowerCase().Pos(bar.LowerCase())==1)
         {
            keys->DeleteKey(k);
            modified = true;
            continue;
         }
         k++;
      }
   }
   if (modified)
   {
      Keys->Clear();
      keys->SaveToStrings(Keys);
   }
   delete keys;
   delete bars;
   return modified;
}
//---------------------------------------------------------------------------
bool __fastcall EditBarredCypherpunkRemailers(TForm *Owner)
{
   BarredRemsDlg = new TBarredRemsDlg(Owner,"Cypherpunk");
   BarredRemsDlg->Label1->Caption = "&List cpunk remailers you wish barred from use :";
   BarredRemsDlg->ShowModal();
   bool ok = BarredRemsDlg->ModalResult==mrOk;
   delete BarredRemsDlg;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall EditBarredMixmasterRemailers(TForm *Owner)
{
   BarredRemsDlg = new TBarredRemsDlg(Owner,"Mixmaster");
   BarredRemsDlg->Label1->Caption = "&List mix remailers you wish barred from use :";
   BarredRemsDlg->ShowModal();
   bool ok = BarredRemsDlg->ModalResult==mrOk;
   delete BarredRemsDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TBarredRemsDlg::TBarredRemsDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TBarredRemsDlg::TBarredRemsDlg(TComponent* Owner, char *caption)
   : TForm(Owner)
{
   cap = caption;
   CenterDialog(this,Owner);
   Caption = "Barred "+cap+" Remailers";
   GetAppData(Memo1->Lines,"Barred"+cap);
   if (!Memo1->Lines->Count)
   {
      //Memo1->Lines->Add("cracker remailer@gacracker.org");
      //Memo1->Lines->Add("bilgates bilgates@securenym.net");
      //Memo1->Lines->Add("nycrem nycrem@phreaker.net");
   }
   Memo1->Modified = false;
   Memo1->SelStart = 0;
}
//---------------------------------------------------------------------------
void __fastcall TBarredRemsDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (Memo1->Modified)
   {
      if (ModalResult==mrCancel)
      {
         switch (MsgDlg(this,
            s("Your list of barred remailers is modified.\n")+
            s("Save your changes?"),s("Confirm"),
            MB_YESNOCANCEL))
         {
            case IDCANCEL:
               CanClose = false;
            case IDNO:
               return;
         }
      }
      PutAppData("Barred"+cap,Memo1->Lines);
   }
}
//---------------------------------------------------------------------------
void __fastcall TBarredRemsDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp2("Remailer_Barred Remailers","Barred Remailers","");
}
//---------------------------------------------------------------------------
