/*
*  BrokeChnDlgs.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "BrokeChnDlgs.h"
#include "Mixmaster.h"
#include "HeadMan.h"
#include "HelpDlgs.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TBrokeChnDlg *BrokeChnDlg;
//---------------------------------------------------------------------------
bool __fastcall CheckBrokenChainDialog(TForm *Owner, AnsiString &Text)
{
   BrokeChnDlg = new TBrokeChnDlg(Owner);
   BrokeChnDlg->Msg->Lines->Text = Text;
   BrokeChnDlg->ShowModal();
   bool yes = BrokeChnDlg->ModalResult==mrYes;
   delete BrokeChnDlg;
   return yes;
}
//---------------------------------------------------------------------------
__fastcall TBrokeChnDlg::TBrokeChnDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,Owner);
   MessageBeep(MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TBrokeChnDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("RemailerChains","Broken Remailer Chains","");
}
//---------------------------------------------------------------------------
bool __fastcall GetBrokenMixChains(TStrings *ToStrings)
{
   ToStrings->Clear();
   if (FileExists(clisttxt))
   {
      TStringList *chains = new TStringList();
      chains->LoadFromFile(clisttxt);
      while (chains->Count && chains->Strings[0].Pos("Broken type-II remailer chains:")!=1)
         chains->Delete(0);
      if (chains->Count) chains->Delete(0);
      int pos; while (chains->Count && !chains->Strings[0].Trim().IsEmpty())
      {
         AnsiString chain = chains->Strings[0];
         while ((pos=chain.Pos("("))>0) chain.Delete(pos,1);
         while ((pos=chain.Pos(")"))>0) chain.Delete(pos,1);
         while ((pos=chain.Pos(" "))>0) chain[pos] = ',';
         ToStrings->Add(chain);
         chains->Delete(0);
      }
      delete chains;
   }
   return ToStrings->Count>0;
}
//---------------------------------------------------------------------------
bool __fastcall HasBrokenMixChain(TForm *Owner, TStrings *msg)
{
   bool has=false;
   TStringList *broken = new TStringList();
   GetBrokenMixChains(broken);
   THeaderManager *hm = new THeaderManager(msg);
   AnsiString rem1,rem2,broke,chaindat = ","+GetToken(0,hm->GetDat("Chain: "),";")+",";
   delete hm;

   TStringList *rems = new TStringList();
   for (int i=0; i<broken->Count; i++)
   {
      broke = broken->Strings[i];
      rem1 = GetToken(0,broke,",").LowerCase();
      rem2 = GetToken(1,broke,",").LowerCase();
      if (rem1=="*")
      {
         rems->CommaText = chaindat;
         TrimNulls(rems);
         if (rems->IndexOf(rem2)>0 && CheckBrokenChainDialog(Owner,
            s("The remailer chain you have specified contains a broken ")+
            s("link. Mail sent from ANY OTHER remailer, to '"+rem2+"' is likely ")+
            s("to fail to be delivered. Would you like to cancel this send and ")+
            s("reconsider your route?")))
         {
            has = true;
            break;
         }
         Snooze(100);
      }
      if (rem2=="*")
      {
         rems->CommaText = chaindat;
         TrimNulls(rems);
         int idx=rems->IndexOf(rem1);
         if (idx>=0 && idx<rems->Count-1 && CheckBrokenChainDialog(Owner,
            s("The remailer chain you have specified contains a broken ")+
            s("link. Mail sent from '"+rem1+"' to ANY OTHER remailer will ")+
            s("likely fail to be delivered. I suggest you cancel this ")+
            s("send and reconsider your route.")))
         {
            has = true;
            break;
         }
         Snooze(100);
      }
      if (rem1!="*" && rem2!="*" && chaindat.Pos(","+broke+",")>0)
      {
         if (CheckBrokenChainDialog(Owner,
            s("The remailer chain you have specified contains a broken link. Mail ")+
            s("sent from '"+rem1+"' to '"+rem2+"' will likely fail to be delivered. ")+
            s("I suggest you cancel this send and reconsider your route.")))
         {
            has = true;
            break;
         }
         Snooze(100);
      }
   }
   delete rems;
   delete broken;
   return has;
}
//---------------------------------------------------------------------------
bool __fastcall HasBrokenMixChainAfterEncrypt(TForm *Owner, AnsiString orgchain,
   TStrings *chains)
{
   bool has=false;
   AnsiString chaindat,broke;
   TStringList *broken = new TStringList();
   GetBrokenMixChains(broken);

   for (int i=0; i<broken->Count; i++)
   {
      broke = ","+broken->Strings[i].Trim()+",";
      for (int r=0; r<chains->Count; r++)
      {
         chaindat = ","+chains->Strings[r].Trim()+",";
         if (chaindat.Pos(broke)>0)// && orgchain.Pos(broke)==0)
         {
            if (CheckBrokenChainDialog(Owner,
               s("The remailer chain Mixmaster selected for you has a broken link. ")+
               s("Mail sent from '"+GetToken(0,broke,",")+"' to '"+GetToken(1,broke,",")+
               s("' will likely fail to be delivered. I suggest you cancel this ")+
               s("send and start again."))))
            {
               has = true;
               break;
            }
         }
      }
      if (has) break;
   }
   delete broken;
   return has;
}
//---------------------------------------------------------------------------
