/*
*  CpkKeyImpDlgs.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "CpkKeyImpDlgs.h"
#include "Cyberpunk.h"
#include "pgpfiles.h"
#include "helpdlgs.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TCpkKeyImpDlg *CpkKeyImpDlg;
const AnsiString CpkNoKeysFoundAtAll = "...NO KEYS FOUND AT ALL!";
const AnsiString CpkLoading = "Loading...";
//---------------------------------------------------------------------------
bool __fastcall ImportCypherpunkKeys(TForm *Owner, TCpkKeyList2 *keylist,
   TCpkKeyList2 *ImpKeys, TCpkKeyList2 *DupKeys, AnsiString &ImportDir)
{
   CpkKeyImpDlg = new TCpkKeyImpDlg(Owner,keylist,ImpKeys,DupKeys,ImportDir);
   CpkKeyImpDlg->ShowModal();
   bool ok = CpkKeyImpDlg->ModalResult==mrOk && (ImpKeys->Count || DupKeys->Count);
   delete CpkKeyImpDlg;
   return ok;
}
//---------------------------------------------------------------------------
// CpkKeyImptDlg
//---------------------------------------------------------------------------
__fastcall TCpkKeyImpDlg::TCpkKeyImpDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyImpDlg::TCpkKeyImpDlg(TComponent* Owner, TCpkKeyList2 *Keylist,
   TCpkKeyList2 *ImpKeys, TCpkKeyList2 *DupKeys, AnsiString &ImportDir)
   : TForm(Owner)
{
   CenterDialog(this);
   impdir = &ImportDir;
   OpenDialog->InitialDir = *impdir;
   OpenDialog->Filter = "Cypherpunk key files (*.asc)|*.asc|All files (*.*)|*.*";
   OpenDialog->DefaultExt = ".asc";
   OpenDialog->FileName = "";
   ComboBox1->Items->Text = "Import Keys to Pubring.asc";
   ComboBox1->ItemIndex = 0;
   keylist = Keylist;
   implist = ImpKeys;
   implist->Clear();
   duplist = DupKeys;
   duplist->Clear();
   dislist = new TCpkKeyList2();
   cap = Caption;
}
//---------------------------------------------------------------------------
__fastcall TCpkKeyImpDlg::~TCpkKeyImpDlg()
{
   delete dislist;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyImpDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   int i,p;
   if (ModalResult==mrCancel)
   {
      if (ImportBtn->Enabled)
      {
          switch (MsgBoxHwnd(Handle,
            "You have good new keys!  Save them now?","Confirm",MB_YESNOCANCEL))
          {
             case IDCANCEL: CanClose=false; return;
             case IDNO: return;
          }
      }
      else return;
   }

   if (ImportBtn->Enabled)
   {
      if (MsgBoxHwnd(Handle,"Import selected keys now?","Confirm",MB_OKCANCEL)==IDCANCEL)
      {
         CanClose = false;
         return;
      }
      Caption = "Importing...";
      i=0; while (i<implist->Count)
      {
         p=ListBox1->Items->IndexOf(implist->Strings[i]);
         if (p>=0 && !ListBox1->Selected[p]) implist->DeleteKey(i);
         else i++;
      }
      i=0; while (i<duplist->Count)
      {
         p=ListBox1->Items->IndexOf(duplist->Strings[i]);
         if (p>=0 && !ListBox1->Selected[p]) duplist->DeleteKey(i);
         else i++;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyImpDlg::ClipBtnClick(TObject *Sender)
{
   if (MsgBoxHwnd(Handle,"Import keys from the clipboard?","Confirm",MB_OKCANCEL)==IDOK)
   {
      RichEdit1->Clear();
      ListBox1->Clear();
      ListBox1->BringToFront();

      flash=0; Timer1->Enabled = true;
      TStringList *clip = new TStringList();
      clip->Text = CpkPasteFromClipboard();
      ImportKeys("Clipboard",clip->Text);
      Timer1->Enabled = false;

      if (RichEdit1->Lines->Count &&
          RichEdit1->Lines->Strings[0].Pos("Clipboard"+CpkNoKeysFoundAtAll)>0)
      {
         RichEdit1->Lines->Add("");
         RichEdit1->Lines->Add("Clipboard Contents--------------------------------------");
         RichEdit1->Lines->AddStrings(clip);
      }
      delete clip;
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyImpDlg::FileBtnClick(TObject *Sender)
{
   if (OpenDialog->Execute())
   {
      RichEdit1->Clear();
      ListBox1->Clear();
      ListBox1->BringToFront();

      flash=0; Timer1->Enabled = true;
      TStringList *keys = new TStringList();
      keys->LoadFromFile(OpenDialog->FileName);
      AnsiString filename=ExtractFileName(OpenDialog->FileName);
      ImportKeys(filename,keys->Text);
      Timer1->Enabled = false;

      if (RichEdit1->Lines->Count &&
          RichEdit1->Lines->Strings[0].Pos(CpkNoKeysFoundAtAll)>0)
      {
         RichEdit1->BringToFront();
         RichEdit1->Lines->Add("");
         RichEdit1->Lines->Add(filename+" Contents-----------------------------------------------");
         RichEdit1->Lines->AddStrings(keys);
      }
      delete keys;

     *impdir = ExtractFilePath(OpenDialog->FileName);
      OpenDialog->InitialDir = *impdir;
      ActiveControl = Panel1;
   }
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyImpDlg::ImportKeys(AnsiString Name, AnsiString Ascii)
{
   implist->Clear();
   duplist->Clear();
   RichEdit1->Clear();
   Caption = "Loading...";

   AnsiString s,keydesc,desc,keytext,orglines=Ascii;
   TStringList *key = new TStringList();
   TStringList *keys = new TStringList();
   ImportBtn->Enabled = false;

   keys->Text = Ascii;
   FixPgpBeginEndLines(keys);
   TCpkKeyList2 *newlist = new TCpkKeyList2(keys);

   SetRedraw(Panel1,0);
   for (int i=0; i<newlist->Count; i++)
   {
      bool dup=false;
      TCpkKey2 *cpkkey = newlist->Key(i);
      AnsiString keydesc = newlist->Strings[i];
      // is the key already present ?
      if (keylist->Find(keydesc,NULL))
      {
         dislist->AddKey(cpkkey);
         continue;
      }
      // No? Is the remailer shortname present ?
      for (int k=0; k<keylist->Count; k++)
      {
         if (cpkkey->name==keylist->Key(k)->name)
         {
            duplist->AddKey(cpkkey);
            dup = true;
            break;
         }
      }
      // this is a new key
      if (!dup)
         implist->AddKey(cpkkey);
   }

   ListBox1->Clear();
   if (implist->Count)
   {
      for (int i=0; i<implist->Count; i++)
         ListBox1->Items->Add(implist->KeyDescription(i));
   }
   if (duplist->Count)
   {
      for (int i=0; i<duplist->Count; i++)
         ListBox1->Items->Add(duplist->KeyDescription(i));
   }

   if (ListBox1->Items->Count)
   {
      for (int i=0; i<ListBox1->Items->Count; i++)
         ListBox1->Selected[i] = true;
      ImportBtn->Enabled = true;
      ListBox1->BringToFront();
      ListBox1->TopIndex = 0;
   }
   else if (dislist->Count) RichEdit1->Lines->Add(Name+"...NO NEW KEYS");
   else RichEdit1->Lines->Add(Name+CpkNoKeysFoundAtAll);

   while (flash<4) AppProcessMessages();
   Timer1->Enabled = false;

   if (!ImportBtn->Enabled)
   {
      RichEdit1->Enabled = true;
      RichEdit1->BringToFront();
   }

   int total=implist->Count+duplist->Count;
   Caption = cap+"..."+s(total)+" key"+(total==1?"":"s");
   SetRedraw(Panel1,1);
   delete keys;
   delete key;
   MyBeep(MB_OK);
}
/*
//---------------------------------------------------------------------------
void __fastcall TCpkKeyImptDlg1::ImportKeys(AnsiString Name, AnsiString Ascii)
{

   implist->Clear();
   duplist->Clear();
   RichEdit1->Clear();
   Caption = "";

   AnsiString s,cshort,curdesc,desc,keytext,orglines=Ascii;
   TStringList *key = new TStringList();
   TStringList *keys = new TStringList();
   ImportBtn->Enabled = false;

   keys->Text = Ascii;
   FixPgpBeginEndLines(keys);
   while (keys->Count && keys->Strings[0]!=BeginPgpPubKeyBlock)
      keys->Delete(0);
   while (keys->Count && keys->Strings[keys->Count-1]!=EndPgpPubKeyBlock)
      keys->Delete(keys->Count-1);

   CpkBlockToKeysFull(keys);

   SetRedraw(Panel1,0);
   while (CpkGetNextKey(desc,key,keys)) // in cyberpunk.cpp
   {
      //if (desc.Pos(NoNameYet)==1) continue;

      bool dis=false,dup=false;
      // is the key already in type2
      if (keylist->IndexOf(desc)>=0) //|| probs->IndexOf(desc)>=0)
      {
         dislist->AddKey(desc,key);
         dis = true;
         //discnt++;
      }
      // No? Is the remailer shortname in type2
      if (!dis)
      {
         cshort = GetToken(0,desc," ");
         for (int i=0; i<keylist->Count; i++)
         {
            if (cshort==GetToken(0,keylist->Strings[i]," "))
            {
               duplist->AddKey(desc,key);
               dup = true;
               //dupcnt++;
               break;
            }
         }
      }
      // if neither above this is a new key
      if (!dis && !dup)
      {
         implist->AddKey(desc,key);
         //newcnt++;
      }
   }

   ListBox1->Clear();
   if (implist->Count)
   {
      for (int i=0; i<implist->Count; i++)
         ListBox1->Items->Add(implist->Strings[i]);
   }
   if (duplist->Count)
   {
      for (int i=0; i<duplist->Count; i++)
         ListBox1->Items->Add(duplist->Strings[i]);
   }
   if (ListBox1->Items->Count)
   {
      for (int i=0; i<ListBox1->Items->Count; i++)
         ListBox1->Selected[i] = true;
      ImportBtn->Enabled = true;
      ListBox1->BringToFront();
      ListBox1->TopIndex = 0;
   }
   else if (dislist->Count) RichEdit1->Lines->Add(Name+"...NO NEW KEYS");
   else RichEdit1->Lines->Add(Name+CpkNoKeysFoundAtAll);

   while (flash<4) AppProcessMessages();
   Timer1->Enabled = false;

   if (!ImportBtn->Enabled)
   {
      RichEdit1->Enabled = true;
      RichEdit1->BringToFront();
   }

   int total=implist->Count+duplist->Count;
   Caption = cap+"..."+s(total)+" key"+(total==1?"":"s");
   SetRedraw(Panel1,1);
   delete keys;
   delete key;
   MyBeep(MB_OK);
}
*/
//---------------------------------------------------------------------------
void __fastcall TCpkKeyImpDlg::Timer1Timer(TObject *Sender)
{
   if (Caption.IsEmpty()) Caption = CpkLoading;
   else Caption = "";
   flash++;
}
//---------------------------------------------------------------------------
void __fastcall TCpkKeyImpDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("CypherpunkKeysImp","Cypherpunk PGP Keys","");
}
//---------------------------------------------------------------------------
