/*
*  Cyberpunk.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
#define _WINSOCKAPI_      // Prevent winsock.h from being included
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Cyberpunk.h"
#include "Mixmaster.h"
#include "RemailerDlgs.h"
#include "brokechndlgs.h"
#include "HeadMan.h"
#include "Pgpmail.h"
#include "PgpFiles.h"
#include "Fileman.h"
//#include "CpkKeyWins.h"
#include "global.h"
#include "view.h"

AnsiString cretbuf;
//---------------------------------------------------------------------------
bool __fastcall HasCpunk()
{
   return HasPgp;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkDir()
{
   return MixDir();
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkPublicRing()
{
   AnsiString name=CpkDir()+"pubring.asc";
   if (!FileExists(name))
   {
      MsgBox("Unable to locate cypherpunk public keyring!","Cypherpunk Error",MB_OK);
      return "";
   }
   return name;
}
//---------------------------------------------------------------------------
bool __fastcall GetBrokenCpunkChains(TStrings *ToStrings)
{
   ToStrings->Clear();
   if (FileExists(clisttxt))
   {
      TStringList *chains = new TStringList();
      chains->LoadFromFile(clisttxt);
      while (chains->Count && chains->Strings[0].Pos("Broken type-I remailer chains:")!=1)
         chains->Delete(0);
      if (chains->Count) chains->Delete(0);
      int pos; while (chains->Count && !chains->Strings[0].Trim().IsEmpty())
      {
         AnsiString chain = chains->Strings[0];
         while ((pos=chain.Pos("("))>0) chain.Delete(pos,1);
         while ((pos=chain.Pos(")"))>0) chain.Delete(pos,1);
         while ((pos=chain.Pos(" "))>0) chain[pos] = ',';
         ToStrings->Add(chain);
         chains->Delete(0);
      }
      delete chains;
   }
   return ToStrings->Count>0;
}
//---------------------------------------------------------------------------
bool __fastcall HasBrokenCpunkChain(TForm *Owner, TStrings *msg)
{
   bool has=false;
   TStringList *broken = new TStringList();
   GetBrokenMixChains(broken);
   THeaderManager *hm = new THeaderManager(msg);
   AnsiString rem1,rem2,broke,chaindat = ","+GetToken(0,hm->GetDat("Chain: "),";")+",";
   delete hm;

   TStringList *rems = new TStringList();
   for (int i=0; i<broken->Count; i++)
   {
      broke = broken->Strings[i];
      rem1 = GetToken(0,broke,",").LowerCase();
      rem2 = GetToken(1,broke,",").LowerCase();
      if (rem1=="*")
      {
         rems->CommaText = chaindat;
         TrimNulls(rems);
         if (rems->IndexOf(rem2)>0 && CheckBrokenChainDialog(Owner,
            s("The remailer chain you have specified contains a broken ")+
            s("link. Mail sent from ANY OTHER remailer, to '"+rem2+"' is likely ")+
            s("to fail to be delivered. Would you like to cancel this send and ")+
            s("reconsider your route?")))
         {
            has = true;
            break;
         }
         Snooze(100);
      }
      if (rem2=="*")
      {
         rems->CommaText = chaindat;
         TrimNulls(rems);
         int idx=rems->IndexOf(rem1);
         if (idx>=0 && idx<rems->Count-1 && CheckBrokenChainDialog(Owner,
            s("The remailer chain you have specified contains a broken ")+
            s("link. Mail sent from '"+rem1+"' to ANY OTHER remailer will ")+
            s("likely fail to be delivered. Would you like to cancel this ")+
            s("send and reconsider your route?")))
         {
            has = true;
            break;
         }
         Snooze(100);
      }
      if (rem1!="*" && rem2!="*" && chaindat.Pos(","+broke+",")>0)
      {
         if (CheckBrokenChainDialog(Owner,
            s("The remailer chain you have specified contains a broken link. Mail ")+
            s("sent from '"+rem1+"' to '"+rem2+"' will likely fail to be delivered. ")+
            s("Would you like to cancel this send and reconsider your route?")))
         {
            has = true;
            break;
         }
         Snooze(100);
      }
   }
   delete rems;
   delete broken;
   return has;
}
//---------------------------------------------------------------------------
bool __fastcall HasBrokenReplyBlockChain(TForm *Owner, AnsiString chaindat)
{
   bool has=false;
   TStringList *broken = new TStringList();
   GetBrokenMixChains(broken);

   AnsiString rem1,rem2,broke;
   TStringList *rems = new TStringList();
   for (int i=0; i<broken->Count; i++)
   {
      broke = broken->Strings[i];
      rem1 = GetToken(0,broke,",").LowerCase();
      rem2 = GetToken(1,broke,",").LowerCase();
      if (rem1=="*")
      {
         rems->CommaText = chaindat;
         TrimNulls(rems);
         if (rems->IndexOf(rem2)>0 && CheckBrokenChainDialog(Owner,
            s("The remailer chain you have specified contains a broken ")+
            s("link. Mail sent from ANY OTHER remailer, to '"+rem2+"' is likely ")+
            s("to fail to be delivered. Would you like to cancel this operation and ")+
            s("reconsider your route?")))
         {
            has = true;
            break;
         }
         Snooze(100);
      }
      if (rem2=="*")
      {
         rems->CommaText = chaindat;
         TrimNulls(rems);
         int idx=rems->IndexOf(rem1);
         if (idx>=0 && idx<rems->Count-1 && CheckBrokenChainDialog(Owner,
            s("The remailer chain you have specified contains a broken ")+
            s("link. Mail sent from '"+rem1+"' to ANY OTHER remailer will ")+
            s("likely fail to be delivered. Would you like to cancel this ")+
            s("operation and reconsider your route?")))
         {
            has = true;
            break;
         }
         Snooze(100);
      }
      if (rem1!="*" && rem2!="*" && chaindat.Pos(","+broke+",")>0)
      {
         if (CheckBrokenChainDialog(Owner,
            s("The remailer chain you have specified contains a broken link. Mail ")+
            s("sent from '"+rem1+"' to '"+rem2+"' will likely fail to be delivered. ")+
            s("Would you like to cancel this operation and reconsider your route?")))
         {
            has = true;
            break;
         }
         Snooze(100);
      }
   }
   delete rems;
   delete broken;
   return has;
}
//---------------------------------------------------------------------------
__fastcall TRemailerDoc::TRemailerDoc()
   : TStringList()
{
   Modified = OpenDoc = false;
}
//---------------------------------------------------------------------------
__fastcall TRemailerDoc::TRemailerDoc(AnsiString Docfile)
   : TStringList()
{
   if (FileExists(Docfile)) LoadFromFile(Docfile);
   Modified = OpenDoc = false;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkPasteFromClipboard()
{
   TMemo *m = new TMemo((TComponent*)NULL);
   m->Visible = false;
   m->Parent = AppMainForm;
   m->PasteFromClipboard();
   AnsiString paste = m->Lines->Text;
   delete m;
   return paste;
}
//---------------------------------------------------------------------------
bool __fastcall cpkdb_getnext(TStringList *key, TStrings *keylist)
{
   key->Clear();
   AnsiString keyline;
   while (keylist->Count && keylist->Strings[0].IsEmpty()) keylist->Delete(0);
   if (!keylist->Count) return false;

   while (keylist->Count)
   {
      keyline = keylist->Strings[0];
      key->Add(keyline); keylist->Delete(0);
      if (keyline==EndPgpPubKeyBlock)
         return true;
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall CpkSortKeys(TStrings *Keys)
{
   TStringList *out = new TStringList();
   TStringList *key = new TStringList();
   while (cpkdb_getnext(key,Keys))
   {
      TStringList *keylines = new TStringList();
      keylines->Text = key->Text;
      out->AddObject(keylines->Strings[0],keylines);
   }
   Keys->Clear();
   out->Sorted = true;
   for (int i=0; i<out->Count; i++)
   {
      TStrings *next = dynamic_cast<TStringList*>(out->Objects[i]);
      if (next) { Keys->AddStrings(next); Keys->Add(""); }
   }
   delete key;
   delete out;
}
//---------------------------------------------------------------------------
/*AnsiString __fastcall CpkPasteFromClipboard()
{
   TMemo *m = new TMemo((TComponent*)NULL);
   m->Visible = false;
   m->Parent = AppMainForm;
   m->PasteFromClipboard();
   AnsiString paste = m->Lines->Text;
   delete m;
   return paste;
}*/
//---------------------------------------------------------------------------
AnsiString __fastcall CpkKeyDesc(TStrings *key)
{
   AnsiString fld,shrt,user,keid,line=key->Count?key->Strings[0]:s("");
   shrt = GetToken(0,line," ");
   user = GetToken(1,line," ");
   keid = GetToken(2,line," ");
   return shrt+" "+user+" "+keid;
}
//---------------------------------------------------------------------------
AnsiString __fastcall CpkCrtDesc(AnsiString &keydesc)
{
   if (keydesc.Pos("  ")>0) return keydesc;
   AnsiString shrt,rest;
   shrt = GetToken(0,keydesc," ").LowerCase();
   rest = keydesc.SubString(shrt.Length()+1,256).Trim(); shrt += "            ";
   int len=10; if (shrt.SubString(1,1)=="#") len = 11;
   return shrt.SubString(1,len)+" "+rest;
}
//---------------------------------------------------------------------------
bool __fastcall CpkKeyDefinately(TStrings *ascii)
{
   int endkey=-1,beginkey=-1;
   for (int i=0; i<ascii->Count; i++)
   {
      if (ascii->Strings[i]==BeginPgpPubKeyBlock) beginkey = i; else
      if (ascii->Strings[i]==EndPgpPubKeyBlock)
      {
         endkey = i;
         break;
      }
   }
   return beginkey==2 && beginkey<endkey;
}
//---------------------------------------------------------------------------
bool __fastcall CpkGetNextKey(AnsiString &keydesc, TStrings *key, TStrings *keys)
{
   key->Clear();
   while (keys->Count)
   {
      while (keys->Count && !CpkRingLineOk(keys->Strings[0])) keys->Delete(0);
      if (keys->Count && CpkKeyDefinately(keys))
      {
         while (keys->Count)
         {
            AnsiString line=keys->Strings[0];
            key->Add(line); keys->Delete(0);
            if (line==EndPgpPubKeyBlock)
            {
               keydesc = CpkCrtDesc(CpkKeyDesc(key));
               return true;
            }
         }
         return false;
      }
   }
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall CpkRingLineOk(AnsiString &line)
{
   return GetParam(1,line," ").Pos("@")>0 && GetParam(2,line," ").Pos("0x")==1;
}
//---------------------------------------------------------------------------
bool __fastcall CpkListLineOk(AnsiString &wholeline)
{//0         1         2         3         4         5         6         7
 //012345678901234567890123456789012345678901234567890123456789012345678901
 //"redneck  config@redneck.gacracker.org     ###***##*###      :27 100.00%"
   int l=1; while (l<wholeline.Length() && wholeline[l]!=' ') l++;
   AnsiString line=wholeline.SubString(l,256).Trim();
   l=line.Length(); if (l<62) return false;
   bool ok = GetParam(0,line," ").Pos("@");
   if (ok) ok = line[l-10]==':';
   if (ok) ok = line[l-3]=='.';
   if (ok) ok = line[l]=='%';
 //sm(s(line[l])+"   "+s(l));
   return ok;
}
//---------------------------------------------------------------------------

