/*
*  DirBrow.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "DirBrow.h"
#include "Global.h"
#include <stdlib.h>
#include <dir.h>
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TBrowseDlg *BrowseDlg;
//---------------------------------------------------------------------------
AnsiString __fastcall GetDirectoryPath(TForm *Owner, AnsiString &FileToFindThere)
{
   BrowseDlg = new TBrowseDlg(Owner);
   BrowseDlg->FindFile = FileToFindThere;
   BrowseDlg->ShowModal();
   AnsiString path = BrowseDlg->ModalResult==mrCancel ? AnsiString("cancel"):BrowseDlg->path;
   delete BrowseDlg;
   return path.LowerCase();
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetAttachmentDirectory(TForm *Owner, AnsiString &InitialDir)
{
   AnsiString path;
   if (!InitialDir.IsEmpty() && !DirectoryExists(InitialDir))
   {
      switch(MsgDlg(Owner,
         s("The directory you have entered does not exist.\n")+
         s("Would you like it created?"),s("Confirm"),
         MB_YESNOCANCEL))
      {
         case IDYES:
            ForceDirectories(InitialDir);
            if (!DirectoryExists(InitialDir))
            {
               MsgDlg(Owner,
                  "Unable to create the specified directory!",
                  "Directory Error",MB_OK);
               InitialDir = "";
            }
            break;
         case IDNO: InitialDir = ""; break;
         default: return "";
      }
   }
   if (InitialDir.IsEmpty()) InitialDir = AppDir;

   BrowseDlg = new TBrowseDlg(Owner);
   BrowseDlg->FileListBox1->Mask = "*.*";
   BrowseDlg->DirectoryListBox1->Directory = InitialDir;
   BrowseDlg->FileListBox1->PopupMenu = BrowseDlg->PopupMenu1;
   BrowseDlg->ShowModal();
   if (BrowseDlg->ModalResult==mrOk)
      path = RemBS(BrowseDlg->path).LowerCase();
   delete BrowseDlg;
   return path;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetBackupDirectory(TForm *Owner, AnsiString &InitialDir)
{
   AnsiString path;
   BrowseDlg = new TBrowseDlg(Owner);
   BrowseDlg->FileListBox1->Mask = "*.dbc;*.pgp";
   BrowseDlg->DirectoryListBox1->Directory = InitialDir;
   BrowseDlg->FileListBox1->PopupMenu = BrowseDlg->PopupMenu1;
   BrowseDlg->ShowModal();
   if (BrowseDlg->ModalResult==mrOk)
      path = RemBS(BrowseDlg->path).LowerCase();
   delete BrowseDlg;
   return path;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetMixmasterPath(TForm *Owner)
{
   BrowseDlg = new TBrowseDlg(Owner);
   BrowseDlg->ShowModal();
   AnsiString path = BrowseDlg->ModalResult==mrCancel ? AnsiString("cancel"):BrowseDlg->path;
   delete BrowseDlg;
   return path.LowerCase();
}
//---------------------------------------------------------------------------
__fastcall TBrowseDlg::TBrowseDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,Owner);
   FindFile = "";
}
//---------------------------------------------------------------------------
void __fastcall TBrowseDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel) return;
   AnsiString dir = AddBS(DirectoryListBox1->Directory);
   if (!FindFile.IsEmpty() && !FileExists(dir+FindFile))
   {
      MsgBoxHwnd(Handle,"The file '"+FindFile+"' is not in the directory you have chosen.\nPlease select again.",
         "Invalid path", MB_OK);
      CanClose = false;
      return;
   }
   path = dir;
}
//---------------------------------------------------------------------------
void __fastcall TBrowseDlg::FormShow(TObject *Sender)
{
   if (DirectoryListBox1->Directory.IsEmpty())
       DirectoryListBox1->Directory = ExtractFilePath(Application->ExeName);
}
//---------------------------------------------------------------------------
void __fastcall TBrowseDlg::PopupMenu1Popup(TObject *Sender)
{
   PopDeleteItem->Enabled = FileListBox1->SelCount>0;
}
//---------------------------------------------------------------------------
void __fastcall TBrowseDlg::PopDeleteItemClick(TObject *Sender)
{
   if (FileListBox1->SelCount>0 && MsgBoxHwnd(Handle,"Delete the selected file(s)?","Confirm",MB_OKCANCEL))
   {
      int i=0; while (i<FileListBox1->Items->Count)
         if (FileListBox1->Selected[i])
         {
            DeleteFile(s(AddBS(DirectoryListBox1->Directory)+FileListBox1->Items->Strings[i]).c_str());
            FileListBox1->Items->Delete(i);
         }
         else i++;
   }
}
//---------------------------------------------------------------------------
