/*
*  DntAskDlgs.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "FileMan.h"
#include "DntAskDlgs.h"
//---------------------------------------------------------------------------
#pragma link "MsgBoxDlgs"
#pragma resource "*.dfm"
TDntAskDlg *DntAskDlg;
//---------------------------------------------------------------------------
int __fastcall DontShowAgainBox(TForm *Owner, AnsiString DontAskKey, AnsiString Message,
   AnsiString Caption, UINT Type)
{
   int result=0;
   TStringList *dontask = new TStringList();
   dontask->Sorted = true;
   GetAppData(dontask,APPDONTASKKEY);
   //dontask->Clear(); PutAppData(APPDONTASKKEY,dontask);
   if (dontask->Find(DontAskKey,NULL))
   {
      delete dontask;
      return IDOK;
   }
   DntAskDlg = new TDntAskDlg(Owner,Message,Caption,Type);
   //DntAskDlg->DontAskBox->Visible = true;
   DntAskDlg->ShowModal();
   switch (DntAskDlg->ModalResult)
   {
      case mrCancel: result = IDCANCEL; break;
      case mrYes: result = IDYES; break;
      case mrOk: result = IDOK; break;
      case mrNo: result = IDNO; break;
   }
   if (DntAskDlg->DontAskBox->Checked)
   {
      dontask->Add(DontAskKey);
      PutAppData(APPDONTASKKEY,dontask);
   }
   delete DntAskDlg;
   delete dontask;
   return result;
}
//---------------------------------------------------------------------------
int __fastcall DontShowFailedErrorCheck(TForm *Owner)
{
   int ret = DontShowAgainBox(Owner,"failederrorcheck",
      s("During this update, you downloaded 1 or more remailer docs that failed\n")+
      s("the QS error checking mechanism. This is not a big problem and is easy\n")+
      s("to fix.\n\n")+
      s("After you close this dialog, click on the 'Help' button below for complete\n")+
      s("instructions. If you have looked at this help before and found it lacking,\n")+
      s("please have a look now. I have improved the explanation and provide\n")+
      s("several solutions to choose from."),
      s("IMPORTANT: Failed Error Check"),
      MB_OK|MB_BING);
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall DontShowNoPop3HasInbox(TForm *Owner)
{
   int ret = DontShowAgainBox(Owner,"explaininboxwithoutpopornews",
      s("Hi! I wanted to explain the presence of the 'inbox' on the mailbox menu and\n")+
      s("QS main toolbar. This presence does not indicate you have POP3 capability.\n")+
      s("You must install the QSpop3 plugin for this. So, why an inbox if no incoming?\n")+
      s("mail? On the Clipboard menu you will find the item, 'Receive'. Using this feature\n")+
      s("you can import the occassional inbound message (from your regular email program)\n")+
      s("you might wish to reply to in QS. The message itself will be treated just as\n")+
      s("though it had been retrieved via POP3."),
      s("IMPORTANT Inbox Information"),
      MB_OK|MB_BING);
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall DontShowKeyChangeInfo(TForm *Owner)
{
   int ret = DontShowAgainBox(Owner,"explainnymkeychange",
      s("The nym key change message is a bit different that the other config messages.\n")+
      s("QS will present you with a list of PGP keys, and after you select a key, will modify\n")+
      s("the current nym profile by replacing the PGP key to that just chosen. At this point\n")+
      s("the key message will be created. A 'key change' is the only config message that\n")+
      s("causes the profile itself, to be modified. However, the modified profile is NOT saved\n")+
      s("to disk. This provides you with quite a bit of flexibility, but if you don't take this\n")+
      s("capability seriously, you could end up with a mismatch between your public key\n")+
      s("and the one the nymserver holds."),s(" IMPORTANT: Changing PGP Keys"),
      MB_OK|MB_BING);
   return ret;
}
// s("in the profile editor. The only portion required is the 10 digit keyid. For example\n")+
// s("0x96A88C43 is a PGP keyid looks like. QS will replace the ascii key blocks stored\n")+
// s("with the profile the next time the profile is saved. If you modify the PGP key in\n")+
// s("this manner, no config message will be created.\n"),
//---------------------------------------------------------------------------
int __fastcall DontShowDHDSSAgain(TForm *Owner)
{
   int ret = DontShowAgainBox(Owner,"explaindhdssnymkey",
      s("I see you have selected a DH/DSS PGP key for your nym. This may be a problem.\n")+
      s("At the time of the writing, 9-20-02, no working nymservers can accept these keys.   \n")+
      s("They use only the older style RSA keys. However, the nymserver program is in the\n")+
      s("process being rewritten to include the newer more secure DH/DSS keys. I imagine\n")+
      s("most nymserver's will adopt this updated version when tests are completed.\n\n")+
      s("If you know, for sure, the nymserver you've chosen does support the newer keys,\n")+
      s("then continue on. Otherwise, go back, make an RSA key, make sure it is 2048 bits\n")+
      s("or less, and start again."),
      s(" DH/DSS PGP Key Notice"),
      MB_OKCANCEL|MB_BING);
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall DontShowRSABitsAgain(TForm *Owner)
{
   int ret = DontShowAgainBox(Owner,"explainrsabitsnymkey",
      s("I see you have selected an RSA PGP key with 'bits' size more than 2048. This\n")+
      s("may be a problem.  At the time of this writing, 06/12/02,  no nymserver supports\n")+
      s("RSA keys larger than 2048.\n\n")+
      s("If you are sure the nymserver you selected will accept your key, then continue\n")+
      s("on. Otherwise, you'll need to go back and create a key conforming to the\n")+
      s("nymserver requirements."),
      s(" RSA PGP Key Notice"),
      MB_OKCANCEL|MB_BING);
   return ret;
}
//---------------------------------------------------------------------------
int __fastcall DontShowNeedsAddressAgain(TForm *Owner)
{
   int ret = DontShowAgainBox(Owner,"explainnymkeyneedsaddress",
      s("I have encountered a problem. Your nym key's userid must contain an email address. It\n")+
      s("does not need to be a valid address, but an address must be there. Why? When signing\n")+
      s("messages with your nym's secret key, mixmaster takes an email address from QS and\n")+
      s("places angle brackets ('<' and '>') on the ends and searches for this string of characters in\n")+
      s("the user ids of the secret keyring. There is no flexibility here. You must have a character\n")+
      s("string beginning with '<' followed by any number of characters, an '@' symbol, any number\n")+
      s("more characters, then '>'. No need to create a new key. Just change the userid or add\n")+
      s("a good one to the key and use that one. IMPORTANT: This requirement applies to keys\n")+
      s("on your Personal PGP keyring, as well.\n\n")+
      s("Here are 2 good userids:\n")+
      s("QuickSilver <quicksilver@nym.alias.net>\n")+
      s("<quicksilver@nym.alias.net>\n\n")+
      s("These 2 cannot be used:\n")+
      s("(quicksilver@skuz.net) QuickSilver\n")+
      s("quicksilver@skuz.net"),
      s(" Nym Key UserId Notice"),
      MB_OKCANCEL|MB_BING);
   return ret;
}
//---------------------------------------------------------------------------
__fastcall TDntAskDlg::TDntAskDlg(TComponent* Owner)
	: TMsgBoxDialog(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TDntAskDlg::TDntAskDlg(TComponent* Owner, AnsiString &message,
   AnsiString &caption, UINT type) : TMsgBoxDialog(Owner,message,caption,type)
{
}
//---------------------------------------------------------------------------
