/*
*  HttpProxyDlgs.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "HttpProxyDlgs.h"
#include "HelpDlgs.h"
#include "Fileman.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
THttpProxyDlg *HttpProxyDlg;
//---------------------------------------------------------------------------
bool __fastcall GetWebProxyInfo(TForm *Owner)
{
   HttpProxyDlg = new THttpProxyDlg(Owner);
   bool ok = HttpProxyDlg->Execute();
   delete HttpProxyDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall THttpProxyDlg::THttpProxyDlg(TComponent* Owner)
  : TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner); Top -= 10;
   ProxyPswdEdit->PasswordChar = '*';
   LoadProxy();
}
//---------------------------------------------------------------------------
void __fastcall THttpProxyDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("ProxyHTTP","Proxy Host","");
}
//---------------------------------------------------------------------------
bool __fastcall THttpProxyDlg::Execute()
{
   ShowModal();
   if (ModalResult==mrOk &&
      (ProxyHostEdit->Modified || ProxyHostEdit->Modified ||
       ProxyPswdEdit->Modified || ProxyUserEdit->Modified))
   {
      StoreProxy();
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall THttpProxyDlg::LoadProxy()
{
   TStringList *http = new TStringList();
   GetAppData(http,HttpInfo);
   ProxyHostEdit->Text = http->Values["ProxyHost"]; ProxyHostEdit->Modified = false;
   ProxyPortEdit->Text = http->Values["ProxyPort"]; ProxyPortEdit->Modified = false;
   ProxyPswdEdit->Text = http->Values["ProxyPswd"]; ProxyPswdEdit->Modified = false;
   ProxyUserEdit->Text = http->Values["ProxyUser"]; ProxyUserEdit->Modified = false;
   delete http;
}
//---------------------------------------------------------------------------
void __fastcall THttpProxyDlg::StoreProxy()
{
   TStringList *http = new TStringList();
   GetAppData(http,HttpInfo);
   http->Values["ProxyHost"] = ProxyHostEdit->Text;
   http->Values["ProxyPort"] = ProxyPortEdit->Text;
   http->Values["ProxyPswd"] = ProxyPswdEdit->Text;
   http->Values["ProxyUser"] = ProxyUserEdit->Text;
   PutAppData(HttpInfo,http);
   delete http;
}
//---------------------------------------------------------------------------
void __fastcall THttpProxyDlg::ProxyPswdBoxClick(TObject *Sender)
{
   ProxyPswdEdit->PasswordChar = ProxyPswdBox->Checked ? '*':'\0';
}
//---------------------------------------------------------------------------
