/*
*  MIMEmanDec.h
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#ifndef MIMEmanDecH
#define MIMEmanDecH

#include "MIMEman4.h"
//---------------------------------------------------------------------------
bool __fastcall ProcessMIMEMessage(TForm *Owner, TStrings *Message, AnsiString &AttachDir);

bool __fastcall DecodeMIMEAttachments(TForm *Owner, TStrings *Message, AnsiString &AttachDir);
bool __fastcall DeleteMIMEApplications(TStrings *Message);
bool __fastcall DeleteMIMEImages(TStrings *Message);
bool __fastcall DeleteMIMEAudios(TStrings *Message);
bool __fastcall DecodeMIMEMessage(TStrings *Message);

class TMIMEdecoder : public TObject
{
public:
   int status;
   char *buffer;
   TStrings *mime;
   bool ok,cancel;//,unknownencoding;
   TStrings *message;
   TStringList *parts,*output,*head,*contenthead,*boundary;
   AnsiString content,version,attachdir,errorstr,errormsg;
   TMIMEdlg *mimedlg;

   virtual __fastcall TMIMEdecoder(TStrings *Message);
   virtual __fastcall TMIMEdecoder(TMIMEdlg *MimeDlg, TStrings *Message, AnsiString &AttachDir);
   virtual __fastcall~TMIMEdecoder();

   AnsiString __fastcall GetMIMEVersion();
   AnsiString __fastcall GetMIMEContent();
   AnsiString __fastcall GetPrimeMIMEContent();

   bool __fastcall DecodeMessage();
   bool __fastcall DecodeFirstPart();
   bool __fastcall DecodeNextPart(AnsiString &boundary);
   bool __fastcall DecodeAttachments();
   bool __fastcall DeleteType(AnsiString &contenttype);
   bool __fastcall DeleteImages();
   bool __fastcall DeleteAudios();
   bool __fastcall DecodeFinish();

   bool __fastcall DecodeBase64Line(AnsiString &line, TStream *stream);
   int  __fastcall DecodeBase64Line(char *line);
   bool __fastcall DecodeUUencodeLine(AnsiString &line, TStream *stream);
   int  __fastcall DecodeUUencodeLine(char *line);
   bool __fastcall DecodeQuotedPrintableLine(AnsiString &line, TStream *stream);
   int  __fastcall DecodeQuotedPrintableLine(char *Line);
   bool __fastcall DecodeUncodedLine(AnsiString &line, TStream *stream);

   void __fastcall ShowProgress(double position);
   bool __fastcall SeekBoundary(AnsiString &boundary);
   int  __fastcall GetPartSize(int start, AnsiString &boundary);
   int  __fastcall GetAttachmentSize(int start, AnsiString &boundary);
   void __fastcall SetAttachedHeader(AnsiString &attached, TStrings *headers);
   AnsiString __fastcall GetValidUniqueFilename(AnsiString &filename);
   bool __fastcall ConstructMessage();

   bool __fastcall IsAttachment(AnsiString &contentline);
   AnsiString __fastcall AttachmentFilename(AnsiString &contentline);
   AnsiString __fastcall ContentBoundary(AnsiString &contentline);
   AnsiString __fastcall ContentEncoding(AnsiString &contentline);
   AnsiString __fastcall ContentType(AnsiString &contentline);
   AnsiString __fastcall GetContent(AnsiString &field);
};

//---------------------------------------------------------------------------
#endif
