/*
*  MIMEmanEnc.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <sys\stat.h>
#include <math.h>
#pragma hdrstop

#include "MIMEmanEnc.h"
#include "MIMEman4.h"
#include "global.h"

TMIMEencoder *MIMEencoder;
const AnsiString EncodingAttachments = "Encoding Attachment";
//---------------------------------------------------------------------------
bool __fastcall EncodeMIMEAttachments(TForm *Owner, TStrings *Message)
{
   if (!HasAttachments(Message))
   {
      BingBox(Owner,"No attachments. Nothing to encode!","MIME Error",MB_OK);
      return true;
   }
   MIMEdlg = new TMIMEdlg(Owner,EncodingAttachments);
   MIMEencoder = new TMIMEencoder(MIMEdlg,Message);
   bool ok = MIMEdlg->EncodeAttachments(MIMEencoder)==mrOk;
   delete MIMEencoder;
   delete MIMEdlg;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall EncodeMIMEAttachments4PGP(TForm *Owner, TStrings *Message)
{
   bool ok=EncodeMIMEAttachments(Owner,Message);
   if (!ok) return ok;

   TStringList *mimehdrs = new TStringList();
   for (int i=0; i<Message->Count; i++)
   {
      AnsiString line = Message->Strings[i];
      if (line.IsEmpty()) // end of headers ?
      {
         int h=-1; while(++h<mimehdrs->Count) // add mimehdrs to body of message
            Message->Insert(1+i+h,mimehdrs->Strings[h]);
         Message->Delete(1+i+h);
         break;
      }
      if (line.Pos("MIME-Version: 1.0")==1) // gather mime headers
      {
         mimehdrs->Add(line); Message->Delete(i);
         while(i<Message->Count &&
           (line=Message->Strings[i]).Pos("Content-Type") || line.Pos("\t")==1)
         {
            mimehdrs->Add(line); Message->Delete(i);
         }
      }
   }
   delete mimehdrs;
   return ok;
}
//---------------------------------------------------------------------------
/*AnsiString __fastcall Base64EncodeLine(AnsiString line)
{
   const char Base64Chars[] =
   {
    'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
    'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
    'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
    'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/', '='
   };

   char DataIn[3];
   char DataOut[81];
   AnsiString encodedline;
   int i,Count=0,BytesRd,InBytes=sizeof(DataIn);

   TMemoryStream *f = new TMemoryStream();
   f->Write(line.c_str(), line.Length());
   f->Position = 0;

   while (true)
   {
      BytesRd=f->Read(DataIn,InBytes);
      for (i=1; i<4; i++) DataOut[Count+i]=0x40;

      DataOut[Count]   = char((DataIn[0] & 0xFC) >> 2);
      DataOut[Count+1] = char((DataIn[0] & 0x03) << 4);
      if (BytesRd>1)
      {
         DataOut[Count+1] += char((DataIn[1] & 0xF0) >> 4);
         DataOut[Count+2]  = char((DataIn[1] & 0x0F) << 2);
         if (BytesRd>2)
         {
            DataOut[Count+2] += char((DataIn[2] & 0xC0) >> 6);
            DataOut[Count+3]  =  char(DataIn[2] & 0x3F);
         }
      }

      for (i=0; i<4; i++) DataOut[Count+i] = byte(Base64Chars[DataOut[Count+i]]);
      Count += 4; if (Count<60 && BytesRd==InBytes) continue;

      DataOut[Count] = '\0';

      encodedline += AnsiString(&DataOut[0]);

      if (BytesRd<InBytes) break;
      Count=0;
   }
   delete f;
   return encodedline;
}*/
//---------------------------------------------------------------------------
// TMIMEencoder
//---------------------------------------------------------------------------
__fastcall TMIMEencoder::TMIMEencoder(TMIMEdlg *MimeDlg, TStrings *message)
{
   status = statMimeOk; ok = true;
   Inlines = new TStringList();
   Filenames = new TStringList();
   Message = message;
   mimedlg = MimeDlg;
   cancel = false;
}
//---------------------------------------------------------------------------
__fastcall TMIMEencoder::~TMIMEencoder()
{
   delete Filenames;
   delete Inlines;
}
//---------------------------------------------------------------------------
void __fastcall TMIMEencoder::DeleteHeader(AnsiString &Header)
{
   for (int i=0; i<Message->Count; i++)
   {
      AnsiString line = Message->Strings[i].Trim();
      if (line.Trim().IsEmpty()) break;
      if (Message->Strings[i].LowerCase().Pos(Header.LowerCase())==1)
      {
         Message->Delete(i);
         while (s(" \t").Pos(Message->Strings[i].SubString(1,1))==1)
            Message->Delete(i);
         break;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TMIMEencoder::ShowProgress(double position)
{
   if (mimedlg) mimedlg->ProgressBar->Position = position*100;
}
//---------------------------------------------------------------------------
int __fastcall TMIMEencoder::EOH()
{
   int eoh = Message->Count-1;
   for (int i=0; i<Message->Count; i++)
      if (Message->Strings[i].Trim().IsEmpty())
      {
         eoh = i;
         break;
      }
   if (eoh==Message->Count-1)
      Message->Add("");
   return eoh;
}
//---------------------------------------------------------------------------
int __fastcall TMIMEencoder::GetAttachmentNames()
{
   AnsiString attname,attline,line,item,filename;
   int i=-1; while(++i<Message->Count)
   {
      line = Message->Strings[i];
      if (line.Trim().IsEmpty()) break;
      if (line.LowerCase().Pos("attachment: ")==1)
      {
         Message->Delete(i);
         attline = line.Trim().SubString(13,1024);
         if (attline.SubString(attline.Length(),1)!=";") attline += ";";
         while(i<Message->Count)
         {
            line = Message->Strings[i];
            if (s(" \t").Pos(line.SubString(1,1))>0)
            {
               attline += line.Trim();
               if (attline.SubString(attline.Length(),1)!=";") attline += ";";
               Message->Delete(i);
               continue;
            }
            break;
         }
      }
   }
   if (attline.IsEmpty()) return 0;

   int pos,count=0;
   while ((pos=attline.Pos("\r"))>0) attline.Delete(pos,1);
   while ((pos=attline.Pos("\n"))>0) attline.Delete(pos,1);
   while ((pos=attline.Pos("\t"))>0) attline.Delete(pos,1);
   while ((pos=attline.Pos("\""))>0) attline.Delete(pos,1);
   while ((pos=attline.Pos(" ;"))>0) attline.Delete(pos,1);
   while ((pos=attline.Pos("; "))>0) attline.Delete(pos+1,1);
   while ((attname=GetToken(count++,attline,";").Trim())!="")
   {
      filename = GetToken(0,attname,",");
      if (!FileExists(filename))
      {
         if (MsgDlg(mimedlg,
            s("The file attachment \""+filename+"\" does not exist!\n\n")+
            s("Continue without?"),s("File Attachment Error"),
            MB_YESNO)==IDNO)
         {
            status = statMimeBadFilename;
            return 0;
         }
      }
      bool Inline=false;
      int i=0; while((item=GetToken(++i,attname,","))!="")
         if (item.Trim().LowerCase()=="body")
         {
            Inline = true;
            break;
         }

      if (Inline) Inlines->Add(attname);
      else Filenames->Add(attname);
   }
   DeleteHeader("Attachment: ");
   return count;
}
//---------------------------------------------------------------------------
bool __fastcall TMIMEencoder::AttachFilesInline(TStrings *filenames)
{
   ok = true; status = statMimeOk;
   TStrings *msg = Message;
   msg->BeginUpdate();
   TStringList *tail = new TStringList();
   TrimNullsAfter(msg);
   int idx = msg->IndexOf("~~");
   if (idx>0) while(idx<msg->Count)
   {
      tail->Add(msg->Strings[idx]);
      msg->Delete(idx);
   }
   TrimNullsAfter(msg); msg->Add("");
   for (int i=0; i<filenames->Count; i++)
   {
      ShowProgress(0);
      AppProcessMessages();
      AnsiString filename = filenames->Strings[i];
      AnsiString method=GetToken(1,filename,",");
      if (method=="x-uuencode") ok = AttachInlineUU(GetToken(0,filename,","),msg);
      else ok = AttachInlineBase64(GetToken(0,filename,","),msg);
      if (mimedlg)
      {
         ShowProgress(100);
         Snooze(300);
         ShowProgress(0);
         Snooze(300);
      }
      if (cancel || !ok)
      {
         msg->EndUpdate();
         delete msg;
      }
   }
   msg->AddStrings(tail);
   msg->EndUpdate();
   if (cancel)
   {
      status = statMimeCancel;
      return (ok=false);
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMIMEencoder::AttachInlineBase64(AnsiString &filename, TStrings* workmsg)
{
   workmsg->BeginUpdate();
   ok = true; status = statMimeOk;
   if (mimedlg) mimedlg->Filename->Caption = "File: "+filename;
   AnsiString justname = ExtractFileName(filename);
   workmsg->Add("Content-Type: "+GetContentType(justname)+"; name=\""+justname+"\"");
   workmsg->Add("Content-Disposition: attachment; filename=\""+justname+"\"");
   workmsg->Add("Content-Transfer-Encoding: base64");
   workmsg->Add("");
   Base64Encode(filename,workmsg);
   workmsg->Add("");
   workmsg->EndUpdate();
   if (cancel)
   {
      status = statMimeCancel;
      return (ok=false);
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMIMEencoder::AttachInlineUU(AnsiString &filename, TStrings* workmsg)
{
   workmsg->BeginUpdate();
   ok = true; status = statMimeOk;
   filename = GetToken(0,filename,",");
   AnsiString justname = ExtractFileName(filename);
   if (mimedlg) mimedlg->Filename->Caption = "File: "+filename;
   workmsg->Add("Content-Type: "+GetContentType(justname)+"; name=\""+justname+"\"");
   workmsg->Add("Content-Disposition: attachment; filename=\""+justname+"\"");
   workmsg->Add("Content-Transfer-Encoding: x-uuencode");
   workmsg->Add("");
   UUEncode(filename,workmsg);
   workmsg->Add("");
   workmsg->EndUpdate();
   if (cancel)
   {
      status = statMimeCancel;
      return (ok=false);
   }
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TMIMEencoder::EncodeAttachments()
{
   ok = true; status = statMimeOk;
   TStrings *msg = Message;
   int cutidx;
   if (!GetAttachmentNames() || status==statMimeBadFilename) return false;
   if ((cutidx=msg->IndexOf("~~"))>0) while(msg->Count>cutidx) msg->Delete(cutidx);
   if (Inlines->Count) ok=AttachFilesInline(Inlines);
   if (!ok)
   {
      if (mimedlg) mimedlg->ModalResult = mrCancel;
      return ok;
   }
   if (!Filenames->Count)
   {
      if (mimedlg) mimedlg->ModalResult = mrOk;
      return ok;
   }

   MimeBoundary = "==0000_MIME_Boundary_"+GetBoundaryNumberEx()+"==";
   DeleteHeader("MIME-Version: ");
   DeleteHeader("Content-Type: ");
   AnsiString line;
   int idx=-1; while(++idx<msg->Count)
   {
      line = msg->Strings[idx];
      if (line.IsEmpty()) break;
      if (line.LowerCase().Pos("from: ")==1) break;
   }
   msg->Insert(idx,"MIME-Version: 1.0");
   msg->Insert(++idx,"Content-Type: multipart/mixed;");
   msg->Insert(++idx,"\tboundary=\""+MimeBoundary+"\"");
   while(++idx<msg->Count && !msg->Strings[idx].Trim().IsEmpty())
      continue;

   msg->Insert(++idx,"This is a multipart MIME message.");
   msg->Insert(++idx,"");
   msg->Insert(++idx,"--" + MimeBoundary);
   msg->Insert(++idx,"Content-Type: text/plain; charset=\"iso-8859-1\"");
   msg->Insert(++idx,"Content-Transfer-Encoding: 7bit");
   msg->Insert(++idx,"");

   AnsiString fname,encodemethod;
   int i=-1; while(++i<Filenames->Count)
   {
      AppProcessMessages();
      line = GetToken(0,Filenames->Strings[i],";");
      fname = GetToken(0,line,",");
      encodemethod = GetToken(1,line,",").LowerCase();
      if (encodemethod.IsEmpty()) encodemethod = "base64";
      if (encodemethod=="uuencode") encodemethod = "x-uuencode";
      if (s(",base64,x-uuencode,").Pos(","+encodemethod+",")==0)
      {
         MsgDlg(mimedlg,
            s("The encode method, '"+encodemethod+"', specified is unknown to me\n")+
            s("It must be either 'base64' or 'x-uuencode'. Cancelling..."),
            s("Attach Method Unknown"),MB_OK);
         status = statMimeBadEncodeMethod;
         return (ok=false);
      }
      if (!FileExists(fname)) continue;
      //if (status==statMimeBadFilename)
      //{
      //   Display->Add("\r\n Error: "+fname+" does not exist!");
      //   //Display->Add(" Continuing with next email.");
      //   break;
      //}
      if (cancel) {
         status = statMimeCancel;
         return (ok=false);
      }
      AttachFile(fname,encodemethod);
   }
   if (status==statMimeOk)
   {
      msg->Add("");
      msg->Add("--"+MimeBoundary+"--");
      if (cutidx>0) msg->Add("~~");
   }

   if (mimedlg) mimedlg->ModalResult = cancel?mrCancel:mrOk;
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall TMIMEencoder::AttachFile(TFileName &Filename, AnsiString &encodemethod)
{
   ok = true; status = statMimeOk;
   while (Message->Count && Message->Strings[Message->Count-1].IsEmpty())
      Message->Delete(Message->Count-1);
   Message->Add("");
   AnsiString FileName    = ExtractFileName(Filename);
   Message->Add("--" + MimeBoundary);
   Message->Add("Content-Type: "+GetContentType(FileName)+"; name=\""+FileName+"\"");
   Message->Add("Content-Disposition: attachment; filename=\""+FileName+"\"");
   Message->Add("Content-Transfer-Encoding: "+encodemethod);
   Message->Add("");
   AppProcessMessages();
   if (encodemethod=="x-uuencode") UUEncode(Filename,Message);
   else Base64Encode(Filename,Message);
}
//---------------------------------------------------------------------------
// ENC is the basic 1 character encoding function to make a char printing
#define ENC(c) (((c) & 077) + ' ')
void __fastcall TMIMEencoder::UUEncode(AnsiString &filename, TStrings *msg)
{
   ok = true; status = statMimeOk;
   AppProcessMessages();
   if (cancel) {
      status = statMimeCancel;
      ok = false;
      return;
   }

   filename = GetToken(0,filename,",");
   FILE *f4stat = fopen(filename.c_str(),"r");
   if (!f4stat)
   {
      status = statMimeFileOpenError;
      ok = false;
      return;
   }
   struct stat sbuf;
   fstat(fileno(f4stat), &sbuf);
   fclose(f4stat);

   AnsiString justname=ExtractFileName(filename);
   if (mimedlg)
   {
      ShowProgress(0);
      mimedlg->Timer2->Enabled = false;
      mimedlg->Caption = "Encoding UU...";
      mimedlg->Filename->Caption = "File: "+filename.LowerCase();
   }
   msg->Add(s("begin ")+s(sbuf.st_mode & 0777)+s(" ")+justname);
   int i,n,l;
   char buf[80];
   AnsiString buffer;
   filename = GetToken(0,filename,",");
   TFileStream *f = new TFileStream(filename,fmOpenRead);
   while(true)
   {
      n = f->Read(buf,45);
	  buffer += (char)ENC(n);

      AppProcessMessages();
      ShowProgress((double)f->Position/(double)f->Size);
      AppProcessMessages();
	  for (i=0; i<n; i += 3)
      {
         AppProcessMessages();
         char *p = &buf[i];
	     buffer += (char)ENC(*p >> 2);
	     buffer += (char)ENC(((*p << 4) & 060) | ((p[1] >> 4) & 017));
	     buffer += (char)ENC(((p[1] << 2) & 074) | ((p[2] >> 6) & 03));
 	     buffer += (char)ENC(p[2] & 077);
      }

      AppProcessMessages();
      if (cancel) {
         status = statMimeCancel;
         ok = false;
         return;
      }

      l = buffer.Length();
      for (i=1; i<=l; i++)
         if (buffer[i]==' ') buffer[i] = '`';
	  msg->Add(buffer);
      buffer = "";

	  if (n <= 0)
         break;
   }
   msg->Add("end");
//view(msg);
   if (mimedlg) Snooze(300);
   delete f;
}
//---------------------------------------------------------------------------
void __fastcall TMIMEencoder::Base64Encode(AnsiString &Filename, TStrings *message)
{
   const char Base64Chars[] =
   {
    'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
    'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
    'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
    'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '+', '/', '='
   };

   AppProcessMessages();
   ok = true; status = statMimeOk;
   if (cancel) {
      status = statMimeCancel;
      ok = false;
      return;
   }

   char DataIn[3];
   char DataOut[81];
   if (mimedlg)
   {
      ShowProgress(0);
      mimedlg->Timer2->Enabled = false;
      mimedlg->Caption = "Encoding Base64...";
      mimedlg->Filename->Caption = "File: "+Filename.LowerCase();
   }
   int i,Count=0,BytesRd,InBytes=sizeof(DataIn);
   TFileStream *f = new TFileStream(Filename,fmOpenRead);
   if (!f)
   {
      status = statMimeFileOpenError;
      ok = false;
      return;
   }

   int c=-1;
   while (true)
   {
      BytesRd=f->Read(DataIn,InBytes);
      for (i=1; i<4; i++) DataOut[Count+i]=0x40;

      if (fmod(++c,20)==0) AppProcessMessages();
      ShowProgress((double)f->Position/(double)f->Size);

      DataOut[Count]   = char((DataIn[0] & 0xFC) >> 2);
      DataOut[Count+1] = char((DataIn[0] & 0x03) << 4);
      if (BytesRd>1)
      {
         DataOut[Count+1] += char((DataIn[1] & 0xF0) >> 4);
         DataOut[Count+2]  = char((DataIn[1] & 0x0F) << 2);
         if (BytesRd>2)
         {
            DataOut[Count+2] += char((DataIn[2] & 0xC0) >> 6);
            DataOut[Count+3]  =  char(DataIn[2] & 0x3F);
         }
      }

      for (i=0; i<4; i++) DataOut[Count+i] = byte(Base64Chars[DataOut[Count+i]]);
      Count += 4; if (Count<60 && BytesRd==InBytes) continue;

      if (cancel) {
         status = statMimeCancel;
         ok = false;
         delete f;
         return;
      }

      DataOut[Count] = '\0';
      message->Add(AnsiString(&DataOut[0]));

      if (BytesRd<InBytes) break;
      Count=0;
   }
   delete f;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMIMEencoder::GetContentType(AnsiString &Filename)
{
  AnsiString type,Ext = ExtractFileExt(Filename).UpperCase();
  if (Ext==".HTM" || Ext==".HTML") type = "text/html"; else
  if (Ext==".AU"  || Ext==".SND" ) type = "audio/basic"; else
  if (Ext==".AIF") type = "audio/aiff"; else
  if (Ext==".GIF") type = "image/gif"; else
  if (Ext==".JPG") type = "image/jpeg"; else
  if (Ext==".AVI") type = "video/avi"; else
  if (Ext==".RTF") type = "text/rtf"; else
  if (Ext==".TXT") type = "text/plain"; else
     type = "application/octet-stream";
  return type;
}
//---------------------------------------------------------------------------
