/*
*  MailboxDlgs.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MailboxDlgs.h"
#include "helpdlgs.h"
#include "MailboxWins.h"
#include "NewNameDlgs.h"
#include "global.h"
#include "fileman.h"
//---------------------------------------------------------------------------
#pragma link "OpenDlgs"
#pragma resource "*.dfm"
TMailboxDlg *MailboxDlg;
AnsiString caption="Open Mailbox";
AnsiString toolcap="Mailbox Menu Manager : select items to appear on menu";
//---------------------------------------------------------------------------
bool __fastcall OpenMailboxes()
{
   MailboxDlg = new TMailboxDlg(AppMainForm);
   MailboxDlg->Caption = caption;
   bool opened = MailboxDlg->Execute();
   delete MailboxDlg;
   return opened;
}
//---------------------------------------------------------------------------
__fastcall TMailboxDlg::TMailboxDlg(TComponent* Owner)
	: TOpenDlg(Owner)
{
   menumode = false;
   menuboxes = new TStringList();
   menuboxes->Sorted = false;
   LookinBox->ItemIndex = 0;
   Caption = caption;
   LoadMailboxes();
}
//---------------------------------------------------------------------------
__fastcall TMailboxDlg::~TMailboxDlg()
{
   AppMainForm->Perform(WM_LOADBOXMENU,0,0);
   delete menuboxes;
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::LoadMailboxes()
{
   ItemsBox->Clear();
   SetRedraw(ItemsBox,false);
   GetAppData(ItemsBox->Items,UserMailboxes);
   GetAppData(menuboxes,MailboxBoxmenu);
   int i=0; while (i<menuboxes->Count)
   {
      if (menuboxes->Strings[i].Trim().IsEmpty()) menuboxes->Delete(i);
      else i++;
   }
   if (!OnMailboxMenu("outbox")) menuboxes->Add("outbox");
   if (!OnMailboxMenu("inbox")) menuboxes->Add("inbox");
   SetRedraw(ItemsBox,true);
}
//---------------------------------------------------------------------------
bool __fastcall TMailboxDlg::DelFromMenu(AnsiString &Boxname)
{
   int pos=menuboxes->IndexOf(Boxname);
   if (pos>=0) menuboxes->Delete(pos);
   return pos>=0;
}
//---------------------------------------------------------------------------
bool __fastcall TMailboxDlg::OnMailboxMenu(AnsiString &Boxname)
{
   if (menuboxes->IndexOf("inbox")<0) menuboxes->Add("inbox");
   if (menuboxes->IndexOf("outbox")<0) menuboxes->Add("outbox");
   return menuboxes->IndexOf(Boxname)>=0;
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::SetSelected()
{
   for (int i=0; i<ItemsBox->Items->Count; i++)
      ItemsBox->Selected[i] =
         OnMailboxMenu(ItemsBox->Items->Strings[i]);
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::ClearSelected()
{
   for (int i=0; i<ItemsBox->Items->Count; i++)
      ItemsBox->Selected[i] = false;
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::SaveMailboxMenu()
{
   menuboxes->Clear();
   for (int i=0; i<ItemsBox->Items->Count; i++)
      if (ItemsBox->Selected[i])
         menuboxes->Add(ItemsBox->Items->Strings[i]);
   DelFromMenu("outbox");
   DelFromMenu("inbox");
   PutAppData(MailboxBoxmenu,menuboxes);
}
//---------------------------------------------------------------------------
bool __fastcall TMailboxDlg::MenuModified()
{
   AnsiString currboxes;
   for (int i=0; i<ItemsBox->Items->Count; i++)
      if (ItemsBox->Selected[i])
         currboxes += ItemsBox->Items->Strings[i]+"\r\n";
   return currboxes!=menuboxes->Text;
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::MenuBtnClick(TObject *Sender)
{ // if sender is null, action will take place but the menu will not be saved
   SetRedraw(ItemsBox,false);
   if (MenuBtn->Down)
   {
      int obox,ibox;
      CancelBtn->Caption = "Cancel";
      if ((ibox=ItemsBox->Items->IndexOf("inbox"))>=0)
         ItemsBox->Selected[ibox] = true;
      if ((obox=ItemsBox->Items->IndexOf("outbox"))>=0)
         ItemsBox->Selected[obox] = true;
      NewBoxBtn->Enabled = false;
      DelBoxBtn->Enabled = false;
      RenBoxBtn->Enabled = false;
      OkBtn->Enabled = false;
      OkBtn->Caption = "Done";
      Caption = toolcap;
      menumode = true;
      SetSelected();
   }
   else
   {
      if (Sender && MenuModified()) SaveMailboxMenu();
      CancelBtn->Caption = "Close";
      NewBoxBtn->Enabled = true;
      DelBoxBtn->Enabled = false;
      RenBoxBtn->Enabled = false;
      OkBtn->Enabled = true;
      OkBtn->Caption = "Ok";
      Caption = caption;
      menumode = false;
      ClearSelected();
   }
   ItemsBox->ItemIndex = ItemsBox->Items->Count<0 ? -1:0;
   ItemsBox->TopIndex = 0;
   ActiveControl = Panel1;
   SetRedraw(ItemsBox,true);
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (menumode)
   {
      if (!MenuModified())
      {
         MenuBtn->Down = false;
         MenuBtnClick(NULL);
         CanClose = false;
         return;
      }
      if (ModalResult==mrOk)
      {
         MenuBtn->Down = false;
         MenuBtnClick(MenuBtn);
         CanClose = false;
         return;
      }
      if (ModalResult==mrCancel)
      {
         CanClose = false;
         switch (MsgBoxHwnd(Handle,"Your Mailbox Menu has been modified.\n\nSave your changes?","Confirm",MB_YESNOCANCEL))
         {
            case IDYES:
               MenuBtn->Down = false;
               MenuBtnClick(MenuBtn);
               break;
            case IDNO:
               MenuBtn->Down = false;
               MenuBtnClick(NULL);
               break;
         }
      }
   }
   if (ModalResult==mrOk)
      for (int i=0; i<ItemsBox->Items->Count; i++)
         if (ItemsBox->Selected[i])
            OpenMailbox(ItemsBox->Items->Strings[i]);
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::ItemsBoxClick(TObject *Sender)
{
   AnsiString boxname=ItemsBox->Items->Strings[ItemsBox->ItemIndex];
   if (menumode)
   {
      int obox,ibox;
      if ((ibox=ItemsBox->Items->IndexOf("inbox"))>=0)
         ItemsBox->Selected[ibox] = true;
      if ((obox=ItemsBox->Items->IndexOf("outbox"))>=0)
         ItemsBox->Selected[obox] = true;
      if (boxname=="inbox" || boxname=="outbox")
      {
         MsgBoxHwnd(Handle,
            s("The '"+boxname+"' is a special box that will always appear in the\n")+
            s("upper portion of the mailbox menu. It cannot be removed."),
            s("Special Case"),
            MB_OK
         );
      }
   }
   if (!OkBtn->Enabled) OkBtn->Enabled = true;
   if (!menumode)
   {
      RenBoxBtn->Enabled = ItemsBox->SelCount==1;
      DelBoxBtn->Enabled = ItemsBox->SelCount>0;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::HelpBtnClick(TObject *Sender)
{
   AnsiString modename = menumode ? "Mailbox Menu":"Open Mailbox";
   OpenHelp("OpenMailbox","Open Mailbox Dialog",modename,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::PopupMenuPopup(TObject *Sender)
{
   int c=ItemsBox->SelCount;
   PopNewItem->Enabled = !menumode;
   PopDeleteItems->Enabled = !menumode && c>0;
   PopRenameItem->Enabled = !menumode && c==1;
   PopOpenItem->Enabled = !menumode && c>0;
   PopMenuManagerMode->Checked = menumode;
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::PopMenuManagerModeClick(TObject *Sender)
{
   PopMenuManagerMode->Checked = !PopMenuManagerMode->Checked;
   MenuBtn->Down = PopMenuManagerMode->Checked;
   MenuBtnClick(MenuBtn);
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::PopNewItemClick(TObject *Sender)
{
   if (menumode) return;
   AnsiString newname = CreateMailbox();
   if (!newname.IsEmpty())
   {
      OpenMailbox(newname); ItemsBox->Clear();
      Application->ProcessMessages(); Sleep(200);
      LoadMailboxes();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::PopOpenItemClick(TObject *Sender)
{
   ModalResult = mrOk;
   /*if (menumode) return;
   for (int i=0; i<ItemsBox->Items->Count; i++)
      if (ItemsBox->Selected[i])
         OpenMailbox(ItemsBox->Items->Strings[i]);
   Close();*/
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::PopDeleteItemsClick(TObject *Sender)
{
   if (menumode) return;
   if (LookinBox->Text==UserMailboxes)
   {
      AnsiString pl = ItemsBox->SelCount>1 ? "es":"";
      if (MsgBoxHwnd(Handle,"Delete selected mailbox"+pl+" and contents!\n\nAre you sure?",
             "Delete Mailbox",MB_OKCANCEL)==IDOK &&
          MsgBoxHwnd(Handle,"Mail in deleted mailbox"+pl+" will be lost forever!",
             "Delete Mailbox",MB_OKCANCEL)==IDOK)
      {
         long i=0; while (i<ItemsBox->Items->Count)
         {
            if (ItemsBox->Selected[i])
            {
               AnsiString boxname = ItemsBox->Items->Strings[i];
               if ((MailboxWin=FindOpenMailbox(boxname))!=NULL)
                  MailboxWin->Close();
               Cursor = crHourGlass;
               DelMailboxPos(boxname);
               DelMailbox(boxname);
               DelFromMenu(boxname);
               ItemsBox->Items->Delete(i);
               Cursor = crDefault;
            }
            else i++;
         }
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::PopRenameItemClick(TObject *Sender)
{
   if (menumode) return;
   AnsiString Newname,Oldname;
   for (int i=0; i<ItemsBox->Items->Count; i++) // find the single selected name
   {
      if (ItemsBox->Selected[i])
      {
         Oldname = ItemsBox->Items->Strings[i];
         break;
      }
   }
   if (Oldname.IsEmpty()) return;

   if ((Newname=GetMailboxRename(Oldname))!="")
   {
      if (Newname==Oldname || Newname.IsEmpty()) return;

      Cursor = crHourGlass;
      RenameAppIndex(UserMailboxes+PS+Oldname,Newname);
      if (DelFromMenu(Oldname)) menuboxes->Add(Newname);
      DelMailboxPos(Oldname);
      SetMailboxPos(Newname,0);

      GetAppData(ItemsBox->Items,UserMailboxes);
      for (int i=0; i<ItemsBox->Items->Count; i++)
         if (ItemsBox->Items->Strings[i]==Newname)
         {
            ItemsBox->Selected[i] = true;
            ItemsBox->ItemIndex = i;
            break;
         }
      Cursor = crDefault;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::ItemsBoxDrawItem(TWinControl *Control, int Index,
	TRect &Rect, TOwnerDrawState State)
{
   TRect r(Rect);
   TBrush *brush=ItemsBox->Canvas->Brush;
   AnsiString text=ItemsBox->Items->Strings[Index];
   if (menumode)
   {
      if (brush->Color==clHighlight)
          brush->Color = clFuchsia;
   }
   ItemsBox->Canvas->TextRect(r,r.Left+4,r.Top+2,text);
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::FormResize(TObject *Sender)
{
   Panel1->Width = Width - 32;
   Panel1->Height = Height- 78;
   ItemsBox->Width = Width - 55;
   ItemsBox->Height = Height - 132;
   OkBtn->Top = Height-58;
   OkBtn->Left = Width - 250;
   HelpBtn->Top = OkBtn->Top;
   HelpBtn->Left = Width - 90;
   CancelBtn->Top = OkBtn->Top;
   CancelBtn->Left = Width - 170;
}
//---------------------------------------------------------------------------
void __fastcall TMailboxDlg::ItemsBoxDblClick(TObject *Sender)
{
   ModalResult = mrOk;  
}
//---------------------------------------------------------------------------
