/*
*  MixDlgs.h
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
#define _WINSOCKAPI_
//---------------------------------------------------------------------------
// see mixmastdlg.cpp for notes on load-time vs run-time binding
// MixDir() is in global.cpp
#ifndef MixDlgsH
#define MixDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>

#include "FileMan.h"
//---------------------------------------------------------------------------
const int modePgpEncryptFile = 1;
const int modePgpDecryptFile = 2;
const int modePgpEncryptConventional = 6;
const int modePgpDecryptConventional = 7;
const int modeMixConfigNym = 9;   // unused so far
const int modePgpEncryptQSDBC = 10;
const int modePgpDecryptQSDBC = 11;

// Encrypt and Decrypt QS Database
int __fastcall PgpEncryptQSDBC(TDataBuf *Passphrase);
int __fastcall PgpDecryptQSDBC(TDataBuf *Passphrase);
// Encrypt and Decrypt when PGP plugin NOT installed
int __fastcall PgpEncryptConventional(TStrings *Message, AnsiString &Passphrase);
int __fastcall PgpDecryptConventional(TStrings *Message, AnsiString &Passphrase,
   int &errorcode);
// Low-level encrypt/decrypt & conpress/uncompress

//int __fastcall data_encrypt(char **data, long &datlen, char *password, int paslen);
//int __fastcall data_decrypt(char **data, long &datlen, char *password, int paslen);
//int __fastcall data_uncompress(char **data, long &datlen);
//int __fastcall data_compress(char **data, long &datlen);

class TMixForm : public TForm
{
__published:	// IDE-managed Components
  TLabel *Label1;
  TButton *CancelBtn;
  TTimer *Timer1;
  TTimer *Timer2;
  TTimer *Timer3;
  void __fastcall FormShow(TObject *Sender);
  
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall Timer2Timer(TObject *Sender);
  void __fastcall Timer3Timer(TObject *Sender);
  
private:	// User declarations
public:		// User declarations
  bool *Cancelled;
  int Mode,Result;
  int MsgCount;
  TStrings *Message;
  TStringList *Recips; // encrypt to these keys
  AnsiString Passphrase;
  TProgressBar *ProgressBar;
  AnsiString Cap,Filename,NewExt,SigId,SKeyRing,PKeyRing;
  TStringList *Feedback,*Messages;
  __fastcall TMixForm(TComponent* Owner);
  virtual __fastcall ~TMixForm();
  int __fastcall PgpEncryptQSDBC();
  int __fastcall PgpDecryptQSDBC();
  int __fastcall PgpEncryptConventional();
  int __fastcall PgpDecryptConventional();
//  int __fastcall MixEncryptMessage();
//  int __fastcall PgpEncryptFile();
//  int __fastcall PgpDecryptFile();
};

//---------------------------------------------------------------------------
extern TMixForm *MixForm;
//---------------------------------------------------------------------------
#endif
