/*
*  MixMsg.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\ComCtrls.hpp>
#include <filectrl.hpp>
#pragma hdrstop

#include "mixmsg.h"
#include "mixmaster.h"
#include "BrokeChnDlgs.h"
#include "MixDupChnDlgs.h"
#include "pgp.h"
#include "global.h"
#include "headman.h"
#include "wipedlgs.h"
#include "console.h"
#include "QSver.h"
#include "fileman.h"
#include "view.h"
#define DISPLAY(msg) display->Add(msg)
//---------------------------------------------------------------------------
void __fastcall MixPoolDeleteFile()
{
   if (FileExists(AppMixPool)&& simplewipe(AppMixPool)==WIPE_OK) // wipe the QS mixpool
      DeleteFile(AppMixPool.c_str());
}
//---------------------------------------------------------------------------
void __fastcall MixPoolDelete(int atPos)
{
   TStringList *pool = new TStringList();
   TStringList *message = new TStringList();
   GetAppData(pool,MixPoolKey,AppMixPool);  // get list of messages in pool
   if (pool->Count>atPos)
      PutAppData(MixPoolKey+PS+pool->Strings[atPos],NULL,AppMixPool); // delete from pool
   if (!MixPoolCount()) MixPoolDeleteFile();
   delete message;
   delete pool;
}
//---------------------------------------------------------------------------
long __fastcall MixPoolGet(TStrings *Message, AnsiString &Name, int atPos)
{
   Name = "";
   Message->Clear();
   TStringList *pool = new TStringList();
   GetAppData(pool,MixPoolKey,AppMixPool);  // get list of messages in pool
   if (pool->Count>atPos)
   {
      Name = pool->Strings[atPos];
      GetAppData(Message,MixPoolKey+PS+Name,AppMixPool); // get first message
   }
   delete pool;
   return atPos;
}
//---------------------------------------------------------------------------
long __fastcall MixPoolAdd(TStrings *Message, AnsiString &Name)
{
   int msgs;
   TStringList *pool = new TStringList();
   PutAppData(MixPoolKey+PS+Name,Message,AppMixPool);
   GetAppData(pool,MixPoolKey,AppMixPool);  // get list of messages in pool
   msgs = pool->Count;
   delete pool;
   return msgs;
}
//---------------------------------------------------------------------------
long __fastcall MixPoolCount()
{
   int count=0;
   if (FileExists(AppMixPool))
   {
      TStringList *pool = new TStringList();
      GetAppData(pool,MixPoolKey,AppMixPool);
      count = pool->Count;
      delete pool;
   }
   return count;
}
//---------------------------------------------------------------------------
void __fastcall MixmasterPoolClear()
{
//sm("ok1");
   AnsiString file,mixpool=MixDir()+"pool\\";
   if (!DirectoryExists(mixpool)) return;

   TStringList *files = new TStringList();
   GetFilenames(files,mixpool+"*.*");
   for (int i=0; i<files->Count; i++)
   {
      file = files->Strings[i];
      if (file==AppMixPool) MixPoolDeleteFile();
      else DeleteFile(file.c_str());
   }
   delete files;
   //RemoveDirectory(mixpool.c_str());
//sm("ok2");
}
//---------------------------------------------------------------------------
__fastcall TMixMessage::TMixMessage(TStringList *message, TStrings *aDisplay,
   TProgressBar *progressbar, TStringList *theFeedback)
{
   Finished = false;
   Cancelled = false;
   Message = message;
   display = aDisplay;

   HeadMan = new THeaderManager(Message);
   From = HeadMan->Get("From: "); HeadMan->Delete("From: ");
   Host = HeadMan->Get("Host: "); HeadMan->Delete("Host: ");
   AnsiString tmpc = HeadMan->GetDat("Chain: ",Message);
   if (tmpc.SubString(tmpc.Length(),1)==";") tmpc.Delete(tmpc.Length(),1);
   HeadMan->Delete("Chain: ");
   HeadMan->Delete("Fcc: ");

   Copies = GetParam(1,tmpc,"=").Trim().ToIntDef(1); if (Copies==0) Copies++;
   Chain = GetParam(0,tmpc,";").Trim(); tmpc = GetParam(1,tmpc,";").Trim();
   ProgressBar = progressbar;
   Feedback = theFeedback;
   MixmasterPoolClear();
}
//---------------------------------------------------------------------------
__fastcall TMixMessage::~TMixMessage()
{
   MixmasterPoolClear();
   delete HeadMan;
}
//---------------------------------------------------------------------------
long __fastcall TMixMessage::MixMessage(TStrings *Message, AnsiString &Chain, int copies,
   TStringList *Feedback)
{
   int i,ret,idx,pos;
   BUFFER *msg=buf_new(),*fbk=buf_new();
   if (!msg || !fbk) return -2;

   msg->sensitive = true; fbk->sensitive = true;
   // check for post
   THeaderManager *hm = new THeaderManager(Message);
   AnsiString post = hm->GetDat("Post: ");
   if (!post.IsEmpty())
   {
      idx=hm->Delete("Post: ");
      Message->Insert(idx<0?0:idx,"Newsgroups: "+post);
   }
   delete hm;

   // massage to and cc to single line
   AnsiString tos=HeadMan->GetDat("To: "),ccs=HeadMan->GetDat("Cc: ");
   if (!tos.IsEmpty())
   {
      while ((pos=tos.Pos("\r"))>0) tos.Delete(pos,1);
      while ((pos=tos.Pos("\n"))>0) tos.Delete(pos,1);
      while ((pos=tos.Pos(" ,"))>0) tos.Delete(pos,1);
      while ((pos=tos.Pos(", "))>0) tos.Delete(pos+1,1);
      idx = HeadMan->Delete("To: ");
      Message->Insert(idx,"To: "+tos);
   }
   if (!ccs.IsEmpty())
   {
      while ((pos=ccs.Pos("\r"))>0) ccs.Delete(pos,1);
      while ((pos=ccs.Pos("\n"))>0) ccs.Delete(pos,1);
      while ((pos=ccs.Pos(" ,"))>0) ccs.Delete(pos,1);
      while ((pos=ccs.Pos(", "))>0) ccs.Delete(pos+1,1);
      idx = HeadMan->Delete("Cc: ");
      Message->Insert(idx,"Cc: "+ccs);
   }
   // move message to buffer for encryption
   for (i=0; i<Message->Count; i++)
   {
      AnsiString line = Message->Strings[i]+"\n";
      buf_append(msg,(byte*)line.c_str(),line.Length());
    //buf_append(msg,(byte*)line.c_str(),line.Length());
    //buf_append(msg,(byte*)"\n",1);
   }

   if ((ret=mix_encrypt((post.IsEmpty()?MSG_MAIL:MSG_POST),msg,Chain.c_str(),copies,fbk))==0)
       mix_send();

   Feedback->Text = AnsiString((char*)fbk->data);
   for (i=0; i<Feedback->Count; i++)
      Feedback->Strings[i].Insert(" ",1);

   buf_free(msg); buf_free(fbk);
   return ret;
}
//---------------------------------------------------------------------------
bool __fastcall StringInList(AnsiString &String, TStringList *List)
{
   bool isin=false;
   for (int i=0; i<List->Count; i++)
   {
      if (List->Strings[i]==String)
      {
         isin = true;
         break;
      }
   }
   return isin;
}
//---------------------------------------------------------------------------
void DeleteStrings(TStrings *FromList, TStrings *ThatAreInList)
{
   int f=0; while (f<FromList->Count)
   {
      int pos = -1;
      for (int i=0; i<ThatAreInList->Count; i++)
      {
         if (FromList->Strings[f]==ThatAreInList->Strings[i])
         {
            pos = f;
            break;
         }
      }
      if (pos>=0)
         FromList->Delete(pos);
      else
         f++;
   }
}
//---------------------------------------------------------------------------
long __fastcall TMixMessage::Execute()
{
   long ret=0;
   AnsiString file,text,name,curstr;
   if (Cancelled) { Finished = true; return ret; }

   TStringList *prefiles = new TStringList();
   GetFilenames(prefiles,QUEUEFILES);
   DISPLAY("Mixmaster encrypting... ");
   Application->ProcessMessages();

   if ((ret=MixMessage(Message,Chain,Copies,Feedback))==0)
   {
      TStringList *msg = new TStringList();
      TStringList *outfiles = new TStringList();
      GetFilenames(outfiles,QUEUEFILES);
      if (!Cancelled)
      {
         AnsiString S = Feedback->Count==1 ? "":"s";
         DISPLAY("Mixmaster reports "+s(Feedback->Count)+" chain"+S+": ");
         for (int i=0; i<Feedback->Count; i++)
         {
            DISPLAY(Feedback->Strings[i]);
            AppProcessMessages();
         }
         if (!HasBrokenMixChainAfterEncrypt(AppMainForm,","+Chain+",",Feedback) &&
             !HasDuplicateMixChainsAfterEncrypt(AppMainForm,Feedback))
         {
            DeleteStrings(outfiles,prefiles);
            for (int i=0; i<outfiles->Count; i++)
            {
               file = outfiles->Strings[i];
               if (!Cancelled)
               {
                  curstr = (i+1<10? " ":"")+AnsiString(i+1);
                  name = MixmasterChain+" "+curstr+" of "+AnsiString(outfiles->Count);
                  msg->LoadFromFile(file); msg->Delete(0);
                  msg->Insert(0,Host);
                  msg->Insert(1,From);
                  msg->SaveToFile(file);
                  MixPoolAdd(msg,name);
               }
               DeleteFile(file.c_str());
            }
         }
         else Cancelled = true;
      }
      if (Cancelled) MixPoolDeleteFile();
      delete outfiles;
      delete msg;
   }
   delete prefiles;

   if (!Cancelled && ret!=0)
   {
      //int lo=LOWORD(ret),hi=HIWORD(ret);
      //DISPLAY("Error: ( "+AnsiString((int)lo)+" , "+AnsiString((int)hi)+" ) encrypting message");
      //switch (hi)
      //{
      //   case 2: Feedback->Add("Client error condition\n"); break;
      //   case 1: Feedback->Add("Commandline error\n"); break;
      //}
      DISPLAY("Mixmaster reports error condition: ");
      for (int i=0; i<Feedback->Count; i++)
      {
         DISPLAY(Feedback->Strings[i]);
         Application->ProcessMessages();
      }
   }
   Finished = true;
   return ret;
}
//---------------------------------------------------------------------------


