/*
*  Mixmaster.h
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#ifndef MixmasterH
#define MixmasterH

#include <vcl/comctrls.hpp>
//---------------------------------------------------------------------------
#define s(text) AnsiString(text)

bool __fastcall HasMix();
bool __fastcall HasMixmaster();

AnsiString __fastcall MixDir();
AnsiString __fastcall MixPublicRing();

const AnsiString AppMixPool = MixDir()+"mixpool";
const AnsiString MixPoolKey = "MixPool"; // datakey for apppool

const AnsiString BeginMixKey = "-----Begin Mix Key-----";
const AnsiString EndMixKey = "-----End Mix Key-----";

// constants used for help windows
const AnsiString MixmasterDocs = "Mixmaster Online Documents"; // caption
const AnsiString UpdateMixDocs = "UpdateMixDocs"; // help section

//bool __fastcall MixKeyDescOK(AnsiString &line);
bool __fastcall MixKeyDefinately(TStrings* keys);
bool __fastcall MixGetNextKey(AnsiString &keydesc, TStrings *key, TStrings *keys);
bool __fastcall MixGenType2(TStrings *Type2, TStrings *Mring, bool SaveToDisk=false);
bool __fastcall MixGenType2();
void __fastcall MixGetType2(TStrings *Type2);
void __fastcall MixSpaceType2(TStrings *Type2);
void __fastcall MixUnSpaceType2(TStrings *Type2);
bool __fastcall MixGetShortNames(TStrings *names);
AnsiString __fastcall MixGetShortNamesCommaText();

bool __fastcall MixRingLineOk(AnsiString &line);
bool __fastcall MixListLineOk(AnsiString &line);

int __fastcall data_encrypt(char **data, long &datlen, char *password, int paslen);
int __fastcall data_decrypt(char **data, long &datlen, char *password, int paslen);

const AnsiString MixKey = "Software\\Mixmaster";
const AnsiString MixExe = "mix.exe";
const AnsiString MixTmp = "mix.tmp.QS";
const AnsiString MixCfg = "mix.cfg";
const AnsiString MixOut = "out*.txt";
const AnsiString DefMixCfg =
   s("#################### Client Configuration ###################\r\n")+
   s("# Of the values below, only Distance, Minrel, Relfinal, and Maxlat can be\r\n")+
   s("# considered user adjustable. Leave the first 3 as they are.  See Help.\r\n")+
   s("#\r\n")+
   s("SENDMAIL outfile\r\n")+
   s("ERRLOG errlog\r\n")+
   s("REMAIL n\r\n\r\n")+
   s("DISTANCE 2\r\n")+
   s("MINREL 98\r\n")+
   s("RELFINAL 99\r\n")+
   s("MAXLAT 36h\r\n");

#define QUEUEDIRECTORY  AnsiString(MixDir()+"pool\\")
#define QUEUEFILES  AnsiString(QUEUEDIRECTORY+MixOut)

#define PATHMAX 512
#define LINELEN 128

typedef unsigned char byte;
typedef struct {
  byte *data;
  long length;
  long ptr;
  long size;
  byte sensitive;
} BUFFER;

typedef struct {
  char *name;
  FILE *f;
} LOCK;

typedef struct {
  int filetype;
  BUFFER *db;
  LOCK *lock;
  int modified;
  char filename[LINELEN];
  BUFFER *encryptkey;
} KEYRING;

int __fastcall mix_init(char *mixdir);
void __fastcall mix_exit();
void __fastcall MixShutDown();
void __fastcall RAND_bytes(byte *buf, int num);

int mixfile(char *path, const char *name);
FILE *mix_openfile(const char *name, const char *a);

int __fastcall mix_encrypt(int type, BUFFER *message, char *chain, int numcopies,
 	 BUFFER *feedback);

int buf_readfile(BUFFER *buffer, char *filename);
int buf_writefile(BUFFER *buffer, char *filename, char* mode);  // mode = 'wb' or 'wt'
int __fastcall buf_read(BUFFER *outmsg, FILE *infile);
int __fastcall buf_write(BUFFER *buffer, FILE *out);

BUFFER* __fastcall buf_new(void);
int __fastcall buf_free(BUFFER *buf);
int __fastcall buf_reset(BUFFER *buf);
int __fastcall buf_append(BUFFER *buffer, byte *mess, int len);
int __fastcall buf_sets(BUFFER *buffer, char *s);
void __fastcall buf_move(BUFFER *dest, BUFFER *src);
int __fastcall buf_write(BUFFER *buffer, FILE *out);
int __fastcall mix_send(void);
int __fastcall pgp_encrypt(int mode, BUFFER *message, BUFFER *encr, BUFFER *sigid,
		BUFFER *pass, char *pubring, char *secring);
int __fastcall pgp_mailenc(int mode, BUFFER *message, char *sigid,
		BUFFER *pass, char *pubring, char *secring);
int __fastcall pgp_decrypt(BUFFER *message, BUFFER *pass, BUFFER *sig, char *pubring,
		char *secring);

int __fastcall rnd_add(byte *b, long len);
void __fastcall rnd_time();
int __fastcall rnd_mouse(UINT i, WPARAM w, LPARAM l);
int __fastcall buf_getline(BUFFER *buffer, BUFFER *line);
int __fastcall buf_getheader(BUFFER *buffer, BUFFER *field, BUFFER *content);
int __fastcall buf_prepare(BUFFER *buffer, int size);
int __fastcall buf_appendc(BUFFER *to, byte b);
int __fastcall buf_appendi(BUFFER *to, int i);
int __fastcall buf_appendl(BUFFER *to, long l);
int __fastcall buf_cat(BUFFER *to, BUFFER *from);
int __fastcall buf_clear(BUFFER *buffer);
int __fastcall buf_appends(BUFFER *buffer, char *s);
int __fastcall buf_get(BUFFER *buffer, BUFFER *to, int n);
int __fastcall buf_rest(BUFFER *to, BUFFER *from);
int __fastcall buf_nl(BUFFER *b);
int __fastcall buf_set(BUFFER *to, BUFFER *from);
int __fastcall decode(BUFFER *in, BUFFER *out);
int __fastcall encode(BUFFER *in, int linelen);
int __fastcall buf_getc(BUFFER *buffer); // copy
int __fastcall buf_geti(BUFFER *b); // copy
long __fastcall buf_getl(BUFFER *b); //copy
int __fastcall buf_rewind(BUFFER *buffer); //copy
int __fastcall buf_eq(BUFFER *b1, BUFFER *b2); // copy
int __fastcall strifind(const char *string, const char *keyword);

// internal use for accessing dll function with run-time binding
typedef int (*MIX_INIT)(char*);
typedef void (*MIX_EXIT)();
typedef void (*RAND_BYTES)(unsigned char*, int);

typedef int (*BUF_READ)(BUFFER*, FILE*);
typedef int (*BUF_WRITE)(BUFFER*, FILE*);
typedef BUFFER* (*BUF_NEW)(void);
typedef int (*BUF_FREE)(BUFFER*);
typedef int (*BUF_RESET)(BUFFER*);
typedef int (*BUF_APPEND)(BUFFER*, byte*, int);
typedef int (*BUF_SETS)(BUFFER*, char *);
typedef void(*BUF_MOVE)(BUFFER*, BUFFER*);
typedef int (*BUF_WRITE)(BUFFER*, FILE*);
typedef int (*MIX_ENCRYPT)(int, BUFFER*, char*, int, BUFFER*);
typedef int (*MIX_SEND)(void);
typedef int (*PGP_ENCRYPTB)(int, BUFFER*, BUFFER*, BUFFER*, BUFFER*, char*, char*);
typedef int (*PGP_MAILENCB)(int, BUFFER*, char*, BUFFER*, char*, char*);

typedef int (*PGP_DECRYPTB)(BUFFER*, BUFFER*, BUFFER*, char*, char*);

typedef int (*RND_ADD)(byte*,long);

typedef void (*RND_TIME)(void);

typedef int (*RND_MOUSE)(UINT, WPARAM, LPARAM);

typedef int (*BUF_GETLINE)(BUFFER*, BUFFER*);
typedef int (*BUF_GETHEADER)(BUFFER*, BUFFER*, BUFFER*);
typedef int (*BUF_PREPARE)(BUFFER*, int);
typedef int (*BUF_APPENDC)(BUFFER*, byte);
typedef int (*BUF_APPENDL)(BUFFER*, long);
typedef int (*BUF_APPENDI)(BUFFER*, int);
typedef int (*BUF_CAT)(BUFFER*, BUFFER*);
typedef int (*BUF_CLEAR)(BUFFER*);
typedef int (*BUF_APPENDS)(BUFFER*, char*);
typedef int (*BUF_GET)(BUFFER*, BUFFER*, int);
typedef int (*BUF_REST)(BUFFER*, BUFFER*);
typedef int (*BUF_NL)(BUFFER*);
typedef int (*BUF_SET)(BUFFER*, BUFFER*);
typedef int (*DECODE)(BUFFER*, BUFFER*);
typedef int (*ENCODE)(BUFFER*, int);
typedef int (*STRIFIND)(const char*, const char*);
/*
// packet type
#define PGP_ENCRYPTED 9

#define MSG_MAIL 1
#define PGP_PASS -2
#define PGP_ERR -1
#define PGP_SIGN 1
#define PGP_ENCRYPT 2
#define PGP_TEXT 16
#define PGP_REMAIL 8
#define PGP_CONVENTIONAL 4
#define PGP_NOARMOR 32

// error codes
#define PGP_OK 0	 	 // valid message, not signed
#define PGP_SIGOK 1	     // valid signature
#define PGP_NOMSG 2		 // is not a OpenPGP message
#define PGP_NODATA 3	 // OpenPGP packet does not contain user data
#define PGP_SIGNKEY 4	 // can't verify signature
#define PGP_ERR -1		 // can't read message, no matching key found
#define PGP_PASS -2		 // bad passphrase
#define PGP_SIGBAD -3	 // bad signature
*/
#define BUFFER_MAX 2*1024*1024
#define BUFSIZE 4096
#define MixRandBin MixDir()+"mixrand.bin"
#define MixRandPool AnsiString("RandomPool")
//---------------------------------------------------------------------------
extern HINSTANCE hMixLib;
extern HINSTANCE hSSLLib;
//---------------------------------------------------------------------------
#endif
