/*
*  NymWins.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "NymWins.h"
//#include "NymRepBlks.h"
#include "NymMail.h"
#include "NymEditDlgs.h"
#include "FileWin.h"
#include "MsgWins.h"
#include "FileMan.h"
#include "ClipReply.h"
#include "PGPbuffers.h"
#include "PgpFiles.h"
//#include "global.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma link "NoteWins"
#pragma resource "*.dfm"
TNymWin *NymWin;
const bool noclear = false;
const bool preview = true;
const int publickey = 1;
const int secretkey = 2;
//---------------------------------------------------------------------------
__fastcall TNymWin::TNymWin(int,int,int,int,AnsiString&,TStrings*,TComponent*):TNoteWin(Owner){};
__fastcall TNymWin::TNymWin(AnsiString,AnsiString,TComponent*):TNoteWin(Owner){};
__fastcall TNymWin::TNymWin(TComponent* Owner):TNoteWin(Owner){};
//---------------------------------------------------------------------------
void __fastcall RunNymWindow(TForm *Owner, AnsiString &NymAddressKey)
{
   NymWin = new TNymWin(Owner,NymAddressKey);
}
//---------------------------------------------------------------------------
/*void __fastcall TNymWizDlg::GenProfileFromInput(TStrings *profile)
{
   profile->Clear();
   profile->Add("Nym: "+NYM->Text);
   profile->Add("Name: "+Name->Text);
   profile->Add("Commands: "+NymCommandsStr());
   profile->Add("PgpKey: "+PgpKey->Text);
   profile->AddStrings(ReplyBlock->Lines);
   AnsiString keyid = PgpKey->Text.SubString(3,8);
   if (pubkeys->get(keyid,key)) profile->Add(key->export());
   if (seckeys->get(keyid,key)) profile->Add(key->export());
   profile->Text = profile->Text;
   int i=0; while (i<profile->Count)
   {
      AnsiString line = profile->Strings[i].Trim();
      if (line.Pos("-----BEGIN PGP ")==1) break;
      if (line.IsEmpty()) profile->Delete(i);
      else i++;
   }
}*/
//---------------------------------------------------------------------------
// TNymProfile
//---------------------------------------------------------------------------
__fastcall TNymProfile::TNymProfile()
   : TStringList()
{
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymProfile::nym()
{
   int i=0; while(i<Count)
      if (Strings[i].Pos("Nym: ")==1) return Strings[i].SubString(6,128);
      else i++;
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymProfile::nymname()
{
   int i=0; while(i<Count)
      if (Strings[i].Pos("Name: ")==1) return Strings[i].SubString(7,128);
      else i++;
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymProfile::nymcommands()
{
   int i=0; while(i<Count)
      if (Strings[i].Pos("Commands: ")==1) return Strings[i].SubString(11,128);
      else i++;
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymProfile::nympgpkeydescrip()
{
   int i=0; while(i<Count)
      if (Strings[i].Pos("PgpKey: ")==1) return Strings[i].SubString(9,128);
      else i++;
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymProfile::nymreplyblocks()
{
   AnsiString blocks;
   bool saving = false;
   TStringList *blks = new TStringList();
   for (int i=0; i<Count; i++)
   {
      if (Strings[i].Pos("-----BEGIN PGP ")==1) break;
      if (Strings[i].Pos("Reply-Block:")==1)
      {
         if (!saving) saving = true;
         blks->Add("");
      }
      if (saving) blks->Add(Strings[i]);
   }
   blocks = blks->Text;
   delete blks;
   return blocks;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymProfile::nympublickey()
{
// secret key is stored without empty lines at position 2, this must be restored below
   AnsiString key;
   bool saving = false;
   TStringList *lines = new TStringList();
   for (int i=0; i<Count; i++)
   {
      if (Strings[i].Pos("-----BEGIN PGP")==1) saving = true;
      if (saving) lines->Add(Strings[i]);
      if (Strings[i].Pos("-----END PGP")==1) break;
   }
   if (lines->Count>3 && !lines->Strings[2].Trim().IsEmpty()) // restored here
      lines->Insert(2,"");
   key = lines->Text;
   delete lines;
   return key;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymProfile::nymsecretkey()
{
   // secret key is stored without empty lines at position 2, this must be restored below
   int keyno = 0;
   AnsiString key;
   bool saving = false;
   TStringList *lines = new TStringList();
   for (int i=0; i<Count; i++)
   {
      if (Strings[i].Pos("-----BEGIN PGP ")==1) keyno++;
      if (keyno==2) saving = true;
      if (saving) lines->Add(Strings[i]);
      if (Strings[i].Pos("-----END PGP ")==1 && keyno==2) break;
   }
   if (lines->Count>3 && !lines->Strings[2].Trim().IsEmpty()) // restored here
      lines->Insert(2,"");
   key = lines->Text;
   delete lines;
   return key;
}
//---------------------------------------------------------------------------
// TNymWin
//---------------------------------------------------------------------------
__fastcall TNymWin::TNymWin(TComponent *Owner, AnsiString NymAddressKey)
	: TNoteWin(Owner)
{
   bool isnew=false;
   AnsiString line;
   nymkey = NymAddressKey;
   pgpkeys = new TStringList();
   profile = new TNymProfile();
   orgprofile = new TNymProfile();
   if (NymAddressKey.Pos("NEWNYM::NEWNYM")==1)
   {
      nymkey = NymProfilesKey;
      orgprofile->Text = NymAddressKey; // holds entire new profile
      orgprofile->Delete(0);
      isnew = true;
   }
   else GetAppData(orgprofile,nymkey);
   if (orgprofile->Count)
   {
      if (nymkey.Pos(NymRetiredsKey)==1) Caption = "Retired "; else
      if (nymkey.Pos(NymProfOldsKey)==1) Caption = "Backup "; else
      if (nymkey.Pos(NymProfilesKey)==1) Caption = "Active ";
      CreateBtn->Enabled = Caption.Pos("Retired")!=1;
      if (orgprofile->Count)
      {
         Caption = Caption+orgprofile->Strings[0];
         orgprofile->Delete(0);
      }

      Editor->OnSelectionChange = 0;
      for (int i=0; i<orgprofile->Count; i++)
      {
         line = orgprofile->Strings[i];
       //if (line.Pos("-----BEGIN PGP ")==1) break;
         Editor->Lines->Add(line);
      }
      GetPgpKey(publickey,orgprofile,pgpkeys);
      GetPgpKey(secretkey,orgprofile,pgpkeys);

      Editor->OnSelectionChange = EditorSelectionChange;
      Editor->WordWrap = false;
      Editor->SelStart = 0;

      SavePBtn->Enabled = isnew;
      Editor->Modified = isnew;
      FormResize(this);
   }
}
//---------------------------------------------------------------------------
__fastcall TNymWin::~TNymWin()
{
   delete orgprofile;
   delete profile;
   delete pgpkeys;
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::CreateBtnClick(TObject *Sender)
{
   TPoint screen,client={ CreateBtn->Left,CreateBtn->Top+CreateBtn->Height };
   screen = ClientToScreen(client);
   ConfigMessageMenu->Popup(screen.x,screen.y);
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::GenProfile(TStrings *profile)
{
   AnsiString line=Nym();
   if (line.Pos("Nym: ")==0) line = "Nym: "+line;

   profile->Clear();
   profile->Add(line);
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      line = Editor->Lines->Strings[i];
      //if (!line.IsEmpty())
      profile->Add(line);
   }
   if (Editor->Lines->IndexOf(BeginPgpPubKeyBlock)<0)
      profile->AddStrings(pgpkeys);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymWin::Nym()
{
   int pos;
   if ((pos=Caption.Pos("Nym: "))==0) return Caption;
   return Caption.SubString(pos+5,256);
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (Editor->Modified)
   {
      switch (MsgDlg((TForm*)Owner,
         s("Your nym profile is modified! Save your changes?"),
         s("Nym Modified"),MB_YESNOCANCEL))
      {
         case IDCANCEL: CanClose = false;
         case IDNO: return;
      }
      SaveProfile();
   }
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::FormResize(TObject *Sender)
{
   HelpBtn->Left = Width-HelpBtn->Width-10;
   TNoteWin::FormResize(Sender);
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymWin::Name()
{
   return Nym();
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::SaveProfile()
{
   GenProfile(profile);
   AnsiString nym=Nym();
   orgprofile->Insert(0,"Nym: "+Nym());
   cap = Caption; Caption = "Saving..."; Snooze(200);
   if (cap.Pos("Active ")==1)
   {
      PutAppData(NymProfOldsKey+PS+nym,orgprofile);
      PutAppData(NymProfilesKey+PS+nym,profile);
   }
   else
   if (cap.Pos("Backup ")==1)
   {
      PutAppData(NymProfOldsKey+PS+nym,profile);
   }
   else
   if (cap.Pos("Retired ")==1)
   {
      PutAppData(NymRetiredsKey+PS+nym,profile);
   }
   orgprofile->Text = profile->Text;
   SavePBtn->Enabled = false;
   Editor->Modified = false;
   Caption = cap;
   Snooze(100);
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::SaveasActiveProfileItemClick(TObject *Sender)
{
   if (MsgDlg(AppMainForm,
      "Save this backup profile as the active profile?",
      "Confirm",MB_OKCANCEL)==IDOK)
   {
      GenProfile(profile);
      AnsiString nym=Nym();
      cap = Caption; Caption = "Saving..."; Snooze(200);
      PutAppData(NymProfilesKey+PS+nym,profile);
      Caption = "Active Nym: "+nym;
      Snooze(100);
   }
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::PopupSaveItemClick(TObject *Sender)
{
   SaveProfile();
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::PopupMenu1Popup(TObject *Sender)
{
   ReplayMessageItem->Enabled = AppDataExists(NymReplaysKey+PS+Nym());
   SaveasActiveProfileItem->Enabled = Caption.Pos("Backup ");
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::OkBtnClick(TObject *Sender)
{
   if (Editor->Modified) SaveProfile();
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::ReplayMessageItemClick(TObject *Sender)
{
   TStringList *msg = new TStringList();
   GetAppData(msg,NymReplaysKey+PS+Nym());
   if (msg->Count)
   {
      if (msg->Strings[0].Pos(NymConfigHdr)==1) msg->Delete(0);
      PutNymMessageOnDesktop(AppMainForm,msg);
   }
   delete msg;
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::PopupNymConfigItemClick(TObject *Sender)
{
   AnsiString tname,name=Nym();
   TStringList *temps = new TStringList();
   GetAppData(temps,UserTemplates);
   if (temps->IndexOf("nym-config")>=0) tname = UserTemplates+PS+"nym-config";
   delete temps;
   if (tname.IsEmpty()) tname = GetMergeMessage(
     "Select a template for your nym-config message",modeNymcnfg
   );
   if (tname.IsEmpty()) return;

   CreateConfigMessage((TForm*)Owner,name,Editor->Lines,orgprofile,tname,!preview);
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::PopupNymConfigPrevItemClick(TObject *Sender)
{
   AnsiString tname,name=Nym();
   TStringList *temps = new TStringList();
   GetAppData(temps,UserTemplates);
   if (temps->IndexOf("nym-config")>=0) tname = UserTemplates+PS+"nym-config";
   delete temps;
   if (tname.IsEmpty()) tname = GetMergeMessage(
     "Select a template for your nym-config message",modeNymcnfg
   );
   if (tname.IsEmpty()) return;

   CreateConfigMessage((TForm*)Owner,name,Editor->Lines,orgprofile,tname,preview);
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::PopupCmdMsgItemClick(TObject *Sender)
{
   AnsiString tname;
   TStringList *temps = new TStringList();
   GetAppData(temps,UserTemplates);
   if (temps->IndexOf("nym-config")>=0) tname = UserTemplates+PS+"nym-config";
   delete temps;
   if (tname.IsEmpty()) tname = GetMergeMessage(
     "Select a template for your nym-config message",modeNymcnfg
   );
   if (tname.IsEmpty()) return;

   CreateCommandMessage((TForm*)Owner,Nym(),Editor->Lines,orgprofile,tname);
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::PopupDeleteMsgItemClick(TObject *Sender)
{
   AnsiString tname;
   TStringList *temps = new TStringList();
   GetAppData(temps,UserTemplates);
   if (temps->IndexOf("nym-config")>=0) tname = UserTemplates+PS+"nym-config";
   delete temps;

   if (tname.IsEmpty()) tname = GetMergeMessage(
     "Select a template for your nym-config message",modeNymcnfg
   );
   if (tname.IsEmpty()) return;

   CreateDeleteMessage((TForm*)Owner,Nym(),Editor->Lines,orgprofile,tname);
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::EditorSelectionChange(TObject *Sender)
{
   if (Editor->Modified && !SavePBtn->Enabled) SavePBtn->Enabled = true;
   TNoteWin::EditorSelectionChange(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::ConfigMessageMenuPopup(TObject *Sender)
{
//sm(NymReplaysKey+PS+Nym());
   PopReplayLastItem->Enabled = AppDataExists(NymReplaysKey+PS+Nym());
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::ToolsNymserversItemClick(TObject *Sender)
{
   TStringList *nymservers = new TStringList();
   GetAppData(nymservers,NymServersKey);
   if (EditNymServers((TForm*)Owner,nymservers))
   {
      PutAppData(NymServersKey,nymservers);
   }
   delete nymservers;
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::Directives1Click(TObject *Sender)
{
   TStringList *dirs = new TStringList();
   GetCpkDirectives(dirs);
   if (EditCpkDirectives((TForm*)Owner,dirs))
   {
      PutAppData(CpkDirectivesKey,dirs);
   }
   delete dirs;
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::Headers1Click(TObject *Sender)
{
   TStringList *hdrs = new TStringList();
   GetCpkHeaders(hdrs);
   if (EditCpkHeaders((TForm*)Owner,hdrs))
   {
      PutAppData(CpkHeadersKey,hdrs);
   }
   delete hdrs;
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::ReplyBlockTemplated1Click(TObject *Sender)
{
   TStringList *temps = new TStringList();
   GetAppData(temps,NymRBTempsKey);
   if (EditRBTemplates((TForm*)Owner,temps))
   {
      PutAppData(NymRBTempsKey,temps);
   }
   delete temps;
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::NymCommands1Click(TObject *Sender)
{
   TStringList *cmds = new TStringList();
   GetAppData(cmds,NymCommandsKey);
   if (EditNymCommands((TForm*)Owner,cmds))
   {
      PutAppData(NymCommandsKey,cmds);
   }
   delete cmds;
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::RDocItemClick(TObject *Sender)
{
   AnsiString doc; int d;
   TMenuItem *item = dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      doc = MixDir()+item->Caption;
      while ((d=doc.Pos("&"))>0) doc.Delete(d,1);
      if (FileExists(doc)) EditTextFile(doc);
   }
}
//---------------------------------------------------------------------------
AnsiString __fastcall TNymWin::PgpKeyId()
{
   AnsiString keyid,tmp;
   for (int i=0; i<Editor->Lines->Count; i++)
   {
      tmp = Editor->Lines->Strings[i];
      if (tmp.Pos("PgpKey: ")==1)
      {
         keyid = tmp.SubString(9,256);
         break;
      }
   }
   return keyid;
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::GetPgpKey(int idx, TStrings *profile, TStrings *tostrings)
{
   bool inkey=false; int c=0;
   for (int i=0; i<profile->Count-1; i++)
   {
      AnsiString line = profile->Strings[i];
      if (line.Pos("-----BEGIN PGP ")==1 && ++c==idx) inkey=true;
      if (inkey)
      {
         tostrings->Add(line);
         if (line.Pos("-----END PGP ")==1) break;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TNymWin::ChangenymsPGPkey1Click(TObject *Sender)
{
   AnsiString tname,newkeyid=RunNymPGPKeyChange((TForm*)Owner,PgpKeyId().c_str());
   if (!newkeyid.IsEmpty())
   {
      pgpkeys->Clear();
      TPGPbuffer *pubs,*secs,*key=new TPGPbuffer();
      pubs=new TPGPbuffer(PgpPublicRing());
      secs=new TPGPbuffer(PgpSecretRing());
      pubs->get(newkeyid,key);
      key->export(pgpkeys);
      secs->get(newkeyid,key);
      key->export(pgpkeys,noclear);
      delete secs;
      delete pubs;
      delete key;

      int i=0; while(i<pgpkeys->Count)
         if (pgpkeys->Strings[i].IsEmpty()) pgpkeys->Delete(i);
         else i++;
      for (int i=0; i<Editor->Lines->Count; i++)
      if (Editor->Lines->Strings[i].Pos("PgpKey:")==1)
      {
         Editor->Lines->Strings[i] = "PgpKey: "+newkeyid;
         break;
      }

      TStringList *temps = new TStringList();
      GetAppData(temps,UserTemplates);
      if (temps->IndexOf("nym-config")>=0) tname = UserTemplates+PS+"nym-config";
      delete temps;
      if (tname.IsEmpty()) tname = GetMergeMessage(
        "Select a template for your nym-config message",modeNymcnfg);
      if (tname.IsEmpty()) return;

      CreateKeyChangeMessage((TForm*)Owner,Nym(),Editor->Lines,orgprofile,
         tname,newkeyid);
   }
}
//---------------------------------------------------------------------------
