/*
*  NymWins.h
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#ifndef NymWinsH
#define NymWinsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include "explbtn.hpp"
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include "NoteWins.h"
#include <vcl\Buttons.hpp>
//---------------------------------------------------------------------------
void __fastcall RunNymWindow(TForm *Owner, AnsiString &NymAddress);

class TNymProfile : public TStringList
{
public:
   __fastcall TNymProfile();
   AnsiString __fastcall nym();
   AnsiString __fastcall nymname();
   AnsiString __fastcall nymcommands();
   AnsiString __fastcall nympgpkeydescrip();
   AnsiString __fastcall nymreplyblocks();
   AnsiString __fastcall nympublickey();
   AnsiString __fastcall nymsecretkey();
};

class TNymWin : public TNoteWin
{
__published:	// IDE-managed Components
	TOfficeButton *CreateBtn;
	TOfficeButton *HelpBtn;
	TMenuItem *SaveasActiveProfileItem;
	TOfficeButton *SavePBtn;
	TMenuItem *N1;
	TPopupMenu *ConfigMessageMenu;
	TMenuItem *PopupNymConfigItem;
	TMenuItem *PopupDeleteMsgItem;
	TMenuItem *PopupCmdMsgItem;
	TMenuItem *PopupNymConfigPrevItem;
	TMenuItem *ReplayMessageItem;
	TMenuItem *PopReplayLastItem;
	TOfficeButton *ToolsBtn;
	TBevel *Bevel2;
	TPopupMenu *PopupMenu3;
	TMenuItem *ToolsNymserversItem;
	TMenuItem *NymCommands1;
	TMenuItem *Directives1;
	TMenuItem *Headers1;
	TMenuItem *MenuItem1;
	TMenuItem *ReplyBlockTemplated1;
	TOfficeButton *DocsBtn;
	TBevel *Bevel3;
	TPopupMenu *PopupMenu2;
	TMenuItem *PopRlistItem;
	TMenuItem *PopPubringItem;
	TMenuItem *ChangenymsPGPkey1;
	TMenuItem *N3;
	void __fastcall CreateBtnClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall PopupSaveItemClick(TObject *Sender);
	void __fastcall SaveasActiveProfileItemClick(TObject *Sender);
	void __fastcall PopupMenu1Popup(TObject *Sender);
	
	void __fastcall OkBtnClick(TObject *Sender);
	void __fastcall ReplayMessageItemClick(TObject *Sender);
	void __fastcall PopupNymConfigItemClick(TObject *Sender);
	void __fastcall PopupCmdMsgItemClick(TObject *Sender);
	void __fastcall PopupDeleteMsgItemClick(TObject *Sender);
	void __fastcall PopupNymConfigPrevItemClick(TObject *Sender);
	
	void __fastcall EditorSelectionChange(TObject *Sender);
	void __fastcall ConfigMessageMenuPopup(TObject *Sender);
	void __fastcall ToolsNymserversItemClick(TObject *Sender);
	void __fastcall Directives1Click(TObject *Sender);
	void __fastcall Headers1Click(TObject *Sender);
	void __fastcall ReplyBlockTemplated1Click(TObject *Sender);
	void __fastcall NymCommands1Click(TObject *Sender);
	void __fastcall RDocItemClick(TObject *Sender);
	
	void __fastcall ChangenymsPGPkey1Click(TObject *Sender);
	
private:	// User declarations
public:		// User declarations
    AnsiString nymkey,cap;
    TStringList *pgpkeys;
    TNymProfile *orgprofile,*profile;
	virtual __fastcall TNymWin(TComponent* Owner);
    virtual __fastcall TNymWin(TComponent* Owner, AnsiString NymAddress);
    virtual __fastcall TNymWin(AnsiString, AnsiString, TComponent*);
    virtual __fastcall TNymWin(int,int,int,int,AnsiString&,TStrings*,TComponent*);
	virtual __fastcall~TNymWin();
    void __fastcall GetPgpKey(int idx, TStrings *profile, TStrings *tostrings);
    //void __fastcall GetPGPPublicKey(TStrings *profile, TStrings *tostrings);
    //void __fastcall GetPGPSecretKey(TStrings *profile, TStrings *tostrings);
    void __fastcall GenProfile(TStrings *profile);
    AnsiString virtual __fastcall Name();
    AnsiString __fastcall PgpKeyId();
    void __fastcall SaveProfile();
    AnsiString __fastcall Nym();
};

bool __fastcall CreateConfigMessage(TForm *Owner, AnsiString &nymaddress,
   TStrings *profile, TStrings *orgprofile, bool preview);
bool __fastcall ReplyBlocksFailInitialScan(TStrings *blocks, TStrings *profile);
bool __fastcall LoadReplyBlocks(TStrings *blocks, TStrings *profile);
AnsiString __fastcall GetProfileItem(AnsiString name, TStrings *profile);
//---------------------------------------------------------------------------
extern TNymWin *NymWin;
//---------------------------------------------------------------------------
#endif
