/*
*  OldOpenDlg.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "OldOpenDlg.h"
#include "NewNameDlgs.h"
#include "MsgWins.h"
#include "SaveDlg.h"
#include "Global.h"
#include "FileMan.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOpenForm *OpenForm;
//---------------------------------------------------------------------------
AnsiString __fastcall OpenOpenDlg(TStrings *Message, AnsiString &Section,
   bool SortView)
{
   AnsiString title;
   OpenForm = new TOpenForm(AppMainForm);
   OpenForm->ListBox->Sorted = SortView;
   OpenForm->Init(Section);
   OpenForm->mode = "Open ";
   OpenForm->ShowModal();
   if (OpenForm->ModalResult==mrOk)
   {
      Section = OpenForm->DatSection();
      Message->Clear(); Sleep(SleepTime);
      GetAppData(Message,Section+PS+OpenForm->Name->Text);
      title = OpenForm->Name->Text;
   }
   delete OpenForm;
   return title;
}
//---------------------------------------------------------------------------
__fastcall TOpenForm::TOpenForm(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,Owner);//AppMainForm);
   ListBox->MultiSelect = true;
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::Init(AnsiString &Section)
{
   if (Section!=MailQueue && Section!=ProblemQueue &&
       Section!=SMTPLog && Section!=POP3Log && Section!=ChainLog && Section!=ErrChkLog)
   {
      LookInBox->Items->Add(UserNotes);
      LookInBox->Items->Add(UserMessages);
      LookInBox->Items->Add(UserTemplates);
   }
   else
      ListBox->Columns = 0;
   if (Section!=SMTPLog && Section!=POP3Log && Section!=ChainLog && Section!=ErrChkLog)
   {  // no extra lookinbox items for pop and smtp
      if (AppDataExists(ProblemQueue)) LookInBox->Items->Add(ProblemQueue);
      if (AppDataExists(MailQueue)) LookInBox->Items->Add(MailQueue);
   }
   else
   {
      LookInBox->Items->Add(Section);
      ListBox->Font->Name = "Courier New";
      ListBox->Font->Size = 9;
   }
   LookInBox->ItemIndex = LookInBox->Items->IndexOf(Section);
   if (Section==MailQueue || Section==ProblemQueue)
      PopRenameItem->Visible = false;
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::ListBoxClick(TObject *Sender)
{
   int count = ListBox->SelCount;
   bool multi = count>1;
   OkBtn->Enabled = count==1;
   Name->Enabled = !multi;
   if (!multi && ListBox->Items->Count)
      Name->Text = ListBox->Items->Strings[ListBox->ItemIndex];
   else
      Name->Clear();
}
//---------------------------------------------------------------------------
AnsiString __fastcall TOpenForm::Title()
{
//   if (DatSection()==UserMailboxes) return "Mailbox";
//   if (DatSection()==UserData) return "Data";
   if (DatSection()==UserTemplates) return "Template";
   if (DatSection()==UserMessages) return "Draft";
//   if (DatSection()==MailQueue) return "Message";
//   if (DatSection()==ProblemQueue) return "Problem";
   if (DatSection()==UserNotes) return "Note";
//   if (DatSection()==UserNyms) return "Nym";
   if (DatSection()==SMTPLog) return SMTPLog;
   if (DatSection()==POP3Log) return POP3Log;
   if (DatSection()==ErrChkLog) return ErrChkLog;
   if (DatSection()==ChainLog) return ChainLog;
   return "";
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::LoadItems()
{
//   Name->Clear();
   Caption = mode+Title();
   ListBox->Items->Clear();
   TStringList *tmp = new TStringList();
   GetAppData(ListBox->Items,DatSection());
   ListBox->Items->AddStrings(tmp);
   if (ListBox->Items->Count)
      ListBox->ItemIndex = 0;
   delete tmp;
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::ListBoxDblClick(TObject *Sender)
{
   if (ListBox->SelCount==1) ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::ListBoxDrawItem(TWinControl *Control, int Index,
	TRect &Rect, TOwnerDrawState State)
{
   int pos;
   TRect r(Rect);
   ListBox->Canvas->FillRect(r);
   r.Right -= 4;
   AnsiString str=ListBox->Items->Strings[Index],fs=FieldSep;
   // fixup new style indexstr's with FieldSep dividers
   if (DatSection()==ProblemQueue || DatSection()==MailQueue)
   {
      while ((pos=str.Pos(InCode))>0) str.Delete(pos,2);
      while ((pos=str.Pos(OutCode))>0) str.Delete(pos,2);
      pos=1; while (pos<=str.Length())
      {
         if (str[pos]==fs[1])
         {
            str.Delete(pos,1); str.Insert("    ",pos);
         }
         pos++;
      }
      while (str.Length() && str[str.Length()]!=' ') // remove msg size field
         str.SetLength(str.Length()-1);
   }
   ListBox->Canvas->TextRect(r,r.Left+4, r.Top+2, str);
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::PopupMenuPopup(TObject *Sender)
{
   int c=0;
   for (int i=0; i<ListBox->Items->Count; i++)
      if (ListBox->Selected[i]) c++;
   PopRenameItem->Enabled = c==1;
   PopDeleteItems->Enabled = c>0;
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::PopDeleteItemsClick(TObject *Sender)
{
   int i;
   AnsiString name;
   if (MsgBoxHwnd(Handle,"Delete selected "+Title()+"(s)!\n\nAre you sure?",
          "Delete Message",MB_OKCANCEL)==IDOK)
   {
      for (i=0; i<ListBox->Items->Count; i++)
         if (ListBox->Selected[i])
            PutAppData(DatSection()+PS+ListBox->Items->Strings[i],NULL);
      if (DatSection()==ProblemQueue) Application->MainForm->Perform(WM_PROBLEMCHANGE,0,NULL);
      if (DatSection()==MailQueue) Application->MainForm->Perform(WM_QUEUECHANGE,0,NULL);
      Name->Clear();
   }
   LoadItems();
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::PopRenameItemClick(TObject *Sender)
{
   int i;
   AnsiString Newname,Oldname,name;
   for (i=0; i<ListBox->Items->Count; i++) {
      if (ListBox->Selected[i]) {
         Oldname = ListBox->Items->Strings[i];
         break;
      }
   }
   if (Oldname.IsEmpty()) return;

   if ((Newname=GetMailboxRename(Oldname))!="")
   {
      if (Newname==Oldname) return;

      TStringList *menuboxes = new TStringList();
      delete menuboxes;

      Cursor = crHourGlass;
      TStringList *mail = new TStringList();
      GetAppData(mail,DatSection()+PS+Oldname);
      PutAppData(DatSection()+PS+Oldname,NULL);
      PutAppData(DatSection()+PS+Newname,mail);
      delete mail;
      LoadItems();
      Name->Clear();
      Cursor = crDefault;
   }
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk && Name->Text.Trim().IsEmpty())
   {
      BingBox(this,"You must enter a name or click 'Close'.","Filename Required",MB_OK);
      CanClose = false;
      return;
   }
   // do these before cancel as messages/problems may have been deleted
   if (DatSection()==ProblemQueue) Application->MainForm->Perform(WM_PROBLEMCHANGE,0,NULL); else
   if (DatSection()==MailQueue) Application->MainForm->Perform(WM_QUEUECHANGE,0,NULL); else
   if (ModalResult==mrCancel) return;

   // can't exit ok with empty name
   if (Name->Text.IsEmpty()) {
      //MyBeep(MB_OK);
      //CanClose = false;
      ModalResult = mrCancel;
      return;
   }
   // is the name supplied in the list?
   if (ListBox->Items->IndexOf(Name->Text)<0)
   {
      MsgBoxHwnd(Handle,"Invalid Name!\n\nPlease select from the list supplied.","Open Error",MB_OK);
      Name->Clear();
      ActiveControl = Name;
      CanClose = false;
      return;
   }
   // is this the master list of data section?
   if (DatSection()==UserData)
   {
      AnsiString tmp;
      if (ListBox->ItemIndex>=0)
         tmp = ListBox->Items->Strings[ListBox->ItemIndex];
      LookInBox->ItemIndex = LookInBox->Items->IndexOf(tmp);
      LoadItems();
      CanClose = false;
      return;
   }
   // exit ok--no problems
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::LookInBoxChange(TObject *Sender)
{
   if (LookInBox->Text==UserData)
   {// not used currently
      ListBox->Clear();
      Caption = mode+Title();
      if (AppDataExists(ProblemQueue)) ListBox->Items->Add(ProblemQueue);
      if (AppDataExists(MailQueue)) ListBox->Items->Add(MailQueue);
      if (AppDataExists(UserNyms)) ListBox->Items->Add(UserNyms);
      ListBox->Items->Add(UserTemplates);
      ListBox->Items->Add(UserMessages);
      ListBox->Items->Add(UserNotes);
   }
   else
      LoadItems();
}
//---------------------------------------------------------------------------
void __fastcall TOpenForm::FormShow(TObject *Sender)
{
   LookInBoxChange(Sender);
   if (DatSection()==SMTPLog || DatSection()==POP3Log)
   {
      int index = ListBox->Items->Count-5; if (index<0) index = 0;
      //ListBox->ItemIndex = ListBox->Items->Count-1;
      ListBox->TopIndex = index;
      ListBox->PopupMenu = NULL;
   }
}
//---------------------------------------------------------------------------
