/*
*  OptionsDlgs.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <filectrl.hpp>
#pragma hdrstop

#include "OptionsDlgs.h"
#include "OptsAdvPGPDlgs.h"
#include "DirBrow.h"
#include "Pop3mail.h"
#include "MsgInWin.h"
#include "global.h"
#include "fileman.h"
#include "mixmaster.h"
#include "cyberpunk.h"
#include "pgpmail.h"
#include "nymmail.h"
#include "pgpfiles.h"
#include "helpdlgs.h"
#include "mainmdi.h"
#include "dirbrow.h"

#define IniValue1orEmpty(inikey) (ini->Values[inikey]=="1" || ini->Values[inikey].IsEmpty())
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TOptionsDlg *OptionsDlg;
//---------------------------------------------------------------------------
bool __fastcall GetPreferences(AnsiString &PageCap)
{
   bool ok=false;
   AnsiString cap = AppMainForm->Caption; AppMainForm->Caption = "Loading options...";
   TColor mfcolor = AppMainForm->Color;
   TOptionsDlg *pf = new TOptionsDlg(AppMainForm);
   CenterDialog(pf,AppMainForm);

   // hide items depending actual capabilities
   pf->RecSheet->TabVisible = HasPop3();
   pf->TabSheet5->TabVisible = HasMix();
   pf->PgpSheet->TabVisible = HasPgp();
   pf->NymSheet->TabVisible = HasPgp() && HasNyms();

   int page=0;
   TPageControl *pc = pf->PageControl1;
   for (int i=0; i<pc->PageCount; i++)
   {
      AnsiString cap = pc->Pages[i]->Caption.Trim().LowerCase();
      if (cap==PageCap.LowerCase() && pc->Pages[i]->TabVisible)
      {
         page = i;
         break;
      }
   }
   TTabSheet *active = pc->ActivePage = pc->Pages[page];
   if (active==pf->PgpSheet || active==pf->EdSheet)
      pf->HelpBtn->Enabled = true;

   AppMainForm->Caption = cap;
   pf->ShowModal();
   if (pf->ModalResult==mrOk) ok=true;
   else
   {
      if (AppMainForm->Color != mfcolor)
      {
          AppMainForm->Color = mfcolor;
        ::InvalidateRect(AppMainForm->ClientHandle,NULL,true);
      }
   }
   return ok;
}
//---------------------------------------------------------------------------
AnsiString __fastcall NameNoParams(AnsiString cmdline)
{
   if (cmdline.IsEmpty()) return "";
   int start=1,pos=cmdline.Pos(".exe");
   if (cmdline[1]=='#') start++;
   if (pos) return cmdline.SubString(start,pos+3);
   return "";
}
//---------------------------------------------------------------------------
__fastcall TOptionsDlg::TOptionsDlg(TComponent* Owner)
  : TForm(Owner)
{
   AnsiString txt;
   ini = new TStringList();
   GetAppData(ini,AppIniValues);
   initcomplete = false; cpunkchange = false;
   // general
   txt = ini->Values[QuoteMarks];
   if (txt.IsEmpty()) txt = "> "; txt = "\""+txt+"\"";
   QuoteMarkEdit->Text = txt;
   ColorBox->Color = AppMainForm->Color;
   GetAppData(ColorDialog1->CustomColors,"CustomColors");
   StatsMinutes->Text = ini->Values[StatsMinUpdates];
   SortMailboxes->Checked = IniValue1orEmpty(MailboxesSorted);
   ShowBetaTest->Checked = IniValue1orEmpty(OpenBetaTestDialog);
   //DBcopies->Text = s(ini->Values[DatabaseCopies].ToIntDef(1));
   // receiving mail
   GetAppData(ReadMailHdrs->Lines,ReadMailHeaders);
   if (!ReadMailHdrs->Lines->Count) ReadMailHdrs->Lines->CommaText = ReadHdrs;
   ReadMailHdrs->Modified = false;
   CompactPgpSig->Checked = ini->Values[UseCompactPgpSig].ToIntDef(1);
   //attachments
   AttachDir->Text = ini->Values[AttachDirectory];
   if (AttachDir->Text.IsEmpty()) AttachDir->Text = AppDir+"Attachments\\";
   AutoDetachBox->Checked = IniValue1orEmpty(DetachAutoDetach);
   StripHTMLBox->Checked = IniValue1orEmpty(DetachStripHTML);
   // editor
   EdWrapWinBtn->Checked = IniValue1orEmpty(WordWrap);
   EdWrapNotBtn->Checked = !EdWrapWinBtn->Checked;
   // EdWrapShowBox->Checked = ini->Values[WordWrapShowBox].ToIntDef(0);
   // sending mail
   txt = ini->Values[SendWrapCharsCount];
   bool wrapchars = IniValue1orEmpty(SendWrapChars); //ni->Values[SendWrapChars].ToIntDef(0);
   bool wrapwin = ini->Values[SendWrapWin] == "1";
   bool wrapnot = ini->Values[SendWrapNot] == "1";

   if (wrapchars) wrapwin = wrapnot = false;
   if (wrapwin) wrapchars = wrapnot = false;
   if (wrapnot) wrapchars = wrapwin = false;

   SendWrapCharBtn->Checked = wrapchars;
   SendWrapCharEdit->Color = wrapchars ? clWindow : clBtnFace;
   SendWrapCharEdit->Text = txt.IsEmpty() ? AnsiString("65") : txt;
   if (!wrapchars) SendWrapCharEdit->Enabled = false;
   SendWrapWinBtn->Checked = wrapwin; //ini->Values[SendWrapWin].ToIntDef(0);
   SendWrapNotBtn->Checked = wrapnot; //ini->Values[SendWrapNot].ToIntDef(0);
   DontWrapQuotes->Checked = IniValue1orEmpty(DontWrapQuoted);//ini->Values[DontWrapQuoted].ToIntDef(1);

   SendChainLogMax->Text = s(ini->Values[ChainLogMax].ToIntDef(16));
   SendSMTPLogMax->Text  = s(ini->Values[SMTPLogMax].ToIntDef(16));
   SendDateHdrBox->Checked = ini->Values[SendDateHdr].ToIntDef(0);
   ReceivePOP3LogMax->Text = s(ini->Values[POP3LogMax].ToIntDef(16));
   RemailerErrChkLogMax->Text  = s(ini->Values[ErrChkLogMax].ToIntDef(16));
   RemailerTimeOut->Text = s(ini->Values[StatsTimeOut].ToIntDef(30));
   UpdateWizTimeOut->Text = s(ini->Values[UpdateWizTimeout].ToIntDef(60));
   Send2Dir->Text = ini->Values[Send2Directory];
   if (Send2Dir->Text.IsEmpty()) Send2Dir->Text = AppDir+"pool";
   DontSendBox->Checked = ini->Values[DontSendMail].ToIntDef(0);
   Warn2Disk->Checked = InfoDlgsValues->Values[Send2Directory]!="1";
   // ignore boxes
   IgnoreMixBox->Checked = ini->Values[IgnoreMix]=="1";
   IgnorePgpBox->Checked = ini->Values[IgnorePgp]=="1";
   IgnoreNymBox->Checked = ini->Values[IgnoreNyms]=="1";
   IgnorePop3Box->Checked = ini->Values[IgnorePop3]=="1";
   IgnoreNewsBox->Checked = ini->Values[IgnoreNews]=="1";
   // pgp
   AnsiString pub,sec,man,path,keys="pgpkeys.exe";
   SaveClearBox->Checked = ini->Values[SaveMsgClear]=="1";
   // keyrings
   pub = ini->Values[PgpPubRing].LowerCase();
   if (pub.IsEmpty() || !FileExists(pub)) pub = PgpPublicRing();
   PgpPublicKeyring->Text = pub;
   sec = ini->Values[PgpSecRing].LowerCase();
   if (sec.IsEmpty() || !FileExists(sec)) sec = PgpSecretRing();
   PgpSecretKeyring->Text = sec;
   // keyring manager -- handle obsolete pgpkeys.exe checkbox first
   if (ini->Values[UsePgpKeysExe]=="1" && (path=PgpPath())!="" && FileExists(path+keys))
      man = path+keys+" /s";
   if (!FileExists(NameNoParams(man))) man = ini->Values[PgpRingMan].LowerCase();
   if (!FileExists(NameNoParams(man))) man = "quicksilver.exe";
   //PgpRingManager->Text = man.LowerCase();
   pgpkeyringman = man.LowerCase();
   pgpbogussigndate = SIGNWITHINVALIDDATE;
   // pgp6
   AutoImportBox->Checked = HasPgp() && IniValue1orEmpty(Pgp6AutoImport);
   KeepPassMins->Text = ini->Values[KeepPasswordMin];
   if (KeepPassMins->Text.IsEmpty())KeepPassMins->Text = "0";
   AutoVerifyClear->Checked = ini->Values[AutoVerifyClearSigned]=="1";
   // nyms
   NymShowPopupBox->Checked = HasNyms() && IniValue1orEmpty(NymShowIntro);
   NymAutoDecryptBox->Checked = HasNyms() && IniValue1orEmpty(NymAutoDecrypt);
   GetAppData(NymCmdsEditor->Lines,NymCommandsKey);
   if (NymCmdsEditor->Lines->Text.IsEmpty()) NymCmdsEditor->Lines->CommaText = DefNymCmds;
   NymCmdsEditor->Modified = false;
   GetAppData(NymServersEditor->Lines,NymServersKey);
   if (NymServersEditor->Lines->Text.IsEmpty()) NymServersEditor->Lines->CommaText = NymServers;
   NymServersEditor->Modified = false;
   // cyberpunk remailers
   //EnableCpkBox->Checked = HasCpunk();
   EnableCpkBox->Visible = false;
   // init OpenPubring dialog
   AnsiString curpubring=pubkeyfile=PgpPublicRing();
   if (FileExists(curpubring))
   {
      OpenPubring->InitialDir = ExtractFilePath(curpubring);
      OpenPubring->FileName = ExtractFileName(curpubring);
   }
   OpenPubring->Filter = "Public Keyring Files (*.pkr;*.pubkr;*.pgp)|*.PKR; *.PUBKR; *.PGP|All Files (*.*)|*.*";
   // init OpenSecring dialog
   AnsiString cursecring=seckeyfile=PgpSecretRing();
   if (FileExists(cursecring))
   {
      OpenSecring->InitialDir = ExtractFilePath(cursecring);
      OpenSecring->FileName = ExtractFileName(cursecring);
   }
   OpenSecring->Filter = "Secret Keyring Files (*.skr;*.prvkr;*.pgp)|*.SKR; *.PVRKR; *.PGP|All Files (*.*)|*.*";
   // is pgp6 available ?
   if (HasPgpSdk())
   {
      PublicKeyring6->Caption = s(PgpPubringPkr()).LowerCase();
      SecretKeyring6->Caption = s(PgpSecringSkr()).LowerCase();
   }
   else
   {
      AutoImportBox->Enabled = false;
      AutoImportBox->Checked = false;
      PublicKeyring6->Enabled = false;
      SecretKeyring6->Enabled = false;
      ImportBtn->Enabled = false;
      Label7->Enabled = false;
      //Label13->Enabled = false;
      //UsePgpKeys->Enabled = false;
      //UsePgpKeys->Checked = false;
      AutoVerifyClear->Enabled = false;
      AutoVerifyClear->Checked = false;
   }
   // finish init
   PageControl1->ActivePage = TabSheet3;
   HelpBtn->Enabled = false; // remove when 'General' tab help is installed
   initcomplete = true;
   DontSendBoxClick(NULL);
}
//---------------------------------------------------------------------------
bool __fastcall FileNamesEqual(AnsiString firstname, AnsiString othername)
{
   AnsiString first=GetShortFileName(firstname).LowerCase();
   AnsiString other=GetShortFileName(othername).LowerCase();
   return first==other;
}
//---------------------------------------------------------------------------
bool __fastcall TOptionsDlg::CheckPGPFilenameColision()
{
   AnsiString
      PGPpub = PgpPublicKeyring->Text,
      QDKpub = PublicKeyring6->Caption,
      PGPsec = PgpSecretKeyring->Text,
      QDKsec = PublicKeyring6->Caption;

   if (FileNamesEqual(PGPpub,QDKpub) || FileNamesEqual(PGPsec,QDKsec))
   {
      if (MsgBoxHwnd(Handle,
        s("You have a conflict in filenames. It appears you have PGP 6\n")+
        s("installed and the QuickSilver keyrings specified are the same\n")+
        s("as your PGP 6 keyrings. You must specify separate files.\n\n")+
        s("How about I put the QS keyrings in the QS home directory?\n"),
        s("PGP Filename Collision!"),
         MB_OKCANCEL)==IDCANCEL)
      {
         return false;
      }
      PgpPublicKeyring->Text = AppDir+ExtractFileName(PublicKeyring6->Caption);
      PgpSecretKeyring->Text = AppDir+ExtractFileName(SecretKeyring6->Caption);
      PgpCheckPGP6NeedsUpdate();
   }
   return true;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk)
   {
      if (HasPgpSdk())
      {
         if (!CheckPGPFilenameColision())
         {
            CanClose = false;
            return;
         }
      }
      if (SendSMTPLogMax->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Maximum SMTP Log entries must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = TabSheet2;
         ActiveControl = SendSMTPLogMax;
         CanClose = false;
         return;
      }
      if (SendChainLogMax->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Maximum CHAIN Log entries must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = TabSheet2;
         ActiveControl = SendChainLogMax;
         CanClose = false;
         return;
      }
      if (ReceivePOP3LogMax->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Maximum POP3 Log entries must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = RecSheet;
         ActiveControl = ReceivePOP3LogMax;
         CanClose = false;
         return;
      }
      if (RemailerErrChkLogMax->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Maximum ERROR CHECK Log entries must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = TabSheet5;
         ActiveControl = RemailerErrChkLogMax;
         CanClose = false;
         return;
      }
      if (RemailerTimeOut->Text.ToIntDef(-1)<0)
      {
         MsgBoxHwnd(Handle,
            s("Download TIMEOUT seconds must be an integer value greater\n")+
            s("than or equal to 0."),
            s("Data Error"),
            MB_OK
         );
         PageControl1->ActivePage = TabSheet5;
         ActiveControl = RemailerTimeOut;
         CanClose = false;
         return;
      }
      Hide();
      SaveIni();
      delete ini;
   }
   if (cpunkchange)
   {
      if (HasCpunk()) QSMainWin->SetCyberpunk();
      else QSMainWin->SetNoCyberpunk();
   }
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::SaveIni()
{
   // general
   AnsiString qm=QuoteMarkEdit->Text;
   if (qm[1]=='\"') qm = qm.SubString(2,16);
   if (qm[qm.Length()]=='\"') qm.SetLength(qm.Length()-1);
   ini->Values[QuoteMarks] = qm;
   ini->Values[StatsMinUpdates] = StatsMinutes->Text;
   ini->Values[WorkSpaceColor] = AnsiString(ColorBox->Color);
   ini->Values[MailboxesSorted] = SortMailboxes->Checked ? "1":"0";
   ini->Values[OpenBetaTestDialog] = ShowBetaTest->Checked ? "1":"0";
   //ini->Values[DatabaseCopies] = DBcopies->Text;
   // receiving mail
   if (ReadMailHdrs->Modified) PutAppData(ReadMailHeaders,ReadMailHdrs->Lines);
   ini->Values[UseCompactPgpSig] = CompactPgpSig->Checked ? "1":"0";
   // attachments
   ini->Values[AttachDirectory] = AttachDir->Text;
   ini->Values[DetachAutoDetach] = AutoDetachBox->Checked ? "1":"0";
   ini->Values[DetachStripHTML] = StripHTMLBox->Checked ? "1":"0";
   //if (AppMainForm->Color != ColorBox->Color)
   AppMainForm->Color  = ColorBox->Color;
   TStrings *colors = ColorDialog1->CustomColors;
   int p; while ((p=colors->IndexOf("FFFFFFFF"))>=0) colors->Delete(p);
   PutAppData("CustomColors",ColorDialog1->CustomColors);
   // editor
   ini->Values[WordWrap] = EdWrapWinBtn->Checked?"1":"0";
// ini->Values[WordWrapShowBox] = EdWrapShowBox->Checked?"1":"0";
   // sending mail
   ini->Values[SendWrapChars] = SendWrapCharBtn->Checked?"1":"0";
   int count = SendWrapCharEdit->Text.ToIntDef(0);
   ini->Values[SendWrapCharsCount] = AnsiString(count<16?16:count);
   ini->Values[SendWrapWin] = SendWrapWinBtn->Checked?"1":"0";
   ini->Values[SendWrapNot] = SendWrapNotBtn->Checked?"1":"0";
   ini->Values[SendDateHdr] = SendDateHdrBox->Checked?"1":"0";
   ini->Values[DontWrapQuoted] = DontWrapQuotes->Checked?"1":"0";
   ini->Values[ChainLogMax] = SendChainLogMax->Text;
   ini->Values[SMTPLogMax] = SendSMTPLogMax->Text;
   ini->Values[POP3LogMax] = ReceivePOP3LogMax->Text;
   ini->Values[ErrChkLogMax] = RemailerErrChkLogMax->Text;
   ini->Values[StatsTimeOut] = RemailerTimeOut->Text;
   ini->Values[UpdateWizTimeout] = UpdateWizTimeOut->Text;
   ini->Values[Send2Directory] = Send2Dir->Text;
   ini->Values[DontSendMail] = DontSendBox->Checked?"1":"0" ;
   InfoDlgsValues->Values[Send2Directory] = Warn2Disk->Checked ? "":"1";
   // ignore
   ini->Values[IgnoreMix] = IgnoreMixBox->Checked ? "1":"0";
   ini->Values[IgnorePgp] = IgnorePgpBox->Checked ? "1":"0";
   ini->Values[IgnoreNyms] = IgnoreNymBox->Checked ? "1":"0";
   ini->Values[IgnorePop3] = IgnorePop3Box->Checked ? "1":"0";
   ini->Values[IgnoreNews] = IgnoreNewsBox->Checked ? "1":"0";
   // pgp
   ini->Values[SaveMsgClear] = SaveClearBox->Checked ? "1":"0";
   ini->Values[PgpPubRing] = PgpPublicKeyring->Text;
   ini->Values[PgpSecRing] = PgpSecretKeyring->Text;
   ini->Values[PgpRingMan] = pgpkeyringman; //PgpRingManager->Text;
   ini->Values[UsePgpKeysExe] = "0"; // obsolete //UsePgpKeys->Checked ? "1":"0";
   ini->Values[Pgp6AutoImport] = AutoImportBox->Checked ? "1":"0";
   ini->Values[KeepPasswordMin] = s(KeepPassMins->Text.ToIntDef(0));
   ini->Values[AutoVerifyClearSigned] = AutoVerifyClear->Checked ? "1":"0";
   ini->Values[SignWithInvalidDate] = pgpbogussigndate ? "1":"0";
   // nyms
   ini->Values[NymShowIntro] = NymShowPopupBox->Checked ? "1":"0";
   ini->Values[NymAutoDecrypt] = NymAutoDecryptBox->Checked ? "1":"0";
   if (NymCmdsEditor->Modified) PutAppData(NymCommandsKey,NymCmdsEditor->Lines);
   if (NymServersEditor->Modified) PutAppData(NymServersKey,NymServersEditor->Lines);
   // store data
   PutAppData(AppIniValues,ini);

   if (IgnoreNymBox->Checked) ((TForm*)Owner)->Perform(WM_IGNOREPLUGIN,nymplug,NULL);
   if (IgnorePgpBox->Checked) ((TForm*)Owner)->Perform(WM_IGNOREPLUGIN,pgpplug,NULL);
   if (IgnoreMixBox->Checked) ((TForm*)Owner)->Perform(WM_IGNOREPLUGIN,mixplug,NULL);
   if (IgnorePop3Box->Checked) ((TForm*)Owner)->Perform(WM_IGNOREPLUGIN,popplug,NULL);
   if (IgnoreNewsBox->Checked) ((TForm*)Owner)->Perform(WM_IGNOREPLUGIN,newplug,NULL);
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::SendWrapBtnClick(TObject *Sender)
{
   bool enabled = SendWrapCharBtn->Checked;
   SendWrapCharEdit->Color = enabled ? clWindow:clBtnFace;
   SendWrapCharEdit->Enabled = enabled;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::SendWrapCharEditExit(TObject *Sender)
{
  if (SendWrapCharEdit->Text.ToIntDef(0)<16)
      SendWrapCharEdit->Text = "16";
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::StatsMinutesExit(TObject *Sender)
{
   if (StatsMinutes->Text.ToIntDef(-1)<0)
      StatsMinutes->Text = "0";
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::ColorBtnClick(TObject *Sender)
{
   ColorDialog1->Color = AppMainForm->Color;
   if (ColorDialog1->Execute() && AppMainForm->Color!=ColorDialog1->Color)
   {
       ColorBox->Color = ColorDialog1->Color;
       ApplyColorBtn->Enabled = true;
   }
   else
       ApplyColorBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::ApplyColorBtnClick(TObject *Sender)
{
   AppMainForm->Color = ColorBox->Color;
   ::InvalidateRect(AppMainForm->ClientHandle,NULL,true);
   ApplyColorBtn->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::PageControl1Change(TObject *Sender)
{
   TTabSheet *active = PageControl1->ActivePage;
   if (active==PgpSheet) ActiveControl = PgpPublicKeyring;
   if (active==EdSheet ) ActiveControl = EdWrapGroup;
   HelpBtn->Enabled = active==PgpSheet || active==EdSheet || active==RecSheet;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::BrowsePubringClick(TObject *Sender)
{
   if (OpenPubring->Execute())
      PgpPublicKeyring->Text = OpenPubring->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::BrowseSecringClick(TObject *Sender)
{
   if (OpenSecring->Execute())
      PgpSecretKeyring->Text = OpenSecring->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::BrowseManagerClick(TObject *Sender)
{
   if (OpenKeyManager->Execute())
      PgpRingManager->Text = OpenKeyManager->FileName;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::HelpBtnClick(TObject *Sender)
{
   AnsiString sections;
   TTabSheet *active = PageControl1->ActivePage;
   if (active==EdSheet)
   {
      sections = "OptionsEditor";
      OpenHelp(sections,"Editor Options","",this);
      return;
   }
   if (active==PgpSheet)
   {
      sections = "OptionsPgp\nOptionsPgpImport";
      OpenHelp(sections,"PGP Keyrings","",this);
      return;
   }
   if (active==RecSheet)
   {
      sections = "Options";
      OpenHelp(sections,"Receiving Mail","",this);
      return;
   }
}
//---------------------------------------------------------------------------
AnsiString num(int val)
{
   AnsiString anum = AnsiString(val);
   while (anum.Length()<2) anum = " "+anum;
   return anum;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::ResetBtnClick(TObject *Sender)
{
   PgpPublicKeyring->Text = pubkeyfile;
   PgpSecretKeyring->Text = seckeyfile;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::ImportBtnClick(TObject *Sender)
{
   if (PgpPublicKeyring->Text.Trim().IsEmpty() || PgpSecretKeyring->Text.Trim().IsEmpty())
   {
      MsgBoxHwnd(Handle,
         "You have not specified the pathnames of your QS keyrings!",
         "PGP Keyring Error",
          MB_OK
      );
      return;
   }
   AnsiString pubring=PublicKeyring6->Caption,secring=SecretKeyring6->Caption;
   if (MsgBoxHwnd(Handle,"Import PGP6 keys now?","Confirm",MB_OKCANCEL)==IDOK)
   {
      SaveIni();
      TMemoryStream *ms = new TMemoryStream();
      if (!FileExists(PgpPublicKeyring->Text))
      {
         AnsiString filename = PgpPublicKeyring->Text;
         AnsiString dir = ExtractFilePath(filename);
         if (!DirectoryExists(dir)) ForceDirectories(dir);
         if (!DirectoryExists(dir))
         {
            MsgBoxHwnd(Handle,
               "Unable to create directory: "+dir,
               "File Specification",
                MB_OK
            );
            return;
         }
         try
         {
            ms->SaveToFile(filename);
            PutAppIni(PgpPubRing,filename);
         }
         catch (...)
         {
            MsgBoxHwnd(Handle,
               "Unable to create keyring: "+filename,
               "Filename Error",
                MB_OK
            );
            return;
         }
      }
      if (!FileExists(PgpSecretKeyring->Text))
      {
         AnsiString filename = PgpSecretKeyring->Text;
         AnsiString dir = ExtractFilePath(filename);
         if (!DirectoryExists(dir)) ForceDirectories(dir);
         if (!DirectoryExists(dir))
         {
            MsgBoxHwnd(Handle,
               "Unable to create directory: "+dir,
               "File Specification",
                MB_OK
            );
            return;
         }
         try
         {
            ms->SaveToFile(filename);
            PutAppIni(PgpSecRing,filename);
         }
         catch (...)
         {
            MsgBoxHwnd(Handle,
               "Unable to create keyring: "+filename,
               "Filename Error",
                MB_OK
            );
            return;
         }
      }
      PublicKeyring6->Caption = "working...";
      SecretKeyring6->Caption = "";
      AppProcessMessages();
      PgpUpdateQSKeyrings();
      Sleep(200);
      PublicKeyring6->Caption = "Keyrings updated!";
      SecretKeyring6->Caption = "";
   }
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::EnableCpkBoxClick(TObject *Sender)
{
   if (HasPgp() && EnableCpkBox->Checked && initcomplete)
   {

      if (MsgBoxHwnd(Handle,
         s("Cypherpunk features are still under construction.\n\n")+
         s("Enabling them now will make various cypherpunk items\n")+
         s("visible within QuickSilver, but they have no use."),
         s("Cypherpunk Remailers"),
         MB_OKCANCEL)==IDCANCEL)
      {
         EnableCpkBox->Checked = false;
         return;
      }
   }
   cpunkchange = true;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::UsePgpKeysClick(TObject *Sender)
{
 /*if (UsePgpKeys->Checked)
   {
      if (BingBox(this,
         s("\nBy ticking this checkbox, you may be changing your QS keyring\n")+
         s("strategy. Please read before continuing!\n\n")+
         s("If your QS Personal PGP keyrings differ from your main PGP keyrings\n")+
         s("in any way, you will NOT want to use the main PGPkeys program for\n")+
         s("maintaining your QS keyrings. Using the built-in QS keyring manager,\n")+
         s("you can selectively import only some of the keys in your main keyrings,\n")+
         s("if you wish. You can also keep keys on your QS keyrings that are not\n")+
         s("on your main keyrings.\n\n")+
         s("If you choose to use the PGPkeys program, your QS PGP keyrings\n")+
         s("will be, for all practical purposes, the exact same as your main keyrings\n")+
         s("Any differences between the 2 will be lost on the first update after\n")+
         s("modifying your main PGP keyrings.\n\n")+
         s("One is more seamless, the other more flexible."),
         s("Using PGPkeys for Keyring Manager"),
         MB_OKCANCEL
      )==IDCANCEL)
      {
         UsePgpKeys->Checked = false;
      }
   }*/
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::ClearCacheBtnClick(TObject *Sender)
{
   PgpClearPassphraseCache();
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::IgnoreMixBoxClick(TObject *Sender)
{
   if (IgnoreMixBox->Checked)
   {
      IgnorePgpBox->Checked = true;
      IgnorePgpBox->Enabled = false;
      IgnoreNymBox->Checked = true;
      IgnoreNymBox->Enabled = false;
   }
   else
   {
      IgnorePgpBox->Enabled = true;
      IgnoreNymBox->Enabled = false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::IgnorePgpBoxClick(TObject *Sender)
{
   if (IgnorePgpBox->Checked)
   {
      IgnoreNymBox->Checked = true;
      IgnoreNymBox->Enabled = false;
   }
   else
   {
      IgnoreNymBox->Enabled = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::DontSendBoxClick(TObject *Sender)
{
   if (DontSendBox->Checked)
   {
      Warn2Disk->Enabled = true;
      Send2Dir->Enabled = true;
      Send2Dir->Color = clWindow;
      Send2Dir->Font->Color = clWindowText;
      Browse2Dir->Enabled = true;
      Label29->Enabled=true;
   }
   else
   {
      Warn2Disk->Enabled = false;
      Send2Dir->Enabled = true;
      Send2Dir->Color = Color;
      Send2Dir->Font->Color = Color;
      Browse2Dir->Enabled = false;
      Label29->Enabled=false;
   }
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::Browse2DirClick(TObject *Sender)
{
   AnsiString dir=GetDirectoryPath(this,"");
   if (!dir.IsEmpty() && dir!="cancel") Send2Dir->Text = dir;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::Button1Click(TObject *Sender)
{
   AnsiString attachdir = GetAttachmentDirectory(this,AttachDir->Text);
   if (!attachdir.IsEmpty() && DirectoryExists(attachdir))
      AttachDir->Text = attachdir;
}
//---------------------------------------------------------------------------
void __fastcall TOptionsDlg::AdvancedBtnClick(TObject *Sender)
{
   EditAdvancedPGPOptions(this,pgpkeyringman,pgpbogussigndate);
}
//---------------------------------------------------------------------------
