/*
*  PackDlg.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "PackDlg.h"
#include "HelpDlgs.h"
#include "WipeDlgs.h"
#include "Global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TPackForm *PackForm;
#define WORKING " working..."
//---------------------------------------------------------------------------
void __fastcall PackDatabase()
{
   PackForm = new TPackForm(Application->MainForm);
   PackForm->ShowModal();
// PackForm->Execute();
   delete PackForm;
}
//---------------------------------------------------------------------------
__fastcall TPackForm::TPackForm(TComponent* Owner)
  : TForm(Owner)
{
   // Center in Main Window
   TForm *Main = Application->MainForm;
   Top = Main->Top+((Main->Height-Height)/2);
   Left = Main->Left+((Main->Width-Width)/2);
   // init
   TmpFile = new TMemoryStream();
   TmpDat = ChangeFileExt(AppDat,".db_");
   if (FileExists(TmpDat)) DeleteFile(TmpDat.c_str());
   started = false;
   packed = false;
   cancel = false;
   items = 0;
   errs = 0;
}
//---------------------------------------------------------------------------
void __fastcall TPackForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk)
   {
      AnsiString appdat = ExtractFileName(AppDat);
      Caption = " wiping "+appdat+"..."; AppProcessMessages(); Sleep(500);
      zapfile(AppDat,7); // wipe QS.dbc then rename packed tmp file
      Caption = ""; AppProcessMessages(); Sleep(300);
      Caption = " saving "+appdat+"..."; AppProcessMessages(); Sleep(500);
      //tmpfile is in memory not on disk
      //TmpFile->SaveToFile(AppDat); // saving to disk
      rename(TmpDat.c_str(),AppDat.c_str());
   }
   if (FileExists(TmpDat))
   {
      Caption = " wiping temporary file...";
      zapfile(TmpDat,7);
   }
}
//---------------------------------------------------------------------------
__fastcall TPackForm::~TPackForm()
{
   memset(TmpFile->Memory,'\0',TmpFile->Size);
   delete TmpFile;
}
//---------------------------------------------------------------------------
void __fastcall TPackForm::FormShow(TObject *Sender)
{
   //Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TPackForm::Execute()
{
   ShowModal();
}
//---------------------------------------------------------------------------
void show(TStringList *list)
{
   TStringList *tmp = new TStringList();
   tmp->Add("start");
   for (int i=0; i<list->Count; i++)
      tmp->Add(list->Strings[i]+"   "+AnsiString((int)list->Objects[i]));
   tmp->Add("finish");
   sm(tmp->Text);
   delete tmp;
}
//---------------------------------------------------------------------------
void __fastcall TPackForm::Display(AnsiString &TextLine)
{
   ProgressLog->Lines->Add(TextLine);
   ActiveControl = Panel1;
}
//---------------------------------------------------------------------------
void __fastcall TPackForm::PackIndex(AnsiString &path, TFMindex *frParent, TFMindex *toParent)
{
   if (cancel) return;
   AnsiString cap = path+"...";
   if (frParent && !frParent->name.IsEmpty())
         cap = frParent->name+"\\"+cap;
   Label1->Caption = cap;
   AppProcessMessages();

   int type;
   AnsiString name,thepath;
   TDataBuf *buf = new TDataBuf();
   TFMindex *frIndex = new TFMindex(frFileMan,path,frParent);
   TFMindex *toIndex = new TFMindex(toFileMan,path,toParent);
   //====================================================
   frIndex->Sorted = true;
   for (int i=0; i<frIndex->Count; i++)
   {
      thepath = path;
      name = frIndex->Strings[i];
      if ((type=frIndex->GetType(name))<0) continue;
      if (frParent && !frParent->name.IsEmpty())
         thepath = frParent->name+"\\"+thepath;
      AppProcessMessages();

      if (type==ISINDEX)
      {
         PackIndex(name,frIndex,toIndex);
         AppProcessMessages();
         if (cancel) break;
      }
      else
      {
         if (!frIndex->GetBinary(name,buf))
         {
            Display("Read Error: "+thepath);
            errs++; continue;
         }
         if (!toIndex->PutBinary(name,buf,false))
         {
            Display("Write Error: "+thepath);
            errs++;
         }
         items++; Label2->Caption = s(items)+" items";
         if (cancel) break;
      }

      AppProcessMessages();
      if (cancel) break;
   }
   toIndex->Save();
   //========================
   delete toIndex;
   delete frIndex;
   delete buf;
}
//---------------------------------------------------------------------------
void __fastcall TPackForm::Pack()
{
   Display(WORKING);
   OkBtn->Enabled = false;
   HelpBtn->Enabled = false;
   frFileMan = new TFileManager(AppDat);
   toFileMan = new TFileManager(TmpDat);
  //===================================
   PackIndex("",NULL,NULL); // recurse until complete
  //=============================
   delete toFileMan;
   delete frFileMan;
   HelpBtn->Enabled = true;
   CancelBtn->Enabled = true;
   if (cancel)
   {
      Label1->Caption = "Pack Cancelled";
      OkBtn->Caption = "Ok";
      OkBtn->Enabled = true;
   }
   else
   {
      Label1->Caption = "Pack Complete";
      OkBtn->Caption = "Ok";
      OkBtn->Enabled = true;
      packed = true;
   }
   if (ProgressLog->Lines->Strings[0]==WORKING); ProgressLog->Lines->Delete(0);
   Display(" "+s(errs)+" errors");
   MyBeep(MB_OK);
}
//---------------------------------------------------------------------------
void __fastcall TPackForm::OkBtnClick(TObject *Sender)
{
   if (OkBtn->Caption=="Pack")
   {
      ProgressLog->Clear(); AppProcessMessages(); Sleep(200);
      ActiveControl = ProgressLog;
      started = true;
      Pack();
      return;
   }
   else ModalResult = mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TPackForm::CancelBtnClick(TObject *Sender)
{
   if (started && !packed && !cancel)
   {
      if(MsgBoxHwnd(Handle,"Cancel database packing operation?",
         "Confirm",MB_YESNO)==IDYES)
      {
         ActiveControl = ProgressLog;
         cancel = true;
         return;
      }
      ActiveControl = ProgressLog;
   }
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TPackForm::HelpBtnClick(TObject *Sender)
{
   OpenHelp("Utility","Packing QS.dbc","",this);
}
//---------------------------------------------------------------------------
