/*
*  Pool.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Pool.h"
#include "fileman.h"
#include "headman.h"
//---------------------------------------------------------------------------
int __fastcall QSPoolNext()
{
   int next = GetAppIni("QSPoolNext","").ToIntDef(0)+1;
   PutAppIni("QSPoolNext",s(next));
   return next;
}
//---------------------------------------------------------------------------
int __fastcall QSPoolCount()
{
   TStringList *pool = new TStringList();
   GetAppData(pool,QSPoolKey);
   int count = pool->Count;
   delete pool;
   return count;
}
//---------------------------------------------------------------------------
int __fastcall QSPoolAdd(TStrings *Msg, AnsiString &Name)
{
   PutAppData(QSPoolKey+PS+Name,Msg);
   return QSPoolCount();
}
//---------------------------------------------------------------------------
int __fastcall QSPoolRemove(AnsiString &Name)
{
   PutAppData(QSPoolKey+PS+Name,NULL);
   return QSPoolCount();
}
//---------------------------------------------------------------------------
void __fastcall QSPoolClear()
{
   TStringList *pool = new TStringList();
   GetAppData(pool,QSPoolKey);
   for (int i=0; i<pool->Count; i++)
      PutAppData(QSPoolKey+PS+pool->Strings[i],NULL);
   PutAppData(QSPoolKey,NULL);
   delete pool;
}
//---------------------------------------------------------------------------
int __fastcall QSPoolGet(TStrings *Msg, AnsiString &Name, bool Remove)
{
   GetAppData(Msg,QSPoolKey+PS+Name);
   if (Remove) QSPoolRemove(Name);
   return QSPoolCount();
}
//---------------------------------------------------------------------------
int __fastcall QSPoolHeaderToClearText(TStrings *msg)
{
   int ClearText;
   THeaderManager *hm = new THeaderManager(msg);
   if ((ClearText=hm->GetDat(ClrTextHdr).ToIntDef(0))>0)
      hm->Delete(ClrTextHdr);
   delete hm;
   return ClearText;
}
//---------------------------------------------------------------------------
bool __fastcall QSPoolHeaderToClearText(int &ClearText, TStrings *msg)
{
   THeaderManager *hm = new THeaderManager(msg);
   ClearText=hm->GetDat(ClrTextHdr).ToIntDef(0);
   hm->Delete(ClrTextHdr);
   return ClearText>0;
}
//---------------------------------------------------------------------------
bool  __fastcall QSPoolClearTextToHeader(TStrings *msg, int ClearText)
{
   if (ClearText>0) msg->Insert(0,ClrTextHdr+s(ClearText));
   return ClearText>0;
}
//---------------------------------------------------------------------------
