/*
*  RemailerCfgDlgs.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "RemailerCfgDlgs.h"
#include "ClipReply.h"
#include "HelpDlgs.h"
#include "msgwins.h"
#include "fileman.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TRemailerCfgDlg *RemailerCfgDlg;
//---------------------------------------------------------------------------
void __fastcall PrepareRemailerConfigRequests(TForm *Owner, TStrings *remailers,
   AnsiString current)
{
   RemailerCfgDlg = new TRemailerCfgDlg(Owner);
   RemailerCfgDlg->RemsBox->Items->AddStrings(remailers);
   RemailerCfgDlg->RemsBox->Text = current;
   RemailerCfgDlg->ShowModal();
   delete RemailerCfgDlg;
}
//---------------------------------------------------------------------------
__fastcall TRemailerCfgDlg::TRemailerCfgDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,Owner);
}
//---------------------------------------------------------------------------
void __fastcall TRemailerCfgDlg::SomeBoxChange(TObject *Sender)
{
   OkBtn->Enabled = ValidAddress() && ConfigBoxChecked();
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerCfgDlg::ConfigBoxChecked()
{
   return StatsBox->Checked || ConfigBox->Checked || HelpBox->Checked || KeyBox->Checked;
}
//---------------------------------------------------------------------------
bool __fastcall TRemailerCfgDlg::ValidAddress()
{
   AnsiString dom,addr=RemsBox->Text;
   int pos = addr.Pos("@");
   if (pos>1)
   {
      dom = addr.SubString(pos+1,256);
      if ((pos=dom.Pos("."))>1 && pos<dom.Length())
         return true;
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerCfgDlg::MakeMessage(TStrings *message, AnsiString &subject)
{
   AnsiString addrs = RemsBox->Text;
   TStringList *msg = new TStringList(); msg->Text = message->Text;
   for (int i=0; i<msg->Count; i++)
   {
      AnsiString tmpstr = msg->Strings[i];
      if (tmpstr.Pos("To:")==1) msg->Strings[i] = "To: "+addrs;
      if (tmpstr.Pos("Subject:")==1) msg->Strings[i] = "Subject: "+subject;
      if (tmpstr.IsEmpty()) break;
   }
   PutMessageOnDesktop(AppMainForm,msg);
   delete msg;
}
//---------------------------------------------------------------------------
void __fastcall TRemailerCfgDlg::GenerateConfigMessages()
{
   AnsiString TempName;
   TStringList *temps = new TStringList();
   GetAppData(temps,UserTemplates);
   if (temps->IndexOf("config-request")>=0) TempName = "config-request";
   if (TempName.IsEmpty()) TempName =
       GetTemplateName("Select Template For Remailer Config-Request",modeMessage);
   if(!TempName.IsEmpty())
   {
      TStringList *Template = new TStringList();
      AnsiString cap = Caption; Caption = "Generating...";
      GetAppData(Template,UserTemplates+PS+TempName);
      if (ConfigBox->Checked) MakeMessage(Template,"remailer-config");
      if (KeyBox->Checked) MakeMessage(Template,"remailer-key");
      if (HelpBox->Checked) MakeMessage(Template,"remailer-help");
      if (StatsBox->Checked) MakeMessage(Template,"remailer-stats");
      AppMainForm->Perform(WM_SHOWSTATUS,0,(LPARAM)"Config-request(s) created");
      Sleep(200); Caption = cap;
      ModalResult = mrOk;
      delete Template;
   }
}
//---------------------------------------------------------------------------
void __fastcall TRemailerCfgDlg::OkBtnClick(TObject *Sender)
{
   GenerateConfigMessages();
}
//---------------------------------------------------------------------------
void __fastcall TRemailerCfgDlg::HelpBtnClick(TObject *Sender)
{
   OpenHelp("RemailerConfig","Remailer Config-Request Dialog","");
}
//---------------------------------------------------------------------------
