/*
*  SMTPPassDlgs.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "SMTPPassDlgs.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TSMTPPassDlg *SMTPPassDlg;
//---------------------------------------------------------------------------
bool __fastcall SMTPGetHostUidPassword(TForm *Owner, AnsiString &Host,
   AnsiString &Userid, AnsiString &Password)
{
   SMTPPassDlg = new TSMTPPassDlg(Owner);
   SMTPPassDlg->Password->Text = Password;
   SMTPPassDlg->Userid->Text = Userid;
   if (!Host.IsEmpty())
   {
      SMTPPassDlg->ActiveControl = SMTPPassDlg->Userid;
      SMTPPassDlg->Caption = "Enter User ID and Password";
      SMTPPassDlg->Host->ParentColor = true;
      SMTPPassDlg->Host->ReadOnly = true;
      SMTPPassDlg->Host->Text = Host;
   }
   SMTPPassDlg->ShowModal();
   bool ok = SMTPPassDlg->ModalResult==mrOk;
   Password = SMTPPassDlg->Password->Text;
   Userid = SMTPPassDlg->Userid->Text;
   Host = SMTPPassDlg->Host->Text;
   delete SMTPPassDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TSMTPPassDlg::TSMTPPassDlg(TComponent* Owner)
	: TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner);
}
//---------------------------------------------------------------------------
void __fastcall TSMTPPassDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrCancel && DataModified())
   {
      switch(MsgDlg(this,
        "Your host information is modified.\n\nSave your changes?",
        "Confirm",MB_YESNOCANCEL))
      {
         case IDYES: ModalResult = mrOk; break;
         case IDCANCEL: CanClose = false;
      }
   }
   /*if (ModalResult==mrOk && !Host->Text.Pos("."))
   {
      MsgDlg(this,
         s("The host name specified is not a valid host name. It must\n")+
         s("contain at least 1 period ('.') Yours has none at all !"),
         s("Host Name Error"), MB_OK);
      CanClose = false;
      return;
   }*/
   if (ModalResult==mrOk && DataIsEmpty())
   {
      MsgDlg(this,
         "Host, User ID and Password are all required fields!",
         "Data Error",MB_OK);
      CanClose = false;
      return;
   }
}
//---------------------------------------------------------------------------
bool __fastcall TSMTPPassDlg::DataModified()
{
   return Host->Modified || Userid->Modified || Password->Modified;
}
//---------------------------------------------------------------------------
bool __fastcall TSMTPPassDlg::DataIsEmpty()
{
   return Host->Text.IsEmpty() || Userid->Text.IsEmpty() || Password->Text.IsEmpty();
}
//---------------------------------------------------------------------------
void __fastcall TSMTPPassDlg::HideTypeClick(TObject *Sender)
{
   if (HideType->Checked) Password->PasswordChar = '*';
   else Password->PasswordChar = '\0';
}
//---------------------------------------------------------------------------
void __fastcall TSMTPPassDlg::FormShow(TObject *Sender)
{
   Password->Modified = false;
   Userid->Modified = false;
   Host->Modified = false;
}
//---------------------------------------------------------------------------
