/*
*  UPDUnzipDlg.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "UPDUnzipDlg.h"
#include "console.h"
#include "global.h"
#include "fileman.h"
#include "QSver.h"
#include "pop3mail.h"
#include "pgpmail.h"
#include "nymmail.h"
#include "newsmail.h"
#include "wipedlgs.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TUPDunzipForm *UPDunzipForm;
//---------------------------------------------------------------------------
bool __fastcall UnzipQSPlugins(TForm *Owner, AnsiString &zipfile, bool &runQS)
{
   UPDunzipForm = new TUPDunzipForm((TComponent*)Owner,UnzipApp,zipfile);
   bool ok=UPDunzipForm->ShowModal()==mrOk;
   runQS = UPDunzipForm->RunQSBox->Checked;
   delete UPDunzipForm;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TUPDunzipForm::TUPDunzipForm(TComponent* Owner) : TForm(Owner)
{
}
//---------------------------------------------------------------------------
__fastcall TUPDunzipForm::TUPDunzipForm(TComponent* Owner, const AnsiString &UnZipper,
   AnsiString &PluginZip) : TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner);
   output = new TStringList();
   pluginzip = PluginZip;
   unzipper = UnZipper;
   Memo1->Clear();
}
//---------------------------------------------------------------------------
bool __fastcall TUPDunzipForm::Execute(AnsiString &Unzipper, AnsiString &PluginZip)
{
   unzipper = Unzipper;
   pluginzip = PluginZip;
   return ShowModal()==mrOk;
}
//---------------------------------------------------------------------------
void __fastcall TUPDunzipForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ok) MyBeep(MB_OK); else MyBeep(MB_ICONHAND);
   if (FileExists(unzipper)) zapfile(unzipper,1);
   delete output;
}
//---------------------------------------------------------------------------
void __fastcall TUPDunzipForm::FormShow(TObject *Sender)
{
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TUPDunzipForm::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   Memo1->Lines->Add("Running setup...");
   if (hPopLib)
   {
      FreeLibrary(hPopLib);
      hPopLib = NULL;
   }
   if (hPgpLib)
   {
      PgpShutDown();
      FreeLibrary(hPgpLib);
      hPgpLib = NULL;
   }
   if (hNymLib)
   {
      NymShutDown();
      FreeLibrary(hNymLib);
      hNymLib = NULL;
   }
   if (hNntpLib)
   {
      if (FindWindow("QSNewsWin",""))
      {
         MsgDlg(this,
            "I see you have QSnews open. Please close QSnews and begin again.",
            "Update Problem",MB_OK);
         return;
      }
      //FreeLibrary(hNewsLib); //can't use this, news not dll
      hNntpLib = NULL;
   }
   ok = UnpackZipTools() && UnzipPlugins();
   Memo1->Lines->Add(ok ? "Installation success!":"Install failed!");
   RunQSBox->Enabled = true;
   OkBtn->Enabled = true;
}
//---------------------------------------------------------------------------
bool __fastcall TUPDunzipForm::UnpackZipTools()
{
   Memo1->Lines->Add("Preparing unzip tool");
   SetCurrentDirectory(AppDir.c_str());
   TDataBuf *buf = new TDataBuf();
   GetAppBinary(DatExePath+PS+unzipper,buf,AppIni);
   bool ok = buf->length>0;
   if (ok) buf->SaveToFile(unzipper);
   else
   {
      Memo1->Lines->Add("Install failed!");
      Memo1->Lines->Add("Problem getting unzip tool from "+AppIni);
   }
   delete buf;
   return ok;
}
//---------------------------------------------------------------------------
bool __fastcall TUPDunzipForm::UnzipPlugins()
{
   if ( unzipper.IsEmpty() || !FileExists(unzipper )) return false;
   if (pluginzip.IsEmpty() || !FileExists(pluginzip)) return false;

   AnsiString thefile,thedir=AddBackslash(AppDir);
   // get pre-existing filenames
   TStringList *prev = new TStringList();
   GetFilenames(prev,thedir+"*.*");
   for (int i=0; i<prev->Count; i++)
      prev->Strings[i] = prev->Strings[i].LowerCase();
   // create stringlist and load existing uninst.dat
   TStringList *uninstdat = new TStringList();
   uninstdat->Sorted = true;
   uninstdat->Duplicates = dupIgnore;
   if (FileExists(thedir+UninstDat))
      uninstdat->LoadFromFile(thedir+UninstDat);
   int beforecount = uninstdat->Count;

   bool ok=true;
   Memo1->Lines->Add("Unzipping plugins...");
   DWORD rc = RunConsoleApp(unzipper+" -o \""+pluginzip+"\" *.*",output,SW_MINIMIZE);
   if (HIWORD(rc)!=0)
   {
      Memo1->Lines->Add("Unzip Error!");
      ok = false;
   }
   if (output->Count && output->Strings[0].SubString(1,9).LowerCase()=="archive: ")
      output->Delete(0);

   // causes qsnews to run and write out version for QS 'About' checks
   if (output->Text.LowerCase().Pos("qsnews.exe"))
      Exec95(AppDir+"qsnews.exe -version");

   for (int i=0; i<output->Count; i++)
   {
      Memo1->Lines->Add(output->Strings[i]);
      Sleep(200);
   }

   TStringList *tmp = new TStringList();
   GetFilenames(tmp,thedir+"*.*");
   for (int i=0; i<tmp->Count; i++)
   {
      thefile = tmp->Strings[i].LowerCase();
      if (prev->IndexOf(thefile)<0) uninstdat->Add(thefile);
   }
   delete tmp;

   uninstdat->Add(pluginzip.LowerCase());
   if (uninstdat->Count>beforecount)
      uninstdat->SaveToFile(thedir+UninstDat);
   delete uninstdat;
   delete prev;
   return ok;
}
//---------------------------------------------------------------------------
void __fastcall TUPDunzipForm::OkBtnClick(TObject *Sender)
{
   ModalResult = ok ? mrOk : mrCancel;
}
//---------------------------------------------------------------------------
