/*
*  UrlsDlgs.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\registry.hpp>
#pragma hdrstop

#include "UrlsDlgs.h"
#include "Global.h"
#include "FileMan.h"
#include "HelpDlgs.h"
#include "pgpmail.h"
#include "cyberpunk.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TUrlsDlg *UrlsDlg;
//---------------------------------------------------------------------------
bool __fastcall ManageURLs(TForm *Owner, bool Mixmaster)
{
   UrlsDlg = new TUrlsDlg(Owner);
   UrlsDlg->PageControl1->ActivePage = Mixmaster ? UrlsDlg->TabSheet1 : UrlsDlg->TabSheet4;
   bool ok = UrlsDlg->Execute();
   delete UrlsDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TUrlsDlg::TUrlsDlg(TComponent* Owner)
  : TForm(Owner)
{
   CenterDialog(this,(TForm*)Owner); Top -= 8;
   GetAppData(Memo1->Lines,StatsURLs+PS+MListTxt); Memo1->Modified = false;
   GetAppData(Memo2->Lines,StatsURLs+PS+MRingTxt); Memo2->Modified = false;
   GetAppData(Memo3->Lines,StatsURLs+PS+MTyp2Txt); Memo3->Modified = false;
   GetAppData(Memo4->Lines,StatsURLs+PS+CListTxt); Memo4->Modified = false;
   GetAppData(Memo5->Lines,StatsURLs+PS+CRingTxt); Memo5->Modified = false;

   //if (!HasPgp() || !HasCpunk())
   //   TabSheet4->TabVisible = TabSheet5->TabVisible = false;

   Memo2->Font->Name = Memo1->Font->Name;
   Memo2->Font->Size = Memo1->Font->Size;
   Memo3->Font->Name = Memo1->Font->Name;
   Memo3->Font->Size = Memo1->Font->Size;
   Memo4->Font->Name = Memo1->Font->Name;
   Memo4->Font->Size = Memo1->Font->Size;
   Memo5->Font->Name = Memo1->Font->Name;
   Memo5->Font->Size = Memo1->Font->Size;

   PageControl1->ActivePage = TabSheet1;
   ActiveControl = Memo1;
   SavedURLs = false;
}
//---------------------------------------------------------------------------
void __fastcall TUrlsDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (!URLsModified()) return;
   if (ModalResult==mrCancel)
   {
      switch (MsgBoxHwnd(Handle,
        "Your URLs have been modified.\n\nSave your changes?","Confirm",MB_YESNOCANCEL))
      {
         case IDCANCEL: CanClose = false; break;
         case IDYES: SaveURLs(); break;
      }
      return;
   }
   SaveURLs();
}
//---------------------------------------------------------------------------
bool __fastcall TUrlsDlg::URLsModified()
{
   return Memo1->Modified||Memo2->Modified||Memo3->Modified||
      Memo4->Modified||Memo5->Modified;
}
//---------------------------------------------------------------------------
void __fastcall DumpNulls(TStrings *items)
{
}
//---------------------------------------------------------------------------
void __fastcall TUrlsDlg::SaveDocURLs(AnsiString &DocName, TStrings *URLs)
{
   int i=0; while (i<URLs->Count)
   {
      if (URLs->Strings[i].Trim().IsEmpty()) URLs->Delete(i);
      else i++;
   }
   PutAppData(StatsURLs+PS+DocName,URLs);
}
//---------------------------------------------------------------------------
bool __fastcall TUrlsDlg::Execute()
{
   ShowModal();
   return SavedURLs;
}
//---------------------------------------------------------------------------
void __fastcall TUrlsDlg::SaveURLs()
{
   if (Memo1->Modified) SaveDocURLs(MListTxt,Memo1->Lines);
   if (Memo2->Modified) SaveDocURLs(MRingTxt,Memo2->Lines);
   if (Memo3->Modified) SaveDocURLs(MTyp2Txt,Memo3->Lines);
   if (Memo4->Modified) SaveDocURLs(CListTxt,Memo4->Lines);
   if (Memo5->Modified) SaveDocURLs(CRingTxt,Memo5->Lines);
   SavedURLs = true;
}
//---------------------------------------------------------------------------
void __fastcall TUrlsDlg::PageControl1Change(TObject *Sender)
{
   SetRedraw(PageControl1,0);
   AppProcessMessages()
   if (PageControl1->ActivePage==TabSheet1) ActiveControl = Memo1; else
   if (PageControl1->ActivePage==TabSheet2) ActiveControl = Memo2; else
   if (PageControl1->ActivePage==TabSheet3) ActiveControl = Memo3; else
   if (PageControl1->ActivePage==TabSheet4) ActiveControl = Memo4; else
   if (PageControl1->ActivePage==TabSheet5) ActiveControl = Memo5;
   AppProcessMessages()
   SetRedraw(PageControl1,1);
}
//---------------------------------------------------------------------------
void __fastcall TUrlsDlg::SetDefaultUrlFromCursor(TMemo *memo)
{
   if (!memo) return;
   int idx = memo->Perform(EM_LINEFROMCHAR,(WORD)memo->SelStart,0);
   if (idx>=1 && idx<memo->Lines->Count)
   {
      memo->Lines->Insert(0,"");
      AnsiString line = memo->Lines->Strings[idx+1];
      for (int i=1; i<=line.Length(); i++)
      {
         memo->Lines->Strings[idx+1] = line.SubString(i,64);
         memo->Lines->Strings[0] = line.SubString(1,i);
         Sleep(0);
      }
      memo->Lines->Delete(idx+1);
      memo->SelStart = 0;
   }
}

//---------------------------------------------------------------------------
void __fastcall TUrlsDlg::MemoDblClick(TObject *Sender)
{
   SetDefaultUrlFromCursor(dynamic_cast<TMemo*>(Sender));
}
//---------------------------------------------------------------------------
void __fastcall TUrlsDlg::HeplBtnClick(TObject *Sender)
{
   OpenHelp("RemailerUrl","Remailer Documents URLs","URL Manager",Application->MainForm);
}
//---------------------------------------------------------------------------
