/*
*  UseLibDlg.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <dir.h>
#pragma hdrstop

#include "UseLibDlg.h"
#include "fileman.h"
#include "textwins.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TUsenetLibDlg *UsenetLibDlg;
//---------------------------------------------------------------------------
void __fastcall SaveUsenetArticle(TRichEdit *Article, TForm *Owner)
{
   UsenetLibDlg = new TUsenetLibDlg(Owner);
   UsenetLibDlg->Article = Article;
   UsenetLibDlg->ShowModal();
   delete UsenetLibDlg;
}
//---------------------------------------------------------------------------
__fastcall TUsenetLibDlg::TUsenetLibDlg(TComponent* Owner)
  : TForm(Owner)
{
   Edit1->Text = GetAppIni("UsenetLibPath","");
   Edit2->Text = GetAppIni("UsenetLibName","");
   Edit2->SelectAll();
   ActiveControl = Edit2;
}
//---------------------------------------------------------------------------
void __fastcall TUsenetLibDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (ModalResult==mrOk && Edit2->Text.IsEmpty())
   {
      CanClose = false;
      MyBeep(MB_OK);
      return;
   }
   PutAppIni("UsenetLibPath",Edit1->Text);
   PutAppIni("UsenetLibName",Edit2->Text);
   if (ModalResult==mrOk)
   {
   }
}
//---------------------------------------------------------------------------
void __fastcall TUsenetLibDlg::Edit1Change(TObject *Sender)
{
   if (DirectoryExists(Edit1->Text))
      FileListBox1->Directory = Edit1->Text;
   else
      FileListBox1->Clear();
}
//---------------------------------------------------------------------------
AnsiString __fastcall TUsenetLibDlg::FileName()
{
   if (ExtractFileExt(Edit2->Text).LowerCase()!=".txt")
      return Edit2->Text + ".txt";
   return Edit2->Text;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TUsenetLibDlg::FilePath()
{
   return AddBackslash(Edit1->Text);
}
//---------------------------------------------------------------------------
void __fastcall TUsenetLibDlg::SpeedButton2Click(TObject *Sender)
{
   try
   {
      bool save=true;
      if (FileExists(FilePath()+FileName()) && MsgBoxHwnd(Handle,
          "File "+FileName()+" already exists!\n\nOverwrite?",
          "Confirm",
          MB_OKCANCEL)==IDCANCEL)
              save = false;
      if (save)
      {
         TStringList *text = new TStringList();
         GetUnWrappedText(Article,text);
         text->SaveToFile(FilePath()+FileName());
         delete text;

         FileListBox1->Clear();
         AppProcessMessages(); Sleep(200);
         FileListBox1->Update();
         FileListBox1->ItemIndex = FileListBox1->Items->IndexOf(FileName());
      }
   }
   catch(...)
   {
      MsgBoxHwnd(Handle,
         s("Unable to save the file. I would say the problem\n")+
         s("s likely illegal characters in the filename\n"),
         s("Save File Error"),
         MB_OK
      );
   }
}
//---------------------------------------------------------------------------
void __fastcall TUsenetLibDlg::FileListBox1DblClick(TObject *Sender)
{
   if (FileListBox1->ItemIndex>=0)
      Exec95("notepad.exe "+FilePath()+
         FileListBox1->Items->Strings[FileListBox1->ItemIndex]);
}
//---------------------------------------------------------------------------
void __fastcall TUsenetLibDlg::Delete1Click(TObject *Sender)
{
   int item = FileListBox1->ItemIndex;
   AnsiString filename = FileListBox1->Items->Strings[item];
   if (item>=0 && FileExists(FilePath()+filename))
   {
      if (MsgBoxHwnd(Handle,
         "Delete "+filename+"?",
         "Confirm",
         MB_OKCANCEL)==IDOK)
      {
         FileListBox1->Clear();
         DeleteFile(s(FilePath()+filename).c_str());
         AppProcessMessages(); Sleep(100);
         FileListBox1->Update();
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TUsenetLibDlg::SpeedButton1Click(TObject *Sender)
{
   ExploreFolder(Edit1->Text);  
}
//---------------------------------------------------------------------------
