/*
*  nymmail.cpp
*  Copyright 1999-2003 by Benchmark Software
*  All Rights Reserved
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilver.skuz.net 
*
*  Richard
*  --
*  R.Christman
*  Benchmark Software
*  quicksilver@skuz.net
*  http://quicksilver.skuz.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "nymmail.h"
#include "global.h"
HINSTANCE hNymLib=NULL;
//---------------------------------------------------------------------------
bool __fastcall HasNyms()
{
   return hNymLib!=NULL;
}
//---------------------------------------------------------------------------
bool __fastcall HasActualNyms()
{
   return AppDataExists(NymProfilesKey);
}
//---------------------------------------------------------------------------
bool __fastcall IsNymDeleteMsg(TStrings *msg)
{
   bool is = false;
   for (int i=0; i<msg->Count; i++)
   {
      AnsiString cmd,line = msg->Strings[i];
      if (line.Pos("Nym-Commands: ")==1)
      {
         int c=-1; while ((cmd=GetToken(++c,line," ").LowerCase())!="")
         {
            if (cmd=="delete")
            {
               is = true;
               break;
            }
         }
      }
      if (is) break;
   }
   return is;
}
//---------------------------------------------------------------------------
bool __fastcall NymInit(HINSTANCE HMixLib, HINSTANCE HSSLLib, HWND AppHandle)
{
   NYMINIT nyminit;
   if ((nyminit = (NYMINIT)GetProcAddress(hNymLib,"@NymInit"))!=NULL)
   {
     (nyminit)(HMixLib,HSSLLib,AppHandle);
      return true;
   }
   return false;
}
//---------------------------------------------------------------------------
void __fastcall NymShutDown()
{
   NYMSHUTDOWN nymshutdown;
   if ((nymshutdown = (NYMSHUTDOWN)GetProcAddress(hNymLib,"@nymshutdown"))!=NULL)
       (nymshutdown)();
}
//---------------------------------------------------------------------------
char* __fastcall GetNymLibName()
{
   GET_NYMLIBNAME getnymlibname;
   if ((getnymlibname = (GET_NYMLIBNAME)GetProcAddress(hNymLib,"@GetNymLibName"))!=NULL)
      return (getnymlibname)();
   return "";
}
//---------------------------------------------------------------------------
char* __fastcall GetNymLibVersion()
{
   GET_NYMLIBVERSION getnymlibversion;
   if ((getnymlibversion = (GET_NYMLIBVERSION)GetProcAddress(hNymLib,"@GetNymLibVersion"))!=NULL)
      return (getnymlibversion)();
   return "";
}
//---------------------------------------------------------------------------
char*__fastcall DecryptNymMessage(TForm *Owner, char *message, int &errcode)
{
   DECRYPTNYMMESSAGE decnymmsg;
   if ((decnymmsg = (DECRYPTNYMMESSAGE)GetProcAddress(hNymLib,"@DecryptNymMessage"))!=NULL)
      return (decnymmsg)(Owner,message,errcode);
   return "";
}
//---------------------------------------------------------------------------
bool __fastcall RunNymWizard(TForm *Owner)
{
   RUNNYMWIZARD runnymwizard;
   if ((runnymwizard = (RUNNYMWIZARD)GetProcAddress(hNymLib,"@RunNymWizard"))!=NULL)
      return (runnymwizard)(Owner);
   return false;
}
//---------------------------------------------------------------------------
void __fastcall RunNymReports(TForm *Owner)
{
   RUNNYMREPORTS runnymrpts;
   if ((runnymrpts = (RUNNYMREPORTS)GetProcAddress(hNymLib,"@RunNymReports"))!=NULL)
       (runnymrpts)(Owner);
}
//---------------------------------------------------------------------------
char*__fastcall RunNymRegistry(TForm *Owner)
{
   RUNNYMREGISTRY runreg;
   if ((runreg = (RUNNYMREGISTRY)GetProcAddress(hNymLib,"@RunNymRegistry"))!=NULL)
       return (runreg)(Owner);
   return "";
}
//---------------------------------------------------------------------------
void __fastcall RunFinger(TForm *Owner)
{
   RUNFINGER runfinger;
   if ((runfinger = (RUNFINGER)GetProcAddress(hNymLib,"@RunFinger"))!=NULL)
      (runfinger)(Owner);
}
//---------------------------------------------------------------------------
bool __fastcall GetNymServers(TStrings *tostrings)
{
   AnsiString line,server,cap;
   GetAppData(tostrings,NymServersKey);
   if (!tostrings->Count) tostrings->CommaText = NymServers;
   return tostrings->Count>0;
}
//---------------------------------------------------------------------------
char*__fastcall GenerateReplyBlocks(TForm *Owner, char *Blocks, bool Preview)
{
   GENREPLYBLKS genblks;
   if ((genblks=(GENREPLYBLKS)GetProcAddress(hNymLib,"@GenerateReplyBlocks"))!=NULL)
      return (genblks)(Owner,Blocks,Preview);
   return NULL;
}
//---------------------------------------------------------------------------
bool __fastcall CreateConfigMessage(TForm *Owner, AnsiString &NymAddress,
   TStrings *Profile, TStrings *orgProfile, AnsiString &templatename, bool preview)
{
   CREATENYMCFGMSG crecfg;
   if ((crecfg=(CREATENYMCFGMSG)GetProcAddress(hNymLib,"@CreateConfigMessage"))!=NULL)
      return (crecfg)(Owner,
         NymAddress.c_str(),Profile->Text.c_str(),orgProfile->Text.c_str(),
         templatename.c_str(),
         preview);
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall CreateCommandMessage(TForm *Owner, AnsiString &NymAddress,
   TStrings *Profile, TStrings *orgProfile, AnsiString &templatename)
{
   CREATECFGMSG crecfg;
   if ((crecfg=(CREATECFGMSG)GetProcAddress(hNymLib,"@CreateCommandMessage"))!=NULL)
      return (crecfg)(Owner,
         NymAddress.c_str(),Profile->Text.c_str(),orgProfile->Text.c_str(),
         templatename.c_str());
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall CreateDeleteMessage(TForm *Owner, AnsiString &NymAddress,
   TStrings *Profile, TStrings *orgProfile, AnsiString &templatename)
{
   CREATECFGMSG crecfg;
   if ((crecfg=(CREATECFGMSG)GetProcAddress(hNymLib,"@CreateDeleteMessage"))!=NULL)
      return (crecfg)(Owner, NymAddress.c_str(),Profile->Text.c_str(),
         orgProfile->Text.c_str(), templatename.c_str());
   return false;
}
//---------------------------------------------------------------------------
bool __fastcall CreateKeyChangeMessage(TForm *Owner, AnsiString &NymAddress,
   TStrings *Profile, TStrings *orgProfile, AnsiString &templatename,
   AnsiString &newkeyid8)
{
   CREATEKEYCHNGMSG keymsg;
   if ((keymsg=(CREATEKEYCHNGMSG)GetProcAddress(hNymLib,"@CreateKeyChangeMessage"))!=NULL)
      return (keymsg)(Owner,NymAddress.c_str(),Profile->Text.c_str(),
         orgProfile->Text.c_str(),templatename.c_str(),newkeyid8.c_str());
   return false;
}
//---------------------------------------------------------------------------
char*__fastcall RunNymPGPKeyChange(TForm *Owner, char *oldkeyid)
{
   NYMKEYCHANGE keychng;
   if ((keychng=(NYMKEYCHANGE)GetProcAddress(hNymLib,"@RunNymPGPKeyChange"))!=NULL)
      return (keychng)(Owner,oldkeyid);
   return NULL;
}
//---------------------------------------------------------------------------
